// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

// Package route53recoverycluster provides the client and types for making API
// requests to Route53 Recovery Cluster.
//
// Welcome to the Amazon Route 53 Application Recovery Controller API Reference
// Guide for Recovery Control Data Plane .
//
// Recovery control in Route 53 Application Recovery Controller includes extremely
// reliable routing controls that enable you to recover applications by rerouting
// traffic, for example, across Availability Zones or AWS Regions. Routing controls
// are simple on/off switches hosted on a cluster. A cluster is a set of five
// redundant regional endpoints against which you can execute API calls to update
// or get the state of routing controls. You use routing controls to failover
// traffic to recover your application across Availability Zones or Regions.
//
// This API guide includes information about how to get and update routing control
// states in Route 53 Application Recovery Controller.
//
// For more information about Route 53 Application Recovery Controller, see
// the following:
//
//    * You can create clusters, routing controls, and control panels by using
//    the control plane API for Recovery Control. For more information, see
//    Amazon Route 53 Application Recovery Controller Recovery Control API Reference
//    (https://docs.aws.amazon.com/recovery-cluster/latest/api/).
//
//    * Route 53 Application Recovery Controller also provides continuous readiness
//    checks to ensure that your applications are scaled to handle failover
//    traffic. For more information about the related API actions, see Amazon
//    Route 53 Application Recovery Controller Recovery Readiness API Reference
//    (https://docs.aws.amazon.com/recovery-readiness/latest/api/).
//
//    * For more information about creating resilient applications and preparing
//    for recovery readiness with Route 53 Application Recovery Controller,
//    see the Amazon Route 53 Application Recovery Controller Developer Guide
//    (r53recovery/latest/dg/).
//
// See https://docs.aws.amazon.com/goto/WebAPI/route53-recovery-cluster-2019-12-02 for more information on this service.
//
// See route53recoverycluster package documentation for more information.
// https://docs.aws.amazon.com/sdk-for-go/api/service/route53recoverycluster/
//
// Using the Client
//
// To contact Route53 Recovery Cluster with the SDK use the New function to create
// a new service client. With that client you can make API requests to the service.
// These clients are safe to use concurrently.
//
// See the SDK's documentation for more information on how to use the SDK.
// https://docs.aws.amazon.com/sdk-for-go/api/
//
// See aws.Config documentation for more information on configuring SDK clients.
// https://docs.aws.amazon.com/sdk-for-go/api/aws/#Config
//
// See the Route53 Recovery Cluster client Route53RecoveryCluster for more
// information on creating client for this service.
// https://docs.aws.amazon.com/sdk-for-go/api/service/route53recoverycluster/#New
package route53recoverycluster
