// Code generated by private/model/cli/gen-api/main.go. DO NOT EDIT.

package proton

import (
	"fmt"
	"time"

	"github.com/aws/aws-sdk-go/aws"
	"github.com/aws/aws-sdk-go/aws/awsutil"
	"github.com/aws/aws-sdk-go/aws/request"
	"github.com/aws/aws-sdk-go/private/protocol"
	"github.com/aws/aws-sdk-go/private/protocol/jsonrpc"
)

const opAcceptEnvironmentAccountConnection = "AcceptEnvironmentAccountConnection"

// AcceptEnvironmentAccountConnectionRequest generates a "aws/request.Request" representing the
// client's request for the AcceptEnvironmentAccountConnection operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See AcceptEnvironmentAccountConnection for more information on using the AcceptEnvironmentAccountConnection
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the AcceptEnvironmentAccountConnectionRequest method.
//    req, resp := client.AcceptEnvironmentAccountConnectionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/AcceptEnvironmentAccountConnection
func (c *Proton) AcceptEnvironmentAccountConnectionRequest(input *AcceptEnvironmentAccountConnectionInput) (req *request.Request, output *AcceptEnvironmentAccountConnectionOutput) {
	op := &request.Operation{
		Name:       opAcceptEnvironmentAccountConnection,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &AcceptEnvironmentAccountConnectionInput{}
	}

	output = &AcceptEnvironmentAccountConnectionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// AcceptEnvironmentAccountConnection API operation for AWS Proton.
//
// In a management account, an environment account connection request is accepted.
// When the environment account connection request is accepted, AWS Proton can
// use the associated IAM role to provision environment infrastructure resources
// in the associated environment account.
//
// For more information, see Environment account connections (https://docs.aws.amazon.com/proton/latest/adminguide/ag-env-account-connections.html)
// in the AWS Proton Administrator guide.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation AcceptEnvironmentAccountConnection for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/AcceptEnvironmentAccountConnection
func (c *Proton) AcceptEnvironmentAccountConnection(input *AcceptEnvironmentAccountConnectionInput) (*AcceptEnvironmentAccountConnectionOutput, error) {
	req, out := c.AcceptEnvironmentAccountConnectionRequest(input)
	return out, req.Send()
}

// AcceptEnvironmentAccountConnectionWithContext is the same as AcceptEnvironmentAccountConnection with the addition of
// the ability to pass a context and additional request options.
//
// See AcceptEnvironmentAccountConnection for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) AcceptEnvironmentAccountConnectionWithContext(ctx aws.Context, input *AcceptEnvironmentAccountConnectionInput, opts ...request.Option) (*AcceptEnvironmentAccountConnectionOutput, error) {
	req, out := c.AcceptEnvironmentAccountConnectionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opCancelEnvironmentDeployment = "CancelEnvironmentDeployment"

// CancelEnvironmentDeploymentRequest generates a "aws/request.Request" representing the
// client's request for the CancelEnvironmentDeployment operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See CancelEnvironmentDeployment for more information on using the CancelEnvironmentDeployment
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the CancelEnvironmentDeploymentRequest method.
//    req, resp := client.CancelEnvironmentDeploymentRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CancelEnvironmentDeployment
func (c *Proton) CancelEnvironmentDeploymentRequest(input *CancelEnvironmentDeploymentInput) (req *request.Request, output *CancelEnvironmentDeploymentOutput) {
	op := &request.Operation{
		Name:       opCancelEnvironmentDeployment,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &CancelEnvironmentDeploymentInput{}
	}

	output = &CancelEnvironmentDeploymentOutput{}
	req = c.newRequest(op, input, output)
	return
}

// CancelEnvironmentDeployment API operation for AWS Proton.
//
// Attempts to cancel an environment deployment on an UpdateEnvironment action,
// if the deployment is IN_PROGRESS. For more information, see Update an environment
// (https://docs.aws.amazon.com/proton/latest/adminguide/ag-env-update.html)
// in the AWS Proton Administrator guide.
//
// The following list includes potential cancellation scenarios.
//
//    * If the cancellation attempt succeeds, the resulting deployment state
//    is CANCELLED.
//
//    * If the cancellation attempt fails, the resulting deployment state is
//    FAILED.
//
//    * If the current UpdateEnvironment action succeeds before the cancellation
//    attempt starts, the resulting deployment state is SUCCEEDED and the cancellation
//    attempt has no effect.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation CancelEnvironmentDeployment for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CancelEnvironmentDeployment
func (c *Proton) CancelEnvironmentDeployment(input *CancelEnvironmentDeploymentInput) (*CancelEnvironmentDeploymentOutput, error) {
	req, out := c.CancelEnvironmentDeploymentRequest(input)
	return out, req.Send()
}

// CancelEnvironmentDeploymentWithContext is the same as CancelEnvironmentDeployment with the addition of
// the ability to pass a context and additional request options.
//
// See CancelEnvironmentDeployment for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) CancelEnvironmentDeploymentWithContext(ctx aws.Context, input *CancelEnvironmentDeploymentInput, opts ...request.Option) (*CancelEnvironmentDeploymentOutput, error) {
	req, out := c.CancelEnvironmentDeploymentRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opCancelServiceInstanceDeployment = "CancelServiceInstanceDeployment"

// CancelServiceInstanceDeploymentRequest generates a "aws/request.Request" representing the
// client's request for the CancelServiceInstanceDeployment operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See CancelServiceInstanceDeployment for more information on using the CancelServiceInstanceDeployment
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the CancelServiceInstanceDeploymentRequest method.
//    req, resp := client.CancelServiceInstanceDeploymentRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CancelServiceInstanceDeployment
func (c *Proton) CancelServiceInstanceDeploymentRequest(input *CancelServiceInstanceDeploymentInput) (req *request.Request, output *CancelServiceInstanceDeploymentOutput) {
	op := &request.Operation{
		Name:       opCancelServiceInstanceDeployment,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &CancelServiceInstanceDeploymentInput{}
	}

	output = &CancelServiceInstanceDeploymentOutput{}
	req = c.newRequest(op, input, output)
	return
}

// CancelServiceInstanceDeployment API operation for AWS Proton.
//
// Attempts to cancel a service instance deployment on an UpdateServiceInstance
// action, if the deployment is IN_PROGRESS. For more information, see Update
// a service instance in the AWS Proton Administrator guide (https://docs.aws.amazon.com/proton/latest/adminguide/ag-svc-instance-update.html)
// or the AWS Proton User guide (https://docs.aws.amazon.com/proton/latest/userguide/ug-svc-instance-update.html).
//
// The following list includes potential cancellation scenarios.
//
//    * If the cancellation attempt succeeds, the resulting deployment state
//    is CANCELLED.
//
//    * If the cancellation attempt fails, the resulting deployment state is
//    FAILED.
//
//    * If the current UpdateServiceInstance action succeeds before the cancellation
//    attempt starts, the resulting deployment state is SUCCEEDED and the cancellation
//    attempt has no effect.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation CancelServiceInstanceDeployment for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CancelServiceInstanceDeployment
func (c *Proton) CancelServiceInstanceDeployment(input *CancelServiceInstanceDeploymentInput) (*CancelServiceInstanceDeploymentOutput, error) {
	req, out := c.CancelServiceInstanceDeploymentRequest(input)
	return out, req.Send()
}

// CancelServiceInstanceDeploymentWithContext is the same as CancelServiceInstanceDeployment with the addition of
// the ability to pass a context and additional request options.
//
// See CancelServiceInstanceDeployment for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) CancelServiceInstanceDeploymentWithContext(ctx aws.Context, input *CancelServiceInstanceDeploymentInput, opts ...request.Option) (*CancelServiceInstanceDeploymentOutput, error) {
	req, out := c.CancelServiceInstanceDeploymentRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opCancelServicePipelineDeployment = "CancelServicePipelineDeployment"

// CancelServicePipelineDeploymentRequest generates a "aws/request.Request" representing the
// client's request for the CancelServicePipelineDeployment operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See CancelServicePipelineDeployment for more information on using the CancelServicePipelineDeployment
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the CancelServicePipelineDeploymentRequest method.
//    req, resp := client.CancelServicePipelineDeploymentRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CancelServicePipelineDeployment
func (c *Proton) CancelServicePipelineDeploymentRequest(input *CancelServicePipelineDeploymentInput) (req *request.Request, output *CancelServicePipelineDeploymentOutput) {
	op := &request.Operation{
		Name:       opCancelServicePipelineDeployment,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &CancelServicePipelineDeploymentInput{}
	}

	output = &CancelServicePipelineDeploymentOutput{}
	req = c.newRequest(op, input, output)
	return
}

// CancelServicePipelineDeployment API operation for AWS Proton.
//
// Attempts to cancel a service pipeline deployment on an UpdateServicePipeline
// action, if the deployment is IN_PROGRESS. For more information, see Update
// a service pipeline in the AWS Proton Administrator guide (https://docs.aws.amazon.com/proton/latest/adminguide/ag-svc-pipeline-update.html)
// or the AWS Proton User guide (https://docs.aws.amazon.com/proton/latest/userguide/ug-svc-pipeline-update.html).
//
// The following list includes potential cancellation scenarios.
//
//    * If the cancellation attempt succeeds, the resulting deployment state
//    is CANCELLED.
//
//    * If the cancellation attempt fails, the resulting deployment state is
//    FAILED.
//
//    * If the current UpdateServicePipeline action succeeds before the cancellation
//    attempt starts, the resulting deployment state is SUCCEEDED and the cancellation
//    attempt has no effect.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation CancelServicePipelineDeployment for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CancelServicePipelineDeployment
func (c *Proton) CancelServicePipelineDeployment(input *CancelServicePipelineDeploymentInput) (*CancelServicePipelineDeploymentOutput, error) {
	req, out := c.CancelServicePipelineDeploymentRequest(input)
	return out, req.Send()
}

// CancelServicePipelineDeploymentWithContext is the same as CancelServicePipelineDeployment with the addition of
// the ability to pass a context and additional request options.
//
// See CancelServicePipelineDeployment for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) CancelServicePipelineDeploymentWithContext(ctx aws.Context, input *CancelServicePipelineDeploymentInput, opts ...request.Option) (*CancelServicePipelineDeploymentOutput, error) {
	req, out := c.CancelServicePipelineDeploymentRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opCreateEnvironment = "CreateEnvironment"

// CreateEnvironmentRequest generates a "aws/request.Request" representing the
// client's request for the CreateEnvironment operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See CreateEnvironment for more information on using the CreateEnvironment
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the CreateEnvironmentRequest method.
//    req, resp := client.CreateEnvironmentRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateEnvironment
func (c *Proton) CreateEnvironmentRequest(input *CreateEnvironmentInput) (req *request.Request, output *CreateEnvironmentOutput) {
	op := &request.Operation{
		Name:       opCreateEnvironment,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &CreateEnvironmentInput{}
	}

	output = &CreateEnvironmentOutput{}
	req = c.newRequest(op, input, output)
	return
}

// CreateEnvironment API operation for AWS Proton.
//
// Deploy a new environment. An AWS Proton environment is created from an environment
// template that defines infrastructure and resources that can be shared across
// services. For more information, see the Environments (https://docs.aws.amazon.com/proton/latest/adminguide/ag-environments.html)
// in the AWS Proton Administrator Guide.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation CreateEnvironment for usage and error information.
//
// Returned Error Types:
//   * ServiceQuotaExceededException
//   A quota was exceeded. For more information, see AWS Proton Quotas (https://docs.aws.amazon.com/proton/latest/adminguide/ag-limits.html)
//   in the AWS Proton Administrator Guide.
//
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateEnvironment
func (c *Proton) CreateEnvironment(input *CreateEnvironmentInput) (*CreateEnvironmentOutput, error) {
	req, out := c.CreateEnvironmentRequest(input)
	return out, req.Send()
}

// CreateEnvironmentWithContext is the same as CreateEnvironment with the addition of
// the ability to pass a context and additional request options.
//
// See CreateEnvironment for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) CreateEnvironmentWithContext(ctx aws.Context, input *CreateEnvironmentInput, opts ...request.Option) (*CreateEnvironmentOutput, error) {
	req, out := c.CreateEnvironmentRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opCreateEnvironmentAccountConnection = "CreateEnvironmentAccountConnection"

// CreateEnvironmentAccountConnectionRequest generates a "aws/request.Request" representing the
// client's request for the CreateEnvironmentAccountConnection operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See CreateEnvironmentAccountConnection for more information on using the CreateEnvironmentAccountConnection
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the CreateEnvironmentAccountConnectionRequest method.
//    req, resp := client.CreateEnvironmentAccountConnectionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateEnvironmentAccountConnection
func (c *Proton) CreateEnvironmentAccountConnectionRequest(input *CreateEnvironmentAccountConnectionInput) (req *request.Request, output *CreateEnvironmentAccountConnectionOutput) {
	op := &request.Operation{
		Name:       opCreateEnvironmentAccountConnection,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &CreateEnvironmentAccountConnectionInput{}
	}

	output = &CreateEnvironmentAccountConnectionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// CreateEnvironmentAccountConnection API operation for AWS Proton.
//
// Create an environment account connection in an environment account so that
// environment infrastructure resources can be provisioned in the environment
// account from a management account.
//
// An environment account connection is a secure bi-directional connection between
// a management account and an environment account that maintains authorization
// and permissions. For more information, see Environment account connections
// (https://docs.aws.amazon.com/proton/latest/adminguide/ag-env-account-connections.html)
// in the AWS Proton Administrator guide.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation CreateEnvironmentAccountConnection for usage and error information.
//
// Returned Error Types:
//   * ServiceQuotaExceededException
//   A quota was exceeded. For more information, see AWS Proton Quotas (https://docs.aws.amazon.com/proton/latest/adminguide/ag-limits.html)
//   in the AWS Proton Administrator Guide.
//
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateEnvironmentAccountConnection
func (c *Proton) CreateEnvironmentAccountConnection(input *CreateEnvironmentAccountConnectionInput) (*CreateEnvironmentAccountConnectionOutput, error) {
	req, out := c.CreateEnvironmentAccountConnectionRequest(input)
	return out, req.Send()
}

// CreateEnvironmentAccountConnectionWithContext is the same as CreateEnvironmentAccountConnection with the addition of
// the ability to pass a context and additional request options.
//
// See CreateEnvironmentAccountConnection for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) CreateEnvironmentAccountConnectionWithContext(ctx aws.Context, input *CreateEnvironmentAccountConnectionInput, opts ...request.Option) (*CreateEnvironmentAccountConnectionOutput, error) {
	req, out := c.CreateEnvironmentAccountConnectionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opCreateEnvironmentTemplate = "CreateEnvironmentTemplate"

// CreateEnvironmentTemplateRequest generates a "aws/request.Request" representing the
// client's request for the CreateEnvironmentTemplate operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See CreateEnvironmentTemplate for more information on using the CreateEnvironmentTemplate
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the CreateEnvironmentTemplateRequest method.
//    req, resp := client.CreateEnvironmentTemplateRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateEnvironmentTemplate
func (c *Proton) CreateEnvironmentTemplateRequest(input *CreateEnvironmentTemplateInput) (req *request.Request, output *CreateEnvironmentTemplateOutput) {
	op := &request.Operation{
		Name:       opCreateEnvironmentTemplate,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &CreateEnvironmentTemplateInput{}
	}

	output = &CreateEnvironmentTemplateOutput{}
	req = c.newRequest(op, input, output)
	return
}

// CreateEnvironmentTemplate API operation for AWS Proton.
//
// Create an environment template for AWS Proton. For more information, see
// Environment Templates (https://docs.aws.amazon.com/proton/latest/adminguide/ag-templates.html)
// in the AWS Proton Administrator Guide.
//
// You can create an environment template in one of the two following ways:
//
//    * Register and publish a standard environment template that instructs
//    AWS Proton to deploy and manage environment infrastructure.
//
//    * Register and publish a customer managed environment template that connects
//    AWS Proton to your existing provisioned infrastructure that you manage.
//    AWS Proton doesn't manage your existing provisioned infrastructure. To
//    create an environment template for customer provisioned and managed infrastructure,
//    include the provisioning parameter and set the value to CUSTOMER_MANAGED.
//    For more information, see Register and publish an environment template
//    (https://docs.aws.amazon.com/proton/latest/adminguide/template-create.html)
//    in the AWS Proton Administrator Guide.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation CreateEnvironmentTemplate for usage and error information.
//
// Returned Error Types:
//   * ServiceQuotaExceededException
//   A quota was exceeded. For more information, see AWS Proton Quotas (https://docs.aws.amazon.com/proton/latest/adminguide/ag-limits.html)
//   in the AWS Proton Administrator Guide.
//
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateEnvironmentTemplate
func (c *Proton) CreateEnvironmentTemplate(input *CreateEnvironmentTemplateInput) (*CreateEnvironmentTemplateOutput, error) {
	req, out := c.CreateEnvironmentTemplateRequest(input)
	return out, req.Send()
}

// CreateEnvironmentTemplateWithContext is the same as CreateEnvironmentTemplate with the addition of
// the ability to pass a context and additional request options.
//
// See CreateEnvironmentTemplate for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) CreateEnvironmentTemplateWithContext(ctx aws.Context, input *CreateEnvironmentTemplateInput, opts ...request.Option) (*CreateEnvironmentTemplateOutput, error) {
	req, out := c.CreateEnvironmentTemplateRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opCreateEnvironmentTemplateVersion = "CreateEnvironmentTemplateVersion"

// CreateEnvironmentTemplateVersionRequest generates a "aws/request.Request" representing the
// client's request for the CreateEnvironmentTemplateVersion operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See CreateEnvironmentTemplateVersion for more information on using the CreateEnvironmentTemplateVersion
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the CreateEnvironmentTemplateVersionRequest method.
//    req, resp := client.CreateEnvironmentTemplateVersionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateEnvironmentTemplateVersion
func (c *Proton) CreateEnvironmentTemplateVersionRequest(input *CreateEnvironmentTemplateVersionInput) (req *request.Request, output *CreateEnvironmentTemplateVersionOutput) {
	op := &request.Operation{
		Name:       opCreateEnvironmentTemplateVersion,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &CreateEnvironmentTemplateVersionInput{}
	}

	output = &CreateEnvironmentTemplateVersionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// CreateEnvironmentTemplateVersion API operation for AWS Proton.
//
// Create a new major or minor version of an environment template. A major version
// of an environment template is a version that isn't backwards compatible.
// A minor version of an environment template is a version that's backwards
// compatible within its major version.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation CreateEnvironmentTemplateVersion for usage and error information.
//
// Returned Error Types:
//   * ServiceQuotaExceededException
//   A quota was exceeded. For more information, see AWS Proton Quotas (https://docs.aws.amazon.com/proton/latest/adminguide/ag-limits.html)
//   in the AWS Proton Administrator Guide.
//
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateEnvironmentTemplateVersion
func (c *Proton) CreateEnvironmentTemplateVersion(input *CreateEnvironmentTemplateVersionInput) (*CreateEnvironmentTemplateVersionOutput, error) {
	req, out := c.CreateEnvironmentTemplateVersionRequest(input)
	return out, req.Send()
}

// CreateEnvironmentTemplateVersionWithContext is the same as CreateEnvironmentTemplateVersion with the addition of
// the ability to pass a context and additional request options.
//
// See CreateEnvironmentTemplateVersion for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) CreateEnvironmentTemplateVersionWithContext(ctx aws.Context, input *CreateEnvironmentTemplateVersionInput, opts ...request.Option) (*CreateEnvironmentTemplateVersionOutput, error) {
	req, out := c.CreateEnvironmentTemplateVersionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opCreateService = "CreateService"

// CreateServiceRequest generates a "aws/request.Request" representing the
// client's request for the CreateService operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See CreateService for more information on using the CreateService
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the CreateServiceRequest method.
//    req, resp := client.CreateServiceRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateService
func (c *Proton) CreateServiceRequest(input *CreateServiceInput) (req *request.Request, output *CreateServiceOutput) {
	op := &request.Operation{
		Name:       opCreateService,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &CreateServiceInput{}
	}

	output = &CreateServiceOutput{}
	req = c.newRequest(op, input, output)
	return
}

// CreateService API operation for AWS Proton.
//
// Create an AWS Proton service. An AWS Proton service is an instantiation of
// a service template and often includes several service instances and pipeline.
// For more information, see Services (https://docs.aws.amazon.com/proton/latest/adminguide/ag-services.html)
// in the AWS Proton Administrator Guide and Services (https://docs.aws.amazon.com/proton/latest/userguide/ug-service.html)
// in the AWS Proton User Guide.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation CreateService for usage and error information.
//
// Returned Error Types:
//   * ServiceQuotaExceededException
//   A quota was exceeded. For more information, see AWS Proton Quotas (https://docs.aws.amazon.com/proton/latest/adminguide/ag-limits.html)
//   in the AWS Proton Administrator Guide.
//
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateService
func (c *Proton) CreateService(input *CreateServiceInput) (*CreateServiceOutput, error) {
	req, out := c.CreateServiceRequest(input)
	return out, req.Send()
}

// CreateServiceWithContext is the same as CreateService with the addition of
// the ability to pass a context and additional request options.
//
// See CreateService for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) CreateServiceWithContext(ctx aws.Context, input *CreateServiceInput, opts ...request.Option) (*CreateServiceOutput, error) {
	req, out := c.CreateServiceRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opCreateServiceTemplate = "CreateServiceTemplate"

// CreateServiceTemplateRequest generates a "aws/request.Request" representing the
// client's request for the CreateServiceTemplate operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See CreateServiceTemplate for more information on using the CreateServiceTemplate
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the CreateServiceTemplateRequest method.
//    req, resp := client.CreateServiceTemplateRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateServiceTemplate
func (c *Proton) CreateServiceTemplateRequest(input *CreateServiceTemplateInput) (req *request.Request, output *CreateServiceTemplateOutput) {
	op := &request.Operation{
		Name:       opCreateServiceTemplate,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &CreateServiceTemplateInput{}
	}

	output = &CreateServiceTemplateOutput{}
	req = c.newRequest(op, input, output)
	return
}

// CreateServiceTemplate API operation for AWS Proton.
//
// Create a service template. The administrator creates a service template to
// define standardized infrastructure and an optional CICD service pipeline.
// Developers, in turn, select the service template from AWS Proton. If the
// selected service template includes a service pipeline definition, they provide
// a link to their source code repository. AWS Proton then deploys and manages
// the infrastructure defined by the selected service template. For more information,
// see Service Templates (https://docs.aws.amazon.com/proton/latest/adminguide/managing-svc-templates.html)
// in the AWS Proton Administrator Guide.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation CreateServiceTemplate for usage and error information.
//
// Returned Error Types:
//   * ServiceQuotaExceededException
//   A quota was exceeded. For more information, see AWS Proton Quotas (https://docs.aws.amazon.com/proton/latest/adminguide/ag-limits.html)
//   in the AWS Proton Administrator Guide.
//
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateServiceTemplate
func (c *Proton) CreateServiceTemplate(input *CreateServiceTemplateInput) (*CreateServiceTemplateOutput, error) {
	req, out := c.CreateServiceTemplateRequest(input)
	return out, req.Send()
}

// CreateServiceTemplateWithContext is the same as CreateServiceTemplate with the addition of
// the ability to pass a context and additional request options.
//
// See CreateServiceTemplate for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) CreateServiceTemplateWithContext(ctx aws.Context, input *CreateServiceTemplateInput, opts ...request.Option) (*CreateServiceTemplateOutput, error) {
	req, out := c.CreateServiceTemplateRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opCreateServiceTemplateVersion = "CreateServiceTemplateVersion"

// CreateServiceTemplateVersionRequest generates a "aws/request.Request" representing the
// client's request for the CreateServiceTemplateVersion operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See CreateServiceTemplateVersion for more information on using the CreateServiceTemplateVersion
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the CreateServiceTemplateVersionRequest method.
//    req, resp := client.CreateServiceTemplateVersionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateServiceTemplateVersion
func (c *Proton) CreateServiceTemplateVersionRequest(input *CreateServiceTemplateVersionInput) (req *request.Request, output *CreateServiceTemplateVersionOutput) {
	op := &request.Operation{
		Name:       opCreateServiceTemplateVersion,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &CreateServiceTemplateVersionInput{}
	}

	output = &CreateServiceTemplateVersionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// CreateServiceTemplateVersion API operation for AWS Proton.
//
// Create a new major or minor version of a service template. A major version
// of a service template is a version that isn't backwards compatible. A minor
// version of a service template is a version that's backwards compatible within
// its major version.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation CreateServiceTemplateVersion for usage and error information.
//
// Returned Error Types:
//   * ServiceQuotaExceededException
//   A quota was exceeded. For more information, see AWS Proton Quotas (https://docs.aws.amazon.com/proton/latest/adminguide/ag-limits.html)
//   in the AWS Proton Administrator Guide.
//
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/CreateServiceTemplateVersion
func (c *Proton) CreateServiceTemplateVersion(input *CreateServiceTemplateVersionInput) (*CreateServiceTemplateVersionOutput, error) {
	req, out := c.CreateServiceTemplateVersionRequest(input)
	return out, req.Send()
}

// CreateServiceTemplateVersionWithContext is the same as CreateServiceTemplateVersion with the addition of
// the ability to pass a context and additional request options.
//
// See CreateServiceTemplateVersion for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) CreateServiceTemplateVersionWithContext(ctx aws.Context, input *CreateServiceTemplateVersionInput, opts ...request.Option) (*CreateServiceTemplateVersionOutput, error) {
	req, out := c.CreateServiceTemplateVersionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opDeleteEnvironment = "DeleteEnvironment"

// DeleteEnvironmentRequest generates a "aws/request.Request" representing the
// client's request for the DeleteEnvironment operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See DeleteEnvironment for more information on using the DeleteEnvironment
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the DeleteEnvironmentRequest method.
//    req, resp := client.DeleteEnvironmentRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteEnvironment
func (c *Proton) DeleteEnvironmentRequest(input *DeleteEnvironmentInput) (req *request.Request, output *DeleteEnvironmentOutput) {
	op := &request.Operation{
		Name:       opDeleteEnvironment,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &DeleteEnvironmentInput{}
	}

	output = &DeleteEnvironmentOutput{}
	req = c.newRequest(op, input, output)
	return
}

// DeleteEnvironment API operation for AWS Proton.
//
// Delete an environment.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation DeleteEnvironment for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteEnvironment
func (c *Proton) DeleteEnvironment(input *DeleteEnvironmentInput) (*DeleteEnvironmentOutput, error) {
	req, out := c.DeleteEnvironmentRequest(input)
	return out, req.Send()
}

// DeleteEnvironmentWithContext is the same as DeleteEnvironment with the addition of
// the ability to pass a context and additional request options.
//
// See DeleteEnvironment for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) DeleteEnvironmentWithContext(ctx aws.Context, input *DeleteEnvironmentInput, opts ...request.Option) (*DeleteEnvironmentOutput, error) {
	req, out := c.DeleteEnvironmentRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opDeleteEnvironmentAccountConnection = "DeleteEnvironmentAccountConnection"

// DeleteEnvironmentAccountConnectionRequest generates a "aws/request.Request" representing the
// client's request for the DeleteEnvironmentAccountConnection operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See DeleteEnvironmentAccountConnection for more information on using the DeleteEnvironmentAccountConnection
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the DeleteEnvironmentAccountConnectionRequest method.
//    req, resp := client.DeleteEnvironmentAccountConnectionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteEnvironmentAccountConnection
func (c *Proton) DeleteEnvironmentAccountConnectionRequest(input *DeleteEnvironmentAccountConnectionInput) (req *request.Request, output *DeleteEnvironmentAccountConnectionOutput) {
	op := &request.Operation{
		Name:       opDeleteEnvironmentAccountConnection,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &DeleteEnvironmentAccountConnectionInput{}
	}

	output = &DeleteEnvironmentAccountConnectionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// DeleteEnvironmentAccountConnection API operation for AWS Proton.
//
// In an environment account, delete an environment account connection.
//
// After you delete an environment account connection that’s in use by an
// AWS Proton environment, AWS Proton can’t manage the environment infrastructure
// resources until a new environment account connection is accepted for the
// environment account and associated environment. You're responsible for cleaning
// up provisioned resources that remain without an environment connection.
//
// For more information, see Environment account connections (https://docs.aws.amazon.com/proton/latest/adminguide/ag-env-account-connections.html)
// in the AWS Proton Administrator guide.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation DeleteEnvironmentAccountConnection for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteEnvironmentAccountConnection
func (c *Proton) DeleteEnvironmentAccountConnection(input *DeleteEnvironmentAccountConnectionInput) (*DeleteEnvironmentAccountConnectionOutput, error) {
	req, out := c.DeleteEnvironmentAccountConnectionRequest(input)
	return out, req.Send()
}

// DeleteEnvironmentAccountConnectionWithContext is the same as DeleteEnvironmentAccountConnection with the addition of
// the ability to pass a context and additional request options.
//
// See DeleteEnvironmentAccountConnection for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) DeleteEnvironmentAccountConnectionWithContext(ctx aws.Context, input *DeleteEnvironmentAccountConnectionInput, opts ...request.Option) (*DeleteEnvironmentAccountConnectionOutput, error) {
	req, out := c.DeleteEnvironmentAccountConnectionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opDeleteEnvironmentTemplate = "DeleteEnvironmentTemplate"

// DeleteEnvironmentTemplateRequest generates a "aws/request.Request" representing the
// client's request for the DeleteEnvironmentTemplate operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See DeleteEnvironmentTemplate for more information on using the DeleteEnvironmentTemplate
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the DeleteEnvironmentTemplateRequest method.
//    req, resp := client.DeleteEnvironmentTemplateRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteEnvironmentTemplate
func (c *Proton) DeleteEnvironmentTemplateRequest(input *DeleteEnvironmentTemplateInput) (req *request.Request, output *DeleteEnvironmentTemplateOutput) {
	op := &request.Operation{
		Name:       opDeleteEnvironmentTemplate,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &DeleteEnvironmentTemplateInput{}
	}

	output = &DeleteEnvironmentTemplateOutput{}
	req = c.newRequest(op, input, output)
	return
}

// DeleteEnvironmentTemplate API operation for AWS Proton.
//
// If no other major or minor versions of an environment template exist, delete
// the environment template.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation DeleteEnvironmentTemplate for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteEnvironmentTemplate
func (c *Proton) DeleteEnvironmentTemplate(input *DeleteEnvironmentTemplateInput) (*DeleteEnvironmentTemplateOutput, error) {
	req, out := c.DeleteEnvironmentTemplateRequest(input)
	return out, req.Send()
}

// DeleteEnvironmentTemplateWithContext is the same as DeleteEnvironmentTemplate with the addition of
// the ability to pass a context and additional request options.
//
// See DeleteEnvironmentTemplate for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) DeleteEnvironmentTemplateWithContext(ctx aws.Context, input *DeleteEnvironmentTemplateInput, opts ...request.Option) (*DeleteEnvironmentTemplateOutput, error) {
	req, out := c.DeleteEnvironmentTemplateRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opDeleteEnvironmentTemplateVersion = "DeleteEnvironmentTemplateVersion"

// DeleteEnvironmentTemplateVersionRequest generates a "aws/request.Request" representing the
// client's request for the DeleteEnvironmentTemplateVersion operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See DeleteEnvironmentTemplateVersion for more information on using the DeleteEnvironmentTemplateVersion
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the DeleteEnvironmentTemplateVersionRequest method.
//    req, resp := client.DeleteEnvironmentTemplateVersionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteEnvironmentTemplateVersion
func (c *Proton) DeleteEnvironmentTemplateVersionRequest(input *DeleteEnvironmentTemplateVersionInput) (req *request.Request, output *DeleteEnvironmentTemplateVersionOutput) {
	op := &request.Operation{
		Name:       opDeleteEnvironmentTemplateVersion,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &DeleteEnvironmentTemplateVersionInput{}
	}

	output = &DeleteEnvironmentTemplateVersionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// DeleteEnvironmentTemplateVersion API operation for AWS Proton.
//
// If no other minor versions of an environment template exist, delete a major
// version of the environment template if it's not the Recommended version.
// Delete the Recommended version of the environment template if no other major
// versions or minor versions of the environment template exist. A major version
// of an environment template is a version that's not backwards compatible.
//
// Delete a minor version of an environment template if it isn't the Recommended
// version. Delete a Recommended minor version of the environment template if
// no other minor versions of the environment template exist. A minor version
// of an environment template is a version that's backwards compatible.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation DeleteEnvironmentTemplateVersion for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteEnvironmentTemplateVersion
func (c *Proton) DeleteEnvironmentTemplateVersion(input *DeleteEnvironmentTemplateVersionInput) (*DeleteEnvironmentTemplateVersionOutput, error) {
	req, out := c.DeleteEnvironmentTemplateVersionRequest(input)
	return out, req.Send()
}

// DeleteEnvironmentTemplateVersionWithContext is the same as DeleteEnvironmentTemplateVersion with the addition of
// the ability to pass a context and additional request options.
//
// See DeleteEnvironmentTemplateVersion for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) DeleteEnvironmentTemplateVersionWithContext(ctx aws.Context, input *DeleteEnvironmentTemplateVersionInput, opts ...request.Option) (*DeleteEnvironmentTemplateVersionOutput, error) {
	req, out := c.DeleteEnvironmentTemplateVersionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opDeleteService = "DeleteService"

// DeleteServiceRequest generates a "aws/request.Request" representing the
// client's request for the DeleteService operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See DeleteService for more information on using the DeleteService
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the DeleteServiceRequest method.
//    req, resp := client.DeleteServiceRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteService
func (c *Proton) DeleteServiceRequest(input *DeleteServiceInput) (req *request.Request, output *DeleteServiceOutput) {
	op := &request.Operation{
		Name:       opDeleteService,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &DeleteServiceInput{}
	}

	output = &DeleteServiceOutput{}
	req = c.newRequest(op, input, output)
	return
}

// DeleteService API operation for AWS Proton.
//
// Delete a service.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation DeleteService for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteService
func (c *Proton) DeleteService(input *DeleteServiceInput) (*DeleteServiceOutput, error) {
	req, out := c.DeleteServiceRequest(input)
	return out, req.Send()
}

// DeleteServiceWithContext is the same as DeleteService with the addition of
// the ability to pass a context and additional request options.
//
// See DeleteService for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) DeleteServiceWithContext(ctx aws.Context, input *DeleteServiceInput, opts ...request.Option) (*DeleteServiceOutput, error) {
	req, out := c.DeleteServiceRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opDeleteServiceTemplate = "DeleteServiceTemplate"

// DeleteServiceTemplateRequest generates a "aws/request.Request" representing the
// client's request for the DeleteServiceTemplate operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See DeleteServiceTemplate for more information on using the DeleteServiceTemplate
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the DeleteServiceTemplateRequest method.
//    req, resp := client.DeleteServiceTemplateRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteServiceTemplate
func (c *Proton) DeleteServiceTemplateRequest(input *DeleteServiceTemplateInput) (req *request.Request, output *DeleteServiceTemplateOutput) {
	op := &request.Operation{
		Name:       opDeleteServiceTemplate,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &DeleteServiceTemplateInput{}
	}

	output = &DeleteServiceTemplateOutput{}
	req = c.newRequest(op, input, output)
	return
}

// DeleteServiceTemplate API operation for AWS Proton.
//
// If no other major or minor versions of the service template exist, delete
// the service template.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation DeleteServiceTemplate for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteServiceTemplate
func (c *Proton) DeleteServiceTemplate(input *DeleteServiceTemplateInput) (*DeleteServiceTemplateOutput, error) {
	req, out := c.DeleteServiceTemplateRequest(input)
	return out, req.Send()
}

// DeleteServiceTemplateWithContext is the same as DeleteServiceTemplate with the addition of
// the ability to pass a context and additional request options.
//
// See DeleteServiceTemplate for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) DeleteServiceTemplateWithContext(ctx aws.Context, input *DeleteServiceTemplateInput, opts ...request.Option) (*DeleteServiceTemplateOutput, error) {
	req, out := c.DeleteServiceTemplateRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opDeleteServiceTemplateVersion = "DeleteServiceTemplateVersion"

// DeleteServiceTemplateVersionRequest generates a "aws/request.Request" representing the
// client's request for the DeleteServiceTemplateVersion operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See DeleteServiceTemplateVersion for more information on using the DeleteServiceTemplateVersion
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the DeleteServiceTemplateVersionRequest method.
//    req, resp := client.DeleteServiceTemplateVersionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteServiceTemplateVersion
func (c *Proton) DeleteServiceTemplateVersionRequest(input *DeleteServiceTemplateVersionInput) (req *request.Request, output *DeleteServiceTemplateVersionOutput) {
	op := &request.Operation{
		Name:       opDeleteServiceTemplateVersion,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &DeleteServiceTemplateVersionInput{}
	}

	output = &DeleteServiceTemplateVersionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// DeleteServiceTemplateVersion API operation for AWS Proton.
//
// If no other minor versions of a service template exist, delete a major version
// of the service template if it's not the Recommended version. Delete the Recommended
// version of the service template if no other major versions or minor versions
// of the service template exist. A major version of a service template is a
// version that isn't backwards compatible.
//
// Delete a minor version of a service template if it's not the Recommended
// version. Delete a Recommended minor version of the service template if no
// other minor versions of the service template exist. A minor version of a
// service template is a version that's backwards compatible.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation DeleteServiceTemplateVersion for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/DeleteServiceTemplateVersion
func (c *Proton) DeleteServiceTemplateVersion(input *DeleteServiceTemplateVersionInput) (*DeleteServiceTemplateVersionOutput, error) {
	req, out := c.DeleteServiceTemplateVersionRequest(input)
	return out, req.Send()
}

// DeleteServiceTemplateVersionWithContext is the same as DeleteServiceTemplateVersion with the addition of
// the ability to pass a context and additional request options.
//
// See DeleteServiceTemplateVersion for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) DeleteServiceTemplateVersionWithContext(ctx aws.Context, input *DeleteServiceTemplateVersionInput, opts ...request.Option) (*DeleteServiceTemplateVersionOutput, error) {
	req, out := c.DeleteServiceTemplateVersionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opGetAccountSettings = "GetAccountSettings"

// GetAccountSettingsRequest generates a "aws/request.Request" representing the
// client's request for the GetAccountSettings operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See GetAccountSettings for more information on using the GetAccountSettings
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the GetAccountSettingsRequest method.
//    req, resp := client.GetAccountSettingsRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetAccountSettings
func (c *Proton) GetAccountSettingsRequest(input *GetAccountSettingsInput) (req *request.Request, output *GetAccountSettingsOutput) {
	op := &request.Operation{
		Name:       opGetAccountSettings,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &GetAccountSettingsInput{}
	}

	output = &GetAccountSettingsOutput{}
	req = c.newRequest(op, input, output)
	return
}

// GetAccountSettings API operation for AWS Proton.
//
// Get detail data for the AWS Proton pipeline service role.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation GetAccountSettings for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetAccountSettings
func (c *Proton) GetAccountSettings(input *GetAccountSettingsInput) (*GetAccountSettingsOutput, error) {
	req, out := c.GetAccountSettingsRequest(input)
	return out, req.Send()
}

// GetAccountSettingsWithContext is the same as GetAccountSettings with the addition of
// the ability to pass a context and additional request options.
//
// See GetAccountSettings for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) GetAccountSettingsWithContext(ctx aws.Context, input *GetAccountSettingsInput, opts ...request.Option) (*GetAccountSettingsOutput, error) {
	req, out := c.GetAccountSettingsRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opGetEnvironment = "GetEnvironment"

// GetEnvironmentRequest generates a "aws/request.Request" representing the
// client's request for the GetEnvironment operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See GetEnvironment for more information on using the GetEnvironment
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the GetEnvironmentRequest method.
//    req, resp := client.GetEnvironmentRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetEnvironment
func (c *Proton) GetEnvironmentRequest(input *GetEnvironmentInput) (req *request.Request, output *GetEnvironmentOutput) {
	op := &request.Operation{
		Name:       opGetEnvironment,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &GetEnvironmentInput{}
	}

	output = &GetEnvironmentOutput{}
	req = c.newRequest(op, input, output)
	return
}

// GetEnvironment API operation for AWS Proton.
//
// Get detail data for an environment.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation GetEnvironment for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetEnvironment
func (c *Proton) GetEnvironment(input *GetEnvironmentInput) (*GetEnvironmentOutput, error) {
	req, out := c.GetEnvironmentRequest(input)
	return out, req.Send()
}

// GetEnvironmentWithContext is the same as GetEnvironment with the addition of
// the ability to pass a context and additional request options.
//
// See GetEnvironment for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) GetEnvironmentWithContext(ctx aws.Context, input *GetEnvironmentInput, opts ...request.Option) (*GetEnvironmentOutput, error) {
	req, out := c.GetEnvironmentRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opGetEnvironmentAccountConnection = "GetEnvironmentAccountConnection"

// GetEnvironmentAccountConnectionRequest generates a "aws/request.Request" representing the
// client's request for the GetEnvironmentAccountConnection operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See GetEnvironmentAccountConnection for more information on using the GetEnvironmentAccountConnection
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the GetEnvironmentAccountConnectionRequest method.
//    req, resp := client.GetEnvironmentAccountConnectionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetEnvironmentAccountConnection
func (c *Proton) GetEnvironmentAccountConnectionRequest(input *GetEnvironmentAccountConnectionInput) (req *request.Request, output *GetEnvironmentAccountConnectionOutput) {
	op := &request.Operation{
		Name:       opGetEnvironmentAccountConnection,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &GetEnvironmentAccountConnectionInput{}
	}

	output = &GetEnvironmentAccountConnectionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// GetEnvironmentAccountConnection API operation for AWS Proton.
//
// In an environment account, view the detail data for an environment account
// connection.
//
// For more information, see Environment account connections (https://docs.aws.amazon.com/proton/latest/adminguide/ag-env-account-connections.html)
// in the AWS Proton Administrator guide.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation GetEnvironmentAccountConnection for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetEnvironmentAccountConnection
func (c *Proton) GetEnvironmentAccountConnection(input *GetEnvironmentAccountConnectionInput) (*GetEnvironmentAccountConnectionOutput, error) {
	req, out := c.GetEnvironmentAccountConnectionRequest(input)
	return out, req.Send()
}

// GetEnvironmentAccountConnectionWithContext is the same as GetEnvironmentAccountConnection with the addition of
// the ability to pass a context and additional request options.
//
// See GetEnvironmentAccountConnection for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) GetEnvironmentAccountConnectionWithContext(ctx aws.Context, input *GetEnvironmentAccountConnectionInput, opts ...request.Option) (*GetEnvironmentAccountConnectionOutput, error) {
	req, out := c.GetEnvironmentAccountConnectionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opGetEnvironmentTemplate = "GetEnvironmentTemplate"

// GetEnvironmentTemplateRequest generates a "aws/request.Request" representing the
// client's request for the GetEnvironmentTemplate operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See GetEnvironmentTemplate for more information on using the GetEnvironmentTemplate
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the GetEnvironmentTemplateRequest method.
//    req, resp := client.GetEnvironmentTemplateRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetEnvironmentTemplate
func (c *Proton) GetEnvironmentTemplateRequest(input *GetEnvironmentTemplateInput) (req *request.Request, output *GetEnvironmentTemplateOutput) {
	op := &request.Operation{
		Name:       opGetEnvironmentTemplate,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &GetEnvironmentTemplateInput{}
	}

	output = &GetEnvironmentTemplateOutput{}
	req = c.newRequest(op, input, output)
	return
}

// GetEnvironmentTemplate API operation for AWS Proton.
//
// Get detail data for an environment template.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation GetEnvironmentTemplate for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetEnvironmentTemplate
func (c *Proton) GetEnvironmentTemplate(input *GetEnvironmentTemplateInput) (*GetEnvironmentTemplateOutput, error) {
	req, out := c.GetEnvironmentTemplateRequest(input)
	return out, req.Send()
}

// GetEnvironmentTemplateWithContext is the same as GetEnvironmentTemplate with the addition of
// the ability to pass a context and additional request options.
//
// See GetEnvironmentTemplate for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) GetEnvironmentTemplateWithContext(ctx aws.Context, input *GetEnvironmentTemplateInput, opts ...request.Option) (*GetEnvironmentTemplateOutput, error) {
	req, out := c.GetEnvironmentTemplateRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opGetEnvironmentTemplateVersion = "GetEnvironmentTemplateVersion"

// GetEnvironmentTemplateVersionRequest generates a "aws/request.Request" representing the
// client's request for the GetEnvironmentTemplateVersion operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See GetEnvironmentTemplateVersion for more information on using the GetEnvironmentTemplateVersion
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the GetEnvironmentTemplateVersionRequest method.
//    req, resp := client.GetEnvironmentTemplateVersionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetEnvironmentTemplateVersion
func (c *Proton) GetEnvironmentTemplateVersionRequest(input *GetEnvironmentTemplateVersionInput) (req *request.Request, output *GetEnvironmentTemplateVersionOutput) {
	op := &request.Operation{
		Name:       opGetEnvironmentTemplateVersion,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &GetEnvironmentTemplateVersionInput{}
	}

	output = &GetEnvironmentTemplateVersionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// GetEnvironmentTemplateVersion API operation for AWS Proton.
//
// View detail data for a major or minor version of an environment template.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation GetEnvironmentTemplateVersion for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetEnvironmentTemplateVersion
func (c *Proton) GetEnvironmentTemplateVersion(input *GetEnvironmentTemplateVersionInput) (*GetEnvironmentTemplateVersionOutput, error) {
	req, out := c.GetEnvironmentTemplateVersionRequest(input)
	return out, req.Send()
}

// GetEnvironmentTemplateVersionWithContext is the same as GetEnvironmentTemplateVersion with the addition of
// the ability to pass a context and additional request options.
//
// See GetEnvironmentTemplateVersion for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) GetEnvironmentTemplateVersionWithContext(ctx aws.Context, input *GetEnvironmentTemplateVersionInput, opts ...request.Option) (*GetEnvironmentTemplateVersionOutput, error) {
	req, out := c.GetEnvironmentTemplateVersionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opGetService = "GetService"

// GetServiceRequest generates a "aws/request.Request" representing the
// client's request for the GetService operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See GetService for more information on using the GetService
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the GetServiceRequest method.
//    req, resp := client.GetServiceRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetService
func (c *Proton) GetServiceRequest(input *GetServiceInput) (req *request.Request, output *GetServiceOutput) {
	op := &request.Operation{
		Name:       opGetService,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &GetServiceInput{}
	}

	output = &GetServiceOutput{}
	req = c.newRequest(op, input, output)
	return
}

// GetService API operation for AWS Proton.
//
// Get detail data for a service.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation GetService for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetService
func (c *Proton) GetService(input *GetServiceInput) (*GetServiceOutput, error) {
	req, out := c.GetServiceRequest(input)
	return out, req.Send()
}

// GetServiceWithContext is the same as GetService with the addition of
// the ability to pass a context and additional request options.
//
// See GetService for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) GetServiceWithContext(ctx aws.Context, input *GetServiceInput, opts ...request.Option) (*GetServiceOutput, error) {
	req, out := c.GetServiceRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opGetServiceInstance = "GetServiceInstance"

// GetServiceInstanceRequest generates a "aws/request.Request" representing the
// client's request for the GetServiceInstance operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See GetServiceInstance for more information on using the GetServiceInstance
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the GetServiceInstanceRequest method.
//    req, resp := client.GetServiceInstanceRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetServiceInstance
func (c *Proton) GetServiceInstanceRequest(input *GetServiceInstanceInput) (req *request.Request, output *GetServiceInstanceOutput) {
	op := &request.Operation{
		Name:       opGetServiceInstance,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &GetServiceInstanceInput{}
	}

	output = &GetServiceInstanceOutput{}
	req = c.newRequest(op, input, output)
	return
}

// GetServiceInstance API operation for AWS Proton.
//
// Get detail data for a service instance. A service instance is an instantiation
// of service template, which is running in a specific environment.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation GetServiceInstance for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetServiceInstance
func (c *Proton) GetServiceInstance(input *GetServiceInstanceInput) (*GetServiceInstanceOutput, error) {
	req, out := c.GetServiceInstanceRequest(input)
	return out, req.Send()
}

// GetServiceInstanceWithContext is the same as GetServiceInstance with the addition of
// the ability to pass a context and additional request options.
//
// See GetServiceInstance for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) GetServiceInstanceWithContext(ctx aws.Context, input *GetServiceInstanceInput, opts ...request.Option) (*GetServiceInstanceOutput, error) {
	req, out := c.GetServiceInstanceRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opGetServiceTemplate = "GetServiceTemplate"

// GetServiceTemplateRequest generates a "aws/request.Request" representing the
// client's request for the GetServiceTemplate operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See GetServiceTemplate for more information on using the GetServiceTemplate
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the GetServiceTemplateRequest method.
//    req, resp := client.GetServiceTemplateRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetServiceTemplate
func (c *Proton) GetServiceTemplateRequest(input *GetServiceTemplateInput) (req *request.Request, output *GetServiceTemplateOutput) {
	op := &request.Operation{
		Name:       opGetServiceTemplate,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &GetServiceTemplateInput{}
	}

	output = &GetServiceTemplateOutput{}
	req = c.newRequest(op, input, output)
	return
}

// GetServiceTemplate API operation for AWS Proton.
//
// Get detail data for a service template.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation GetServiceTemplate for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetServiceTemplate
func (c *Proton) GetServiceTemplate(input *GetServiceTemplateInput) (*GetServiceTemplateOutput, error) {
	req, out := c.GetServiceTemplateRequest(input)
	return out, req.Send()
}

// GetServiceTemplateWithContext is the same as GetServiceTemplate with the addition of
// the ability to pass a context and additional request options.
//
// See GetServiceTemplate for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) GetServiceTemplateWithContext(ctx aws.Context, input *GetServiceTemplateInput, opts ...request.Option) (*GetServiceTemplateOutput, error) {
	req, out := c.GetServiceTemplateRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opGetServiceTemplateVersion = "GetServiceTemplateVersion"

// GetServiceTemplateVersionRequest generates a "aws/request.Request" representing the
// client's request for the GetServiceTemplateVersion operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See GetServiceTemplateVersion for more information on using the GetServiceTemplateVersion
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the GetServiceTemplateVersionRequest method.
//    req, resp := client.GetServiceTemplateVersionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetServiceTemplateVersion
func (c *Proton) GetServiceTemplateVersionRequest(input *GetServiceTemplateVersionInput) (req *request.Request, output *GetServiceTemplateVersionOutput) {
	op := &request.Operation{
		Name:       opGetServiceTemplateVersion,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &GetServiceTemplateVersionInput{}
	}

	output = &GetServiceTemplateVersionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// GetServiceTemplateVersion API operation for AWS Proton.
//
// View detail data for a major or minor version of a service template.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation GetServiceTemplateVersion for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/GetServiceTemplateVersion
func (c *Proton) GetServiceTemplateVersion(input *GetServiceTemplateVersionInput) (*GetServiceTemplateVersionOutput, error) {
	req, out := c.GetServiceTemplateVersionRequest(input)
	return out, req.Send()
}

// GetServiceTemplateVersionWithContext is the same as GetServiceTemplateVersion with the addition of
// the ability to pass a context and additional request options.
//
// See GetServiceTemplateVersion for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) GetServiceTemplateVersionWithContext(ctx aws.Context, input *GetServiceTemplateVersionInput, opts ...request.Option) (*GetServiceTemplateVersionOutput, error) {
	req, out := c.GetServiceTemplateVersionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opListEnvironmentAccountConnections = "ListEnvironmentAccountConnections"

// ListEnvironmentAccountConnectionsRequest generates a "aws/request.Request" representing the
// client's request for the ListEnvironmentAccountConnections operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See ListEnvironmentAccountConnections for more information on using the ListEnvironmentAccountConnections
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the ListEnvironmentAccountConnectionsRequest method.
//    req, resp := client.ListEnvironmentAccountConnectionsRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListEnvironmentAccountConnections
func (c *Proton) ListEnvironmentAccountConnectionsRequest(input *ListEnvironmentAccountConnectionsInput) (req *request.Request, output *ListEnvironmentAccountConnectionsOutput) {
	op := &request.Operation{
		Name:       opListEnvironmentAccountConnections,
		HTTPMethod: "POST",
		HTTPPath:   "/",
		Paginator: &request.Paginator{
			InputTokens:     []string{"nextToken"},
			OutputTokens:    []string{"nextToken"},
			LimitToken:      "maxResults",
			TruncationToken: "",
		},
	}

	if input == nil {
		input = &ListEnvironmentAccountConnectionsInput{}
	}

	output = &ListEnvironmentAccountConnectionsOutput{}
	req = c.newRequest(op, input, output)
	return
}

// ListEnvironmentAccountConnections API operation for AWS Proton.
//
// View a list of environment account connections.
//
// For more information, see Environment account connections (https://docs.aws.amazon.com/proton/latest/adminguide/ag-env-account-connections.html)
// in the AWS Proton Administrator guide.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation ListEnvironmentAccountConnections for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListEnvironmentAccountConnections
func (c *Proton) ListEnvironmentAccountConnections(input *ListEnvironmentAccountConnectionsInput) (*ListEnvironmentAccountConnectionsOutput, error) {
	req, out := c.ListEnvironmentAccountConnectionsRequest(input)
	return out, req.Send()
}

// ListEnvironmentAccountConnectionsWithContext is the same as ListEnvironmentAccountConnections with the addition of
// the ability to pass a context and additional request options.
//
// See ListEnvironmentAccountConnections for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListEnvironmentAccountConnectionsWithContext(ctx aws.Context, input *ListEnvironmentAccountConnectionsInput, opts ...request.Option) (*ListEnvironmentAccountConnectionsOutput, error) {
	req, out := c.ListEnvironmentAccountConnectionsRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

// ListEnvironmentAccountConnectionsPages iterates over the pages of a ListEnvironmentAccountConnections operation,
// calling the "fn" function with the response data for each page. To stop
// iterating, return false from the fn function.
//
// See ListEnvironmentAccountConnections method for more information on how to use this operation.
//
// Note: This operation can generate multiple requests to a service.
//
//    // Example iterating over at most 3 pages of a ListEnvironmentAccountConnections operation.
//    pageNum := 0
//    err := client.ListEnvironmentAccountConnectionsPages(params,
//        func(page *proton.ListEnvironmentAccountConnectionsOutput, lastPage bool) bool {
//            pageNum++
//            fmt.Println(page)
//            return pageNum <= 3
//        })
//
func (c *Proton) ListEnvironmentAccountConnectionsPages(input *ListEnvironmentAccountConnectionsInput, fn func(*ListEnvironmentAccountConnectionsOutput, bool) bool) error {
	return c.ListEnvironmentAccountConnectionsPagesWithContext(aws.BackgroundContext(), input, fn)
}

// ListEnvironmentAccountConnectionsPagesWithContext same as ListEnvironmentAccountConnectionsPages except
// it takes a Context and allows setting request options on the pages.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListEnvironmentAccountConnectionsPagesWithContext(ctx aws.Context, input *ListEnvironmentAccountConnectionsInput, fn func(*ListEnvironmentAccountConnectionsOutput, bool) bool, opts ...request.Option) error {
	p := request.Pagination{
		NewRequest: func() (*request.Request, error) {
			var inCpy *ListEnvironmentAccountConnectionsInput
			if input != nil {
				tmp := *input
				inCpy = &tmp
			}
			req, _ := c.ListEnvironmentAccountConnectionsRequest(inCpy)
			req.SetContext(ctx)
			req.ApplyOptions(opts...)
			return req, nil
		},
	}

	for p.Next() {
		if !fn(p.Page().(*ListEnvironmentAccountConnectionsOutput), !p.HasNextPage()) {
			break
		}
	}

	return p.Err()
}

const opListEnvironmentTemplateVersions = "ListEnvironmentTemplateVersions"

// ListEnvironmentTemplateVersionsRequest generates a "aws/request.Request" representing the
// client's request for the ListEnvironmentTemplateVersions operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See ListEnvironmentTemplateVersions for more information on using the ListEnvironmentTemplateVersions
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the ListEnvironmentTemplateVersionsRequest method.
//    req, resp := client.ListEnvironmentTemplateVersionsRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListEnvironmentTemplateVersions
func (c *Proton) ListEnvironmentTemplateVersionsRequest(input *ListEnvironmentTemplateVersionsInput) (req *request.Request, output *ListEnvironmentTemplateVersionsOutput) {
	op := &request.Operation{
		Name:       opListEnvironmentTemplateVersions,
		HTTPMethod: "POST",
		HTTPPath:   "/",
		Paginator: &request.Paginator{
			InputTokens:     []string{"nextToken"},
			OutputTokens:    []string{"nextToken"},
			LimitToken:      "maxResults",
			TruncationToken: "",
		},
	}

	if input == nil {
		input = &ListEnvironmentTemplateVersionsInput{}
	}

	output = &ListEnvironmentTemplateVersionsOutput{}
	req = c.newRequest(op, input, output)
	return
}

// ListEnvironmentTemplateVersions API operation for AWS Proton.
//
// List major or minor versions of an environment template with detail data.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation ListEnvironmentTemplateVersions for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListEnvironmentTemplateVersions
func (c *Proton) ListEnvironmentTemplateVersions(input *ListEnvironmentTemplateVersionsInput) (*ListEnvironmentTemplateVersionsOutput, error) {
	req, out := c.ListEnvironmentTemplateVersionsRequest(input)
	return out, req.Send()
}

// ListEnvironmentTemplateVersionsWithContext is the same as ListEnvironmentTemplateVersions with the addition of
// the ability to pass a context and additional request options.
//
// See ListEnvironmentTemplateVersions for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListEnvironmentTemplateVersionsWithContext(ctx aws.Context, input *ListEnvironmentTemplateVersionsInput, opts ...request.Option) (*ListEnvironmentTemplateVersionsOutput, error) {
	req, out := c.ListEnvironmentTemplateVersionsRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

// ListEnvironmentTemplateVersionsPages iterates over the pages of a ListEnvironmentTemplateVersions operation,
// calling the "fn" function with the response data for each page. To stop
// iterating, return false from the fn function.
//
// See ListEnvironmentTemplateVersions method for more information on how to use this operation.
//
// Note: This operation can generate multiple requests to a service.
//
//    // Example iterating over at most 3 pages of a ListEnvironmentTemplateVersions operation.
//    pageNum := 0
//    err := client.ListEnvironmentTemplateVersionsPages(params,
//        func(page *proton.ListEnvironmentTemplateVersionsOutput, lastPage bool) bool {
//            pageNum++
//            fmt.Println(page)
//            return pageNum <= 3
//        })
//
func (c *Proton) ListEnvironmentTemplateVersionsPages(input *ListEnvironmentTemplateVersionsInput, fn func(*ListEnvironmentTemplateVersionsOutput, bool) bool) error {
	return c.ListEnvironmentTemplateVersionsPagesWithContext(aws.BackgroundContext(), input, fn)
}

// ListEnvironmentTemplateVersionsPagesWithContext same as ListEnvironmentTemplateVersionsPages except
// it takes a Context and allows setting request options on the pages.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListEnvironmentTemplateVersionsPagesWithContext(ctx aws.Context, input *ListEnvironmentTemplateVersionsInput, fn func(*ListEnvironmentTemplateVersionsOutput, bool) bool, opts ...request.Option) error {
	p := request.Pagination{
		NewRequest: func() (*request.Request, error) {
			var inCpy *ListEnvironmentTemplateVersionsInput
			if input != nil {
				tmp := *input
				inCpy = &tmp
			}
			req, _ := c.ListEnvironmentTemplateVersionsRequest(inCpy)
			req.SetContext(ctx)
			req.ApplyOptions(opts...)
			return req, nil
		},
	}

	for p.Next() {
		if !fn(p.Page().(*ListEnvironmentTemplateVersionsOutput), !p.HasNextPage()) {
			break
		}
	}

	return p.Err()
}

const opListEnvironmentTemplates = "ListEnvironmentTemplates"

// ListEnvironmentTemplatesRequest generates a "aws/request.Request" representing the
// client's request for the ListEnvironmentTemplates operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See ListEnvironmentTemplates for more information on using the ListEnvironmentTemplates
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the ListEnvironmentTemplatesRequest method.
//    req, resp := client.ListEnvironmentTemplatesRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListEnvironmentTemplates
func (c *Proton) ListEnvironmentTemplatesRequest(input *ListEnvironmentTemplatesInput) (req *request.Request, output *ListEnvironmentTemplatesOutput) {
	op := &request.Operation{
		Name:       opListEnvironmentTemplates,
		HTTPMethod: "POST",
		HTTPPath:   "/",
		Paginator: &request.Paginator{
			InputTokens:     []string{"nextToken"},
			OutputTokens:    []string{"nextToken"},
			LimitToken:      "maxResults",
			TruncationToken: "",
		},
	}

	if input == nil {
		input = &ListEnvironmentTemplatesInput{}
	}

	output = &ListEnvironmentTemplatesOutput{}
	req = c.newRequest(op, input, output)
	return
}

// ListEnvironmentTemplates API operation for AWS Proton.
//
// List environment templates.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation ListEnvironmentTemplates for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListEnvironmentTemplates
func (c *Proton) ListEnvironmentTemplates(input *ListEnvironmentTemplatesInput) (*ListEnvironmentTemplatesOutput, error) {
	req, out := c.ListEnvironmentTemplatesRequest(input)
	return out, req.Send()
}

// ListEnvironmentTemplatesWithContext is the same as ListEnvironmentTemplates with the addition of
// the ability to pass a context and additional request options.
//
// See ListEnvironmentTemplates for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListEnvironmentTemplatesWithContext(ctx aws.Context, input *ListEnvironmentTemplatesInput, opts ...request.Option) (*ListEnvironmentTemplatesOutput, error) {
	req, out := c.ListEnvironmentTemplatesRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

// ListEnvironmentTemplatesPages iterates over the pages of a ListEnvironmentTemplates operation,
// calling the "fn" function with the response data for each page. To stop
// iterating, return false from the fn function.
//
// See ListEnvironmentTemplates method for more information on how to use this operation.
//
// Note: This operation can generate multiple requests to a service.
//
//    // Example iterating over at most 3 pages of a ListEnvironmentTemplates operation.
//    pageNum := 0
//    err := client.ListEnvironmentTemplatesPages(params,
//        func(page *proton.ListEnvironmentTemplatesOutput, lastPage bool) bool {
//            pageNum++
//            fmt.Println(page)
//            return pageNum <= 3
//        })
//
func (c *Proton) ListEnvironmentTemplatesPages(input *ListEnvironmentTemplatesInput, fn func(*ListEnvironmentTemplatesOutput, bool) bool) error {
	return c.ListEnvironmentTemplatesPagesWithContext(aws.BackgroundContext(), input, fn)
}

// ListEnvironmentTemplatesPagesWithContext same as ListEnvironmentTemplatesPages except
// it takes a Context and allows setting request options on the pages.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListEnvironmentTemplatesPagesWithContext(ctx aws.Context, input *ListEnvironmentTemplatesInput, fn func(*ListEnvironmentTemplatesOutput, bool) bool, opts ...request.Option) error {
	p := request.Pagination{
		NewRequest: func() (*request.Request, error) {
			var inCpy *ListEnvironmentTemplatesInput
			if input != nil {
				tmp := *input
				inCpy = &tmp
			}
			req, _ := c.ListEnvironmentTemplatesRequest(inCpy)
			req.SetContext(ctx)
			req.ApplyOptions(opts...)
			return req, nil
		},
	}

	for p.Next() {
		if !fn(p.Page().(*ListEnvironmentTemplatesOutput), !p.HasNextPage()) {
			break
		}
	}

	return p.Err()
}

const opListEnvironments = "ListEnvironments"

// ListEnvironmentsRequest generates a "aws/request.Request" representing the
// client's request for the ListEnvironments operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See ListEnvironments for more information on using the ListEnvironments
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the ListEnvironmentsRequest method.
//    req, resp := client.ListEnvironmentsRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListEnvironments
func (c *Proton) ListEnvironmentsRequest(input *ListEnvironmentsInput) (req *request.Request, output *ListEnvironmentsOutput) {
	op := &request.Operation{
		Name:       opListEnvironments,
		HTTPMethod: "POST",
		HTTPPath:   "/",
		Paginator: &request.Paginator{
			InputTokens:     []string{"nextToken"},
			OutputTokens:    []string{"nextToken"},
			LimitToken:      "maxResults",
			TruncationToken: "",
		},
	}

	if input == nil {
		input = &ListEnvironmentsInput{}
	}

	output = &ListEnvironmentsOutput{}
	req = c.newRequest(op, input, output)
	return
}

// ListEnvironments API operation for AWS Proton.
//
// List environments with detail data summaries.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation ListEnvironments for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListEnvironments
func (c *Proton) ListEnvironments(input *ListEnvironmentsInput) (*ListEnvironmentsOutput, error) {
	req, out := c.ListEnvironmentsRequest(input)
	return out, req.Send()
}

// ListEnvironmentsWithContext is the same as ListEnvironments with the addition of
// the ability to pass a context and additional request options.
//
// See ListEnvironments for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListEnvironmentsWithContext(ctx aws.Context, input *ListEnvironmentsInput, opts ...request.Option) (*ListEnvironmentsOutput, error) {
	req, out := c.ListEnvironmentsRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

// ListEnvironmentsPages iterates over the pages of a ListEnvironments operation,
// calling the "fn" function with the response data for each page. To stop
// iterating, return false from the fn function.
//
// See ListEnvironments method for more information on how to use this operation.
//
// Note: This operation can generate multiple requests to a service.
//
//    // Example iterating over at most 3 pages of a ListEnvironments operation.
//    pageNum := 0
//    err := client.ListEnvironmentsPages(params,
//        func(page *proton.ListEnvironmentsOutput, lastPage bool) bool {
//            pageNum++
//            fmt.Println(page)
//            return pageNum <= 3
//        })
//
func (c *Proton) ListEnvironmentsPages(input *ListEnvironmentsInput, fn func(*ListEnvironmentsOutput, bool) bool) error {
	return c.ListEnvironmentsPagesWithContext(aws.BackgroundContext(), input, fn)
}

// ListEnvironmentsPagesWithContext same as ListEnvironmentsPages except
// it takes a Context and allows setting request options on the pages.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListEnvironmentsPagesWithContext(ctx aws.Context, input *ListEnvironmentsInput, fn func(*ListEnvironmentsOutput, bool) bool, opts ...request.Option) error {
	p := request.Pagination{
		NewRequest: func() (*request.Request, error) {
			var inCpy *ListEnvironmentsInput
			if input != nil {
				tmp := *input
				inCpy = &tmp
			}
			req, _ := c.ListEnvironmentsRequest(inCpy)
			req.SetContext(ctx)
			req.ApplyOptions(opts...)
			return req, nil
		},
	}

	for p.Next() {
		if !fn(p.Page().(*ListEnvironmentsOutput), !p.HasNextPage()) {
			break
		}
	}

	return p.Err()
}

const opListServiceInstances = "ListServiceInstances"

// ListServiceInstancesRequest generates a "aws/request.Request" representing the
// client's request for the ListServiceInstances operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See ListServiceInstances for more information on using the ListServiceInstances
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the ListServiceInstancesRequest method.
//    req, resp := client.ListServiceInstancesRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListServiceInstances
func (c *Proton) ListServiceInstancesRequest(input *ListServiceInstancesInput) (req *request.Request, output *ListServiceInstancesOutput) {
	op := &request.Operation{
		Name:       opListServiceInstances,
		HTTPMethod: "POST",
		HTTPPath:   "/",
		Paginator: &request.Paginator{
			InputTokens:     []string{"nextToken"},
			OutputTokens:    []string{"nextToken"},
			LimitToken:      "maxResults",
			TruncationToken: "",
		},
	}

	if input == nil {
		input = &ListServiceInstancesInput{}
	}

	output = &ListServiceInstancesOutput{}
	req = c.newRequest(op, input, output)
	return
}

// ListServiceInstances API operation for AWS Proton.
//
// List service instances with summaries of detail data.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation ListServiceInstances for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListServiceInstances
func (c *Proton) ListServiceInstances(input *ListServiceInstancesInput) (*ListServiceInstancesOutput, error) {
	req, out := c.ListServiceInstancesRequest(input)
	return out, req.Send()
}

// ListServiceInstancesWithContext is the same as ListServiceInstances with the addition of
// the ability to pass a context and additional request options.
//
// See ListServiceInstances for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListServiceInstancesWithContext(ctx aws.Context, input *ListServiceInstancesInput, opts ...request.Option) (*ListServiceInstancesOutput, error) {
	req, out := c.ListServiceInstancesRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

// ListServiceInstancesPages iterates over the pages of a ListServiceInstances operation,
// calling the "fn" function with the response data for each page. To stop
// iterating, return false from the fn function.
//
// See ListServiceInstances method for more information on how to use this operation.
//
// Note: This operation can generate multiple requests to a service.
//
//    // Example iterating over at most 3 pages of a ListServiceInstances operation.
//    pageNum := 0
//    err := client.ListServiceInstancesPages(params,
//        func(page *proton.ListServiceInstancesOutput, lastPage bool) bool {
//            pageNum++
//            fmt.Println(page)
//            return pageNum <= 3
//        })
//
func (c *Proton) ListServiceInstancesPages(input *ListServiceInstancesInput, fn func(*ListServiceInstancesOutput, bool) bool) error {
	return c.ListServiceInstancesPagesWithContext(aws.BackgroundContext(), input, fn)
}

// ListServiceInstancesPagesWithContext same as ListServiceInstancesPages except
// it takes a Context and allows setting request options on the pages.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListServiceInstancesPagesWithContext(ctx aws.Context, input *ListServiceInstancesInput, fn func(*ListServiceInstancesOutput, bool) bool, opts ...request.Option) error {
	p := request.Pagination{
		NewRequest: func() (*request.Request, error) {
			var inCpy *ListServiceInstancesInput
			if input != nil {
				tmp := *input
				inCpy = &tmp
			}
			req, _ := c.ListServiceInstancesRequest(inCpy)
			req.SetContext(ctx)
			req.ApplyOptions(opts...)
			return req, nil
		},
	}

	for p.Next() {
		if !fn(p.Page().(*ListServiceInstancesOutput), !p.HasNextPage()) {
			break
		}
	}

	return p.Err()
}

const opListServiceTemplateVersions = "ListServiceTemplateVersions"

// ListServiceTemplateVersionsRequest generates a "aws/request.Request" representing the
// client's request for the ListServiceTemplateVersions operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See ListServiceTemplateVersions for more information on using the ListServiceTemplateVersions
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the ListServiceTemplateVersionsRequest method.
//    req, resp := client.ListServiceTemplateVersionsRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListServiceTemplateVersions
func (c *Proton) ListServiceTemplateVersionsRequest(input *ListServiceTemplateVersionsInput) (req *request.Request, output *ListServiceTemplateVersionsOutput) {
	op := &request.Operation{
		Name:       opListServiceTemplateVersions,
		HTTPMethod: "POST",
		HTTPPath:   "/",
		Paginator: &request.Paginator{
			InputTokens:     []string{"nextToken"},
			OutputTokens:    []string{"nextToken"},
			LimitToken:      "maxResults",
			TruncationToken: "",
		},
	}

	if input == nil {
		input = &ListServiceTemplateVersionsInput{}
	}

	output = &ListServiceTemplateVersionsOutput{}
	req = c.newRequest(op, input, output)
	return
}

// ListServiceTemplateVersions API operation for AWS Proton.
//
// List major or minor versions of a service template with detail data.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation ListServiceTemplateVersions for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListServiceTemplateVersions
func (c *Proton) ListServiceTemplateVersions(input *ListServiceTemplateVersionsInput) (*ListServiceTemplateVersionsOutput, error) {
	req, out := c.ListServiceTemplateVersionsRequest(input)
	return out, req.Send()
}

// ListServiceTemplateVersionsWithContext is the same as ListServiceTemplateVersions with the addition of
// the ability to pass a context and additional request options.
//
// See ListServiceTemplateVersions for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListServiceTemplateVersionsWithContext(ctx aws.Context, input *ListServiceTemplateVersionsInput, opts ...request.Option) (*ListServiceTemplateVersionsOutput, error) {
	req, out := c.ListServiceTemplateVersionsRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

// ListServiceTemplateVersionsPages iterates over the pages of a ListServiceTemplateVersions operation,
// calling the "fn" function with the response data for each page. To stop
// iterating, return false from the fn function.
//
// See ListServiceTemplateVersions method for more information on how to use this operation.
//
// Note: This operation can generate multiple requests to a service.
//
//    // Example iterating over at most 3 pages of a ListServiceTemplateVersions operation.
//    pageNum := 0
//    err := client.ListServiceTemplateVersionsPages(params,
//        func(page *proton.ListServiceTemplateVersionsOutput, lastPage bool) bool {
//            pageNum++
//            fmt.Println(page)
//            return pageNum <= 3
//        })
//
func (c *Proton) ListServiceTemplateVersionsPages(input *ListServiceTemplateVersionsInput, fn func(*ListServiceTemplateVersionsOutput, bool) bool) error {
	return c.ListServiceTemplateVersionsPagesWithContext(aws.BackgroundContext(), input, fn)
}

// ListServiceTemplateVersionsPagesWithContext same as ListServiceTemplateVersionsPages except
// it takes a Context and allows setting request options on the pages.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListServiceTemplateVersionsPagesWithContext(ctx aws.Context, input *ListServiceTemplateVersionsInput, fn func(*ListServiceTemplateVersionsOutput, bool) bool, opts ...request.Option) error {
	p := request.Pagination{
		NewRequest: func() (*request.Request, error) {
			var inCpy *ListServiceTemplateVersionsInput
			if input != nil {
				tmp := *input
				inCpy = &tmp
			}
			req, _ := c.ListServiceTemplateVersionsRequest(inCpy)
			req.SetContext(ctx)
			req.ApplyOptions(opts...)
			return req, nil
		},
	}

	for p.Next() {
		if !fn(p.Page().(*ListServiceTemplateVersionsOutput), !p.HasNextPage()) {
			break
		}
	}

	return p.Err()
}

const opListServiceTemplates = "ListServiceTemplates"

// ListServiceTemplatesRequest generates a "aws/request.Request" representing the
// client's request for the ListServiceTemplates operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See ListServiceTemplates for more information on using the ListServiceTemplates
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the ListServiceTemplatesRequest method.
//    req, resp := client.ListServiceTemplatesRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListServiceTemplates
func (c *Proton) ListServiceTemplatesRequest(input *ListServiceTemplatesInput) (req *request.Request, output *ListServiceTemplatesOutput) {
	op := &request.Operation{
		Name:       opListServiceTemplates,
		HTTPMethod: "POST",
		HTTPPath:   "/",
		Paginator: &request.Paginator{
			InputTokens:     []string{"nextToken"},
			OutputTokens:    []string{"nextToken"},
			LimitToken:      "maxResults",
			TruncationToken: "",
		},
	}

	if input == nil {
		input = &ListServiceTemplatesInput{}
	}

	output = &ListServiceTemplatesOutput{}
	req = c.newRequest(op, input, output)
	return
}

// ListServiceTemplates API operation for AWS Proton.
//
// List service templates with detail data.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation ListServiceTemplates for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListServiceTemplates
func (c *Proton) ListServiceTemplates(input *ListServiceTemplatesInput) (*ListServiceTemplatesOutput, error) {
	req, out := c.ListServiceTemplatesRequest(input)
	return out, req.Send()
}

// ListServiceTemplatesWithContext is the same as ListServiceTemplates with the addition of
// the ability to pass a context and additional request options.
//
// See ListServiceTemplates for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListServiceTemplatesWithContext(ctx aws.Context, input *ListServiceTemplatesInput, opts ...request.Option) (*ListServiceTemplatesOutput, error) {
	req, out := c.ListServiceTemplatesRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

// ListServiceTemplatesPages iterates over the pages of a ListServiceTemplates operation,
// calling the "fn" function with the response data for each page. To stop
// iterating, return false from the fn function.
//
// See ListServiceTemplates method for more information on how to use this operation.
//
// Note: This operation can generate multiple requests to a service.
//
//    // Example iterating over at most 3 pages of a ListServiceTemplates operation.
//    pageNum := 0
//    err := client.ListServiceTemplatesPages(params,
//        func(page *proton.ListServiceTemplatesOutput, lastPage bool) bool {
//            pageNum++
//            fmt.Println(page)
//            return pageNum <= 3
//        })
//
func (c *Proton) ListServiceTemplatesPages(input *ListServiceTemplatesInput, fn func(*ListServiceTemplatesOutput, bool) bool) error {
	return c.ListServiceTemplatesPagesWithContext(aws.BackgroundContext(), input, fn)
}

// ListServiceTemplatesPagesWithContext same as ListServiceTemplatesPages except
// it takes a Context and allows setting request options on the pages.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListServiceTemplatesPagesWithContext(ctx aws.Context, input *ListServiceTemplatesInput, fn func(*ListServiceTemplatesOutput, bool) bool, opts ...request.Option) error {
	p := request.Pagination{
		NewRequest: func() (*request.Request, error) {
			var inCpy *ListServiceTemplatesInput
			if input != nil {
				tmp := *input
				inCpy = &tmp
			}
			req, _ := c.ListServiceTemplatesRequest(inCpy)
			req.SetContext(ctx)
			req.ApplyOptions(opts...)
			return req, nil
		},
	}

	for p.Next() {
		if !fn(p.Page().(*ListServiceTemplatesOutput), !p.HasNextPage()) {
			break
		}
	}

	return p.Err()
}

const opListServices = "ListServices"

// ListServicesRequest generates a "aws/request.Request" representing the
// client's request for the ListServices operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See ListServices for more information on using the ListServices
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the ListServicesRequest method.
//    req, resp := client.ListServicesRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListServices
func (c *Proton) ListServicesRequest(input *ListServicesInput) (req *request.Request, output *ListServicesOutput) {
	op := &request.Operation{
		Name:       opListServices,
		HTTPMethod: "POST",
		HTTPPath:   "/",
		Paginator: &request.Paginator{
			InputTokens:     []string{"nextToken"},
			OutputTokens:    []string{"nextToken"},
			LimitToken:      "maxResults",
			TruncationToken: "",
		},
	}

	if input == nil {
		input = &ListServicesInput{}
	}

	output = &ListServicesOutput{}
	req = c.newRequest(op, input, output)
	return
}

// ListServices API operation for AWS Proton.
//
// List services with summaries of detail data.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation ListServices for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListServices
func (c *Proton) ListServices(input *ListServicesInput) (*ListServicesOutput, error) {
	req, out := c.ListServicesRequest(input)
	return out, req.Send()
}

// ListServicesWithContext is the same as ListServices with the addition of
// the ability to pass a context and additional request options.
//
// See ListServices for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListServicesWithContext(ctx aws.Context, input *ListServicesInput, opts ...request.Option) (*ListServicesOutput, error) {
	req, out := c.ListServicesRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

// ListServicesPages iterates over the pages of a ListServices operation,
// calling the "fn" function with the response data for each page. To stop
// iterating, return false from the fn function.
//
// See ListServices method for more information on how to use this operation.
//
// Note: This operation can generate multiple requests to a service.
//
//    // Example iterating over at most 3 pages of a ListServices operation.
//    pageNum := 0
//    err := client.ListServicesPages(params,
//        func(page *proton.ListServicesOutput, lastPage bool) bool {
//            pageNum++
//            fmt.Println(page)
//            return pageNum <= 3
//        })
//
func (c *Proton) ListServicesPages(input *ListServicesInput, fn func(*ListServicesOutput, bool) bool) error {
	return c.ListServicesPagesWithContext(aws.BackgroundContext(), input, fn)
}

// ListServicesPagesWithContext same as ListServicesPages except
// it takes a Context and allows setting request options on the pages.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListServicesPagesWithContext(ctx aws.Context, input *ListServicesInput, fn func(*ListServicesOutput, bool) bool, opts ...request.Option) error {
	p := request.Pagination{
		NewRequest: func() (*request.Request, error) {
			var inCpy *ListServicesInput
			if input != nil {
				tmp := *input
				inCpy = &tmp
			}
			req, _ := c.ListServicesRequest(inCpy)
			req.SetContext(ctx)
			req.ApplyOptions(opts...)
			return req, nil
		},
	}

	for p.Next() {
		if !fn(p.Page().(*ListServicesOutput), !p.HasNextPage()) {
			break
		}
	}

	return p.Err()
}

const opListTagsForResource = "ListTagsForResource"

// ListTagsForResourceRequest generates a "aws/request.Request" representing the
// client's request for the ListTagsForResource operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See ListTagsForResource for more information on using the ListTagsForResource
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the ListTagsForResourceRequest method.
//    req, resp := client.ListTagsForResourceRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListTagsForResource
func (c *Proton) ListTagsForResourceRequest(input *ListTagsForResourceInput) (req *request.Request, output *ListTagsForResourceOutput) {
	op := &request.Operation{
		Name:       opListTagsForResource,
		HTTPMethod: "POST",
		HTTPPath:   "/",
		Paginator: &request.Paginator{
			InputTokens:     []string{"nextToken"},
			OutputTokens:    []string{"nextToken"},
			LimitToken:      "maxResults",
			TruncationToken: "",
		},
	}

	if input == nil {
		input = &ListTagsForResourceInput{}
	}

	output = &ListTagsForResourceOutput{}
	req = c.newRequest(op, input, output)
	return
}

// ListTagsForResource API operation for AWS Proton.
//
// List tags for a resource. For more information, see AWS Proton resources
// and tagging in the AWS Proton Administrator Guide (https://docs.aws.amazon.com/proton/latest/adminguide/resources.html)
// or AWS Proton User Guide (https://docs.aws.amazon.com/proton/latest/userguide/resources.html).
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation ListTagsForResource for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/ListTagsForResource
func (c *Proton) ListTagsForResource(input *ListTagsForResourceInput) (*ListTagsForResourceOutput, error) {
	req, out := c.ListTagsForResourceRequest(input)
	return out, req.Send()
}

// ListTagsForResourceWithContext is the same as ListTagsForResource with the addition of
// the ability to pass a context and additional request options.
//
// See ListTagsForResource for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListTagsForResourceWithContext(ctx aws.Context, input *ListTagsForResourceInput, opts ...request.Option) (*ListTagsForResourceOutput, error) {
	req, out := c.ListTagsForResourceRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

// ListTagsForResourcePages iterates over the pages of a ListTagsForResource operation,
// calling the "fn" function with the response data for each page. To stop
// iterating, return false from the fn function.
//
// See ListTagsForResource method for more information on how to use this operation.
//
// Note: This operation can generate multiple requests to a service.
//
//    // Example iterating over at most 3 pages of a ListTagsForResource operation.
//    pageNum := 0
//    err := client.ListTagsForResourcePages(params,
//        func(page *proton.ListTagsForResourceOutput, lastPage bool) bool {
//            pageNum++
//            fmt.Println(page)
//            return pageNum <= 3
//        })
//
func (c *Proton) ListTagsForResourcePages(input *ListTagsForResourceInput, fn func(*ListTagsForResourceOutput, bool) bool) error {
	return c.ListTagsForResourcePagesWithContext(aws.BackgroundContext(), input, fn)
}

// ListTagsForResourcePagesWithContext same as ListTagsForResourcePages except
// it takes a Context and allows setting request options on the pages.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) ListTagsForResourcePagesWithContext(ctx aws.Context, input *ListTagsForResourceInput, fn func(*ListTagsForResourceOutput, bool) bool, opts ...request.Option) error {
	p := request.Pagination{
		NewRequest: func() (*request.Request, error) {
			var inCpy *ListTagsForResourceInput
			if input != nil {
				tmp := *input
				inCpy = &tmp
			}
			req, _ := c.ListTagsForResourceRequest(inCpy)
			req.SetContext(ctx)
			req.ApplyOptions(opts...)
			return req, nil
		},
	}

	for p.Next() {
		if !fn(p.Page().(*ListTagsForResourceOutput), !p.HasNextPage()) {
			break
		}
	}

	return p.Err()
}

const opRejectEnvironmentAccountConnection = "RejectEnvironmentAccountConnection"

// RejectEnvironmentAccountConnectionRequest generates a "aws/request.Request" representing the
// client's request for the RejectEnvironmentAccountConnection operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See RejectEnvironmentAccountConnection for more information on using the RejectEnvironmentAccountConnection
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the RejectEnvironmentAccountConnectionRequest method.
//    req, resp := client.RejectEnvironmentAccountConnectionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/RejectEnvironmentAccountConnection
func (c *Proton) RejectEnvironmentAccountConnectionRequest(input *RejectEnvironmentAccountConnectionInput) (req *request.Request, output *RejectEnvironmentAccountConnectionOutput) {
	op := &request.Operation{
		Name:       opRejectEnvironmentAccountConnection,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &RejectEnvironmentAccountConnectionInput{}
	}

	output = &RejectEnvironmentAccountConnectionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// RejectEnvironmentAccountConnection API operation for AWS Proton.
//
// In a management account, reject an environment account connection from another
// environment account.
//
// After you reject an environment account connection request, you won’t be
// able to accept or use the rejected environment account connection.
//
// You can’t reject an environment account connection that is connected to
// an environment.
//
// For more information, see Environment account connections (https://docs.aws.amazon.com/proton/latest/adminguide/ag-env-account-connections.html)
// in the AWS Proton Administrator guide.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation RejectEnvironmentAccountConnection for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/RejectEnvironmentAccountConnection
func (c *Proton) RejectEnvironmentAccountConnection(input *RejectEnvironmentAccountConnectionInput) (*RejectEnvironmentAccountConnectionOutput, error) {
	req, out := c.RejectEnvironmentAccountConnectionRequest(input)
	return out, req.Send()
}

// RejectEnvironmentAccountConnectionWithContext is the same as RejectEnvironmentAccountConnection with the addition of
// the ability to pass a context and additional request options.
//
// See RejectEnvironmentAccountConnection for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) RejectEnvironmentAccountConnectionWithContext(ctx aws.Context, input *RejectEnvironmentAccountConnectionInput, opts ...request.Option) (*RejectEnvironmentAccountConnectionOutput, error) {
	req, out := c.RejectEnvironmentAccountConnectionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opTagResource = "TagResource"

// TagResourceRequest generates a "aws/request.Request" representing the
// client's request for the TagResource operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See TagResource for more information on using the TagResource
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the TagResourceRequest method.
//    req, resp := client.TagResourceRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/TagResource
func (c *Proton) TagResourceRequest(input *TagResourceInput) (req *request.Request, output *TagResourceOutput) {
	op := &request.Operation{
		Name:       opTagResource,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &TagResourceInput{}
	}

	output = &TagResourceOutput{}
	req = c.newRequest(op, input, output)
	req.Handlers.Unmarshal.Swap(jsonrpc.UnmarshalHandler.Name, protocol.UnmarshalDiscardBodyHandler)
	return
}

// TagResource API operation for AWS Proton.
//
// Tag a resource. For more information, see AWS Proton resources and tagging
// in the AWS Proton Administrator Guide (https://docs.aws.amazon.com/proton/latest/adminguide/resources.html)
// or AWS Proton User Guide (https://docs.aws.amazon.com/proton/latest/userguide/resources.html).
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation TagResource for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/TagResource
func (c *Proton) TagResource(input *TagResourceInput) (*TagResourceOutput, error) {
	req, out := c.TagResourceRequest(input)
	return out, req.Send()
}

// TagResourceWithContext is the same as TagResource with the addition of
// the ability to pass a context and additional request options.
//
// See TagResource for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) TagResourceWithContext(ctx aws.Context, input *TagResourceInput, opts ...request.Option) (*TagResourceOutput, error) {
	req, out := c.TagResourceRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opUntagResource = "UntagResource"

// UntagResourceRequest generates a "aws/request.Request" representing the
// client's request for the UntagResource operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See UntagResource for more information on using the UntagResource
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the UntagResourceRequest method.
//    req, resp := client.UntagResourceRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UntagResource
func (c *Proton) UntagResourceRequest(input *UntagResourceInput) (req *request.Request, output *UntagResourceOutput) {
	op := &request.Operation{
		Name:       opUntagResource,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &UntagResourceInput{}
	}

	output = &UntagResourceOutput{}
	req = c.newRequest(op, input, output)
	req.Handlers.Unmarshal.Swap(jsonrpc.UnmarshalHandler.Name, protocol.UnmarshalDiscardBodyHandler)
	return
}

// UntagResource API operation for AWS Proton.
//
// Remove a tag from a resource. For more information, see AWS Proton resources
// and tagging in the AWS Proton Administrator Guide (https://docs.aws.amazon.com/proton/latest/adminguide/resources.html)
// or AWS Proton User Guide (https://docs.aws.amazon.com/proton/latest/userguide/resources.html).
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation UntagResource for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UntagResource
func (c *Proton) UntagResource(input *UntagResourceInput) (*UntagResourceOutput, error) {
	req, out := c.UntagResourceRequest(input)
	return out, req.Send()
}

// UntagResourceWithContext is the same as UntagResource with the addition of
// the ability to pass a context and additional request options.
//
// See UntagResource for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) UntagResourceWithContext(ctx aws.Context, input *UntagResourceInput, opts ...request.Option) (*UntagResourceOutput, error) {
	req, out := c.UntagResourceRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opUpdateAccountSettings = "UpdateAccountSettings"

// UpdateAccountSettingsRequest generates a "aws/request.Request" representing the
// client's request for the UpdateAccountSettings operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See UpdateAccountSettings for more information on using the UpdateAccountSettings
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the UpdateAccountSettingsRequest method.
//    req, resp := client.UpdateAccountSettingsRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateAccountSettings
func (c *Proton) UpdateAccountSettingsRequest(input *UpdateAccountSettingsInput) (req *request.Request, output *UpdateAccountSettingsOutput) {
	op := &request.Operation{
		Name:       opUpdateAccountSettings,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &UpdateAccountSettingsInput{}
	}

	output = &UpdateAccountSettingsOutput{}
	req = c.newRequest(op, input, output)
	return
}

// UpdateAccountSettings API operation for AWS Proton.
//
// Update the AWS Proton pipeline service account settings.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation UpdateAccountSettings for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateAccountSettings
func (c *Proton) UpdateAccountSettings(input *UpdateAccountSettingsInput) (*UpdateAccountSettingsOutput, error) {
	req, out := c.UpdateAccountSettingsRequest(input)
	return out, req.Send()
}

// UpdateAccountSettingsWithContext is the same as UpdateAccountSettings with the addition of
// the ability to pass a context and additional request options.
//
// See UpdateAccountSettings for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) UpdateAccountSettingsWithContext(ctx aws.Context, input *UpdateAccountSettingsInput, opts ...request.Option) (*UpdateAccountSettingsOutput, error) {
	req, out := c.UpdateAccountSettingsRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opUpdateEnvironment = "UpdateEnvironment"

// UpdateEnvironmentRequest generates a "aws/request.Request" representing the
// client's request for the UpdateEnvironment operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See UpdateEnvironment for more information on using the UpdateEnvironment
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the UpdateEnvironmentRequest method.
//    req, resp := client.UpdateEnvironmentRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateEnvironment
func (c *Proton) UpdateEnvironmentRequest(input *UpdateEnvironmentInput) (req *request.Request, output *UpdateEnvironmentOutput) {
	op := &request.Operation{
		Name:       opUpdateEnvironment,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &UpdateEnvironmentInput{}
	}

	output = &UpdateEnvironmentOutput{}
	req = c.newRequest(op, input, output)
	return
}

// UpdateEnvironment API operation for AWS Proton.
//
// Update an environment.
//
// If the environment is associated with an environment account connection,
// don't update or include the protonServiceRoleArn parameter to update or connect
// to an environment account connection.
//
// You can only update to a new environment account connection if it was created
// in the same environment account that the current environment account connection
// was created in and is associated with the current environment.
//
// If the environment isn't associated with an environment account connection,
// don't update or include the environmentAccountConnectionId parameter to update
// or connect to an environment account connection.
//
// You can update either the environmentAccountConnectionId or protonServiceRoleArn
// parameter and value. You can’t update both.
//
// There are four modes for updating an environment as described in the following.
// The deploymentType field defines the mode.
//
// NONE
//
// In this mode, a deployment doesn't occur. Only the requested metadata parameters
// are updated.
//
// CURRENT_VERSION
//
// In this mode, the environment is deployed and updated with the new spec that
// you provide. Only requested parameters are updated. Don’t include minor
// or major version parameters when you use this deployment-type.
//
// MINOR_VERSION
//
// In this mode, the environment is deployed and updated with the published,
// recommended (latest) minor version of the current major version in use, by
// default. You can also specify a different minor version of the current major
// version in use.
//
// MAJOR_VERSION
//
// In this mode, the environment is deployed and updated with the published,
// recommended (latest) major and minor version of the current template, by
// default. You can also specify a different major version that's higher than
// the major version in use and a minor version (optional).
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation UpdateEnvironment for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateEnvironment
func (c *Proton) UpdateEnvironment(input *UpdateEnvironmentInput) (*UpdateEnvironmentOutput, error) {
	req, out := c.UpdateEnvironmentRequest(input)
	return out, req.Send()
}

// UpdateEnvironmentWithContext is the same as UpdateEnvironment with the addition of
// the ability to pass a context and additional request options.
//
// See UpdateEnvironment for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) UpdateEnvironmentWithContext(ctx aws.Context, input *UpdateEnvironmentInput, opts ...request.Option) (*UpdateEnvironmentOutput, error) {
	req, out := c.UpdateEnvironmentRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opUpdateEnvironmentAccountConnection = "UpdateEnvironmentAccountConnection"

// UpdateEnvironmentAccountConnectionRequest generates a "aws/request.Request" representing the
// client's request for the UpdateEnvironmentAccountConnection operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See UpdateEnvironmentAccountConnection for more information on using the UpdateEnvironmentAccountConnection
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the UpdateEnvironmentAccountConnectionRequest method.
//    req, resp := client.UpdateEnvironmentAccountConnectionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateEnvironmentAccountConnection
func (c *Proton) UpdateEnvironmentAccountConnectionRequest(input *UpdateEnvironmentAccountConnectionInput) (req *request.Request, output *UpdateEnvironmentAccountConnectionOutput) {
	op := &request.Operation{
		Name:       opUpdateEnvironmentAccountConnection,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &UpdateEnvironmentAccountConnectionInput{}
	}

	output = &UpdateEnvironmentAccountConnectionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// UpdateEnvironmentAccountConnection API operation for AWS Proton.
//
// In an environment account, update an environment account connection to use
// a new IAM role.
//
// For more information, see Environment account connections (https://docs.aws.amazon.com/proton/latest/adminguide/ag-env-account-connections.html)
// in the AWS Proton Administrator guide.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation UpdateEnvironmentAccountConnection for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateEnvironmentAccountConnection
func (c *Proton) UpdateEnvironmentAccountConnection(input *UpdateEnvironmentAccountConnectionInput) (*UpdateEnvironmentAccountConnectionOutput, error) {
	req, out := c.UpdateEnvironmentAccountConnectionRequest(input)
	return out, req.Send()
}

// UpdateEnvironmentAccountConnectionWithContext is the same as UpdateEnvironmentAccountConnection with the addition of
// the ability to pass a context and additional request options.
//
// See UpdateEnvironmentAccountConnection for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) UpdateEnvironmentAccountConnectionWithContext(ctx aws.Context, input *UpdateEnvironmentAccountConnectionInput, opts ...request.Option) (*UpdateEnvironmentAccountConnectionOutput, error) {
	req, out := c.UpdateEnvironmentAccountConnectionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opUpdateEnvironmentTemplate = "UpdateEnvironmentTemplate"

// UpdateEnvironmentTemplateRequest generates a "aws/request.Request" representing the
// client's request for the UpdateEnvironmentTemplate operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See UpdateEnvironmentTemplate for more information on using the UpdateEnvironmentTemplate
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the UpdateEnvironmentTemplateRequest method.
//    req, resp := client.UpdateEnvironmentTemplateRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateEnvironmentTemplate
func (c *Proton) UpdateEnvironmentTemplateRequest(input *UpdateEnvironmentTemplateInput) (req *request.Request, output *UpdateEnvironmentTemplateOutput) {
	op := &request.Operation{
		Name:       opUpdateEnvironmentTemplate,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &UpdateEnvironmentTemplateInput{}
	}

	output = &UpdateEnvironmentTemplateOutput{}
	req = c.newRequest(op, input, output)
	return
}

// UpdateEnvironmentTemplate API operation for AWS Proton.
//
// Update an environment template.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation UpdateEnvironmentTemplate for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateEnvironmentTemplate
func (c *Proton) UpdateEnvironmentTemplate(input *UpdateEnvironmentTemplateInput) (*UpdateEnvironmentTemplateOutput, error) {
	req, out := c.UpdateEnvironmentTemplateRequest(input)
	return out, req.Send()
}

// UpdateEnvironmentTemplateWithContext is the same as UpdateEnvironmentTemplate with the addition of
// the ability to pass a context and additional request options.
//
// See UpdateEnvironmentTemplate for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) UpdateEnvironmentTemplateWithContext(ctx aws.Context, input *UpdateEnvironmentTemplateInput, opts ...request.Option) (*UpdateEnvironmentTemplateOutput, error) {
	req, out := c.UpdateEnvironmentTemplateRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opUpdateEnvironmentTemplateVersion = "UpdateEnvironmentTemplateVersion"

// UpdateEnvironmentTemplateVersionRequest generates a "aws/request.Request" representing the
// client's request for the UpdateEnvironmentTemplateVersion operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See UpdateEnvironmentTemplateVersion for more information on using the UpdateEnvironmentTemplateVersion
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the UpdateEnvironmentTemplateVersionRequest method.
//    req, resp := client.UpdateEnvironmentTemplateVersionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateEnvironmentTemplateVersion
func (c *Proton) UpdateEnvironmentTemplateVersionRequest(input *UpdateEnvironmentTemplateVersionInput) (req *request.Request, output *UpdateEnvironmentTemplateVersionOutput) {
	op := &request.Operation{
		Name:       opUpdateEnvironmentTemplateVersion,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &UpdateEnvironmentTemplateVersionInput{}
	}

	output = &UpdateEnvironmentTemplateVersionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// UpdateEnvironmentTemplateVersion API operation for AWS Proton.
//
// Update a major or minor version of an environment template.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation UpdateEnvironmentTemplateVersion for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateEnvironmentTemplateVersion
func (c *Proton) UpdateEnvironmentTemplateVersion(input *UpdateEnvironmentTemplateVersionInput) (*UpdateEnvironmentTemplateVersionOutput, error) {
	req, out := c.UpdateEnvironmentTemplateVersionRequest(input)
	return out, req.Send()
}

// UpdateEnvironmentTemplateVersionWithContext is the same as UpdateEnvironmentTemplateVersion with the addition of
// the ability to pass a context and additional request options.
//
// See UpdateEnvironmentTemplateVersion for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) UpdateEnvironmentTemplateVersionWithContext(ctx aws.Context, input *UpdateEnvironmentTemplateVersionInput, opts ...request.Option) (*UpdateEnvironmentTemplateVersionOutput, error) {
	req, out := c.UpdateEnvironmentTemplateVersionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opUpdateService = "UpdateService"

// UpdateServiceRequest generates a "aws/request.Request" representing the
// client's request for the UpdateService operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See UpdateService for more information on using the UpdateService
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the UpdateServiceRequest method.
//    req, resp := client.UpdateServiceRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateService
func (c *Proton) UpdateServiceRequest(input *UpdateServiceInput) (req *request.Request, output *UpdateServiceOutput) {
	op := &request.Operation{
		Name:       opUpdateService,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &UpdateServiceInput{}
	}

	output = &UpdateServiceOutput{}
	req = c.newRequest(op, input, output)
	return
}

// UpdateService API operation for AWS Proton.
//
// Edit a service description or use a spec to add and delete service instances.
//
// Existing service instances and the service pipeline can't be edited using
// this API. They can only be deleted.
//
// Use the description parameter to modify the description.
//
// Edit the spec parameter to add or delete instances.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation UpdateService for usage and error information.
//
// Returned Error Types:
//   * ServiceQuotaExceededException
//   A quota was exceeded. For more information, see AWS Proton Quotas (https://docs.aws.amazon.com/proton/latest/adminguide/ag-limits.html)
//   in the AWS Proton Administrator Guide.
//
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateService
func (c *Proton) UpdateService(input *UpdateServiceInput) (*UpdateServiceOutput, error) {
	req, out := c.UpdateServiceRequest(input)
	return out, req.Send()
}

// UpdateServiceWithContext is the same as UpdateService with the addition of
// the ability to pass a context and additional request options.
//
// See UpdateService for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) UpdateServiceWithContext(ctx aws.Context, input *UpdateServiceInput, opts ...request.Option) (*UpdateServiceOutput, error) {
	req, out := c.UpdateServiceRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opUpdateServiceInstance = "UpdateServiceInstance"

// UpdateServiceInstanceRequest generates a "aws/request.Request" representing the
// client's request for the UpdateServiceInstance operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See UpdateServiceInstance for more information on using the UpdateServiceInstance
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the UpdateServiceInstanceRequest method.
//    req, resp := client.UpdateServiceInstanceRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateServiceInstance
func (c *Proton) UpdateServiceInstanceRequest(input *UpdateServiceInstanceInput) (req *request.Request, output *UpdateServiceInstanceOutput) {
	op := &request.Operation{
		Name:       opUpdateServiceInstance,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &UpdateServiceInstanceInput{}
	}

	output = &UpdateServiceInstanceOutput{}
	req = c.newRequest(op, input, output)
	return
}

// UpdateServiceInstance API operation for AWS Proton.
//
// Update a service instance.
//
// There are four modes for updating a service instance as described in the
// following. The deploymentType field defines the mode.
//
// NONE
//
// In this mode, a deployment doesn't occur. Only the requested metadata parameters
// are updated.
//
// CURRENT_VERSION
//
// In this mode, the service instance is deployed and updated with the new spec
// that you provide. Only requested parameters are updated. Don’t include
// minor or major version parameters when you use this deployment-type.
//
// MINOR_VERSION
//
// In this mode, the service instance is deployed and updated with the published,
// recommended (latest) minor version of the current major version in use, by
// default. You can also specify a different minor version of the current major
// version in use.
//
// MAJOR_VERSION
//
// In this mode, the service instance is deployed and updated with the published,
// recommended (latest) major and minor version of the current template, by
// default. You can also specify a different major version that is higher than
// the major version in use and a minor version (optional).
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation UpdateServiceInstance for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateServiceInstance
func (c *Proton) UpdateServiceInstance(input *UpdateServiceInstanceInput) (*UpdateServiceInstanceOutput, error) {
	req, out := c.UpdateServiceInstanceRequest(input)
	return out, req.Send()
}

// UpdateServiceInstanceWithContext is the same as UpdateServiceInstance with the addition of
// the ability to pass a context and additional request options.
//
// See UpdateServiceInstance for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) UpdateServiceInstanceWithContext(ctx aws.Context, input *UpdateServiceInstanceInput, opts ...request.Option) (*UpdateServiceInstanceOutput, error) {
	req, out := c.UpdateServiceInstanceRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opUpdateServicePipeline = "UpdateServicePipeline"

// UpdateServicePipelineRequest generates a "aws/request.Request" representing the
// client's request for the UpdateServicePipeline operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See UpdateServicePipeline for more information on using the UpdateServicePipeline
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the UpdateServicePipelineRequest method.
//    req, resp := client.UpdateServicePipelineRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateServicePipeline
func (c *Proton) UpdateServicePipelineRequest(input *UpdateServicePipelineInput) (req *request.Request, output *UpdateServicePipelineOutput) {
	op := &request.Operation{
		Name:       opUpdateServicePipeline,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &UpdateServicePipelineInput{}
	}

	output = &UpdateServicePipelineOutput{}
	req = c.newRequest(op, input, output)
	return
}

// UpdateServicePipeline API operation for AWS Proton.
//
// Update the service pipeline.
//
// There are four modes for updating a service pipeline as described in the
// following. The deploymentType field defines the mode.
//
// NONE
//
// In this mode, a deployment doesn't occur. Only the requested metadata parameters
// are updated.
//
// CURRENT_VERSION
//
// In this mode, the service pipeline is deployed and updated with the new spec
// that you provide. Only requested parameters are updated. Don’t include
// minor or major version parameters when you use this deployment-type.
//
// MINOR_VERSION
//
// In this mode, the service pipeline is deployed and updated with the published,
// recommended (latest) minor version of the current major version in use, by
// default. You can also specify a different minor version of the current major
// version in use.
//
// MAJOR_VERSION
//
// In this mode, the service pipeline is deployed and updated with the published,
// recommended (latest) major and minor version of the current template by default.
// You can also specify a different major version that is higher than the major
// version in use and a minor version (optional).
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation UpdateServicePipeline for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateServicePipeline
func (c *Proton) UpdateServicePipeline(input *UpdateServicePipelineInput) (*UpdateServicePipelineOutput, error) {
	req, out := c.UpdateServicePipelineRequest(input)
	return out, req.Send()
}

// UpdateServicePipelineWithContext is the same as UpdateServicePipeline with the addition of
// the ability to pass a context and additional request options.
//
// See UpdateServicePipeline for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) UpdateServicePipelineWithContext(ctx aws.Context, input *UpdateServicePipelineInput, opts ...request.Option) (*UpdateServicePipelineOutput, error) {
	req, out := c.UpdateServicePipelineRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opUpdateServiceTemplate = "UpdateServiceTemplate"

// UpdateServiceTemplateRequest generates a "aws/request.Request" representing the
// client's request for the UpdateServiceTemplate operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See UpdateServiceTemplate for more information on using the UpdateServiceTemplate
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the UpdateServiceTemplateRequest method.
//    req, resp := client.UpdateServiceTemplateRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateServiceTemplate
func (c *Proton) UpdateServiceTemplateRequest(input *UpdateServiceTemplateInput) (req *request.Request, output *UpdateServiceTemplateOutput) {
	op := &request.Operation{
		Name:       opUpdateServiceTemplate,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &UpdateServiceTemplateInput{}
	}

	output = &UpdateServiceTemplateOutput{}
	req = c.newRequest(op, input, output)
	return
}

// UpdateServiceTemplate API operation for AWS Proton.
//
// Update a service template.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation UpdateServiceTemplate for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateServiceTemplate
func (c *Proton) UpdateServiceTemplate(input *UpdateServiceTemplateInput) (*UpdateServiceTemplateOutput, error) {
	req, out := c.UpdateServiceTemplateRequest(input)
	return out, req.Send()
}

// UpdateServiceTemplateWithContext is the same as UpdateServiceTemplate with the addition of
// the ability to pass a context and additional request options.
//
// See UpdateServiceTemplate for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) UpdateServiceTemplateWithContext(ctx aws.Context, input *UpdateServiceTemplateInput, opts ...request.Option) (*UpdateServiceTemplateOutput, error) {
	req, out := c.UpdateServiceTemplateRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

const opUpdateServiceTemplateVersion = "UpdateServiceTemplateVersion"

// UpdateServiceTemplateVersionRequest generates a "aws/request.Request" representing the
// client's request for the UpdateServiceTemplateVersion operation. The "output" return
// value will be populated with the request's response once the request completes
// successfully.
//
// Use "Send" method on the returned Request to send the API call to the service.
// the "output" return value is not valid until after Send returns without error.
//
// See UpdateServiceTemplateVersion for more information on using the UpdateServiceTemplateVersion
// API call, and error handling.
//
// This method is useful when you want to inject custom logic or configuration
// into the SDK's request lifecycle. Such as custom headers, or retry logic.
//
//
//    // Example sending a request using the UpdateServiceTemplateVersionRequest method.
//    req, resp := client.UpdateServiceTemplateVersionRequest(params)
//
//    err := req.Send()
//    if err == nil { // resp is now filled
//        fmt.Println(resp)
//    }
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateServiceTemplateVersion
func (c *Proton) UpdateServiceTemplateVersionRequest(input *UpdateServiceTemplateVersionInput) (req *request.Request, output *UpdateServiceTemplateVersionOutput) {
	op := &request.Operation{
		Name:       opUpdateServiceTemplateVersion,
		HTTPMethod: "POST",
		HTTPPath:   "/",
	}

	if input == nil {
		input = &UpdateServiceTemplateVersionInput{}
	}

	output = &UpdateServiceTemplateVersionOutput{}
	req = c.newRequest(op, input, output)
	return
}

// UpdateServiceTemplateVersion API operation for AWS Proton.
//
// Update a major or minor version of a service template.
//
// Returns awserr.Error for service API and SDK errors. Use runtime type assertions
// with awserr.Error's Code and Message methods to get detailed information about
// the error.
//
// See the AWS API reference guide for AWS Proton's
// API operation UpdateServiceTemplateVersion for usage and error information.
//
// Returned Error Types:
//   * ValidationException
//   The input is invalid or an out-of-range value was supplied for the input
//   parameter.
//
//   * AccessDeniedException
//   There isn't sufficient access for performing this action.
//
//   * ThrottlingException
//   The request was denied due to request throttling.
//
//   * ConflictException
//   The request couldn't be made due to a conflicting operation or resource.
//
//   * ResourceNotFoundException
//   The requested resource wasn't found.
//
//   * InternalServerException
//   The request failed to register with the service.
//
// See also, https://docs.aws.amazon.com/goto/WebAPI/proton-2020-07-20/UpdateServiceTemplateVersion
func (c *Proton) UpdateServiceTemplateVersion(input *UpdateServiceTemplateVersionInput) (*UpdateServiceTemplateVersionOutput, error) {
	req, out := c.UpdateServiceTemplateVersionRequest(input)
	return out, req.Send()
}

// UpdateServiceTemplateVersionWithContext is the same as UpdateServiceTemplateVersion with the addition of
// the ability to pass a context and additional request options.
//
// See UpdateServiceTemplateVersion for details on how to use this API operation.
//
// The context must be non-nil and will be used for request cancellation. If
// the context is nil a panic will occur. In the future the SDK may create
// sub-contexts for http.Requests. See https://golang.org/pkg/context/
// for more information on using Contexts.
func (c *Proton) UpdateServiceTemplateVersionWithContext(ctx aws.Context, input *UpdateServiceTemplateVersionInput, opts ...request.Option) (*UpdateServiceTemplateVersionOutput, error) {
	req, out := c.UpdateServiceTemplateVersionRequest(input)
	req.SetContext(ctx)
	req.ApplyOptions(opts...)
	return out, req.Send()
}

type AcceptEnvironmentAccountConnectionInput struct {
	_ struct{} `type:"structure"`

	// The ID of the environment account connection.
	//
	// Id is a required field
	Id *string `locationName:"id" type:"string" required:"true"`
}

// String returns the string representation
func (s AcceptEnvironmentAccountConnectionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s AcceptEnvironmentAccountConnectionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *AcceptEnvironmentAccountConnectionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "AcceptEnvironmentAccountConnectionInput"}
	if s.Id == nil {
		invalidParams.Add(request.NewErrParamRequired("Id"))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetId sets the Id field's value.
func (s *AcceptEnvironmentAccountConnectionInput) SetId(v string) *AcceptEnvironmentAccountConnectionInput {
	s.Id = &v
	return s
}

type AcceptEnvironmentAccountConnectionOutput struct {
	_ struct{} `type:"structure"`

	// The environment account connection data that's returned by AWS Proton.
	//
	// EnvironmentAccountConnection is a required field
	EnvironmentAccountConnection *EnvironmentAccountConnection `locationName:"environmentAccountConnection" type:"structure" required:"true"`
}

// String returns the string representation
func (s AcceptEnvironmentAccountConnectionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s AcceptEnvironmentAccountConnectionOutput) GoString() string {
	return s.String()
}

// SetEnvironmentAccountConnection sets the EnvironmentAccountConnection field's value.
func (s *AcceptEnvironmentAccountConnectionOutput) SetEnvironmentAccountConnection(v *EnvironmentAccountConnection) *AcceptEnvironmentAccountConnectionOutput {
	s.EnvironmentAccountConnection = v
	return s
}

// There isn't sufficient access for performing this action.
type AccessDeniedException struct {
	_            struct{}                  `type:"structure"`
	RespMetadata protocol.ResponseMetadata `json:"-" xml:"-"`

	Message_ *string `locationName:"message" type:"string" sensitive:"true"`
}

// String returns the string representation
func (s AccessDeniedException) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s AccessDeniedException) GoString() string {
	return s.String()
}

func newErrorAccessDeniedException(v protocol.ResponseMetadata) error {
	return &AccessDeniedException{
		RespMetadata: v,
	}
}

// Code returns the exception type name.
func (s *AccessDeniedException) Code() string {
	return "AccessDeniedException"
}

// Message returns the exception's message.
func (s *AccessDeniedException) Message() string {
	if s.Message_ != nil {
		return *s.Message_
	}
	return ""
}

// OrigErr always returns nil, satisfies awserr.Error interface.
func (s *AccessDeniedException) OrigErr() error {
	return nil
}

func (s *AccessDeniedException) Error() string {
	return fmt.Sprintf("%s: %s", s.Code(), s.Message())
}

// Status code returns the HTTP status code for the request's response error.
func (s *AccessDeniedException) StatusCode() int {
	return s.RespMetadata.StatusCode
}

// RequestID returns the service's response RequestID for request.
func (s *AccessDeniedException) RequestID() string {
	return s.RespMetadata.RequestID
}

// The AWS Proton pipeline service role data.
type AccountSettings struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the AWS Proton pipeline service role.
	PipelineServiceRoleArn *string `locationName:"pipelineServiceRoleArn" min:"1" type:"string"`
}

// String returns the string representation
func (s AccountSettings) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s AccountSettings) GoString() string {
	return s.String()
}

// SetPipelineServiceRoleArn sets the PipelineServiceRoleArn field's value.
func (s *AccountSettings) SetPipelineServiceRoleArn(v string) *AccountSettings {
	s.PipelineServiceRoleArn = &v
	return s
}

type CancelEnvironmentDeploymentInput struct {
	_ struct{} `type:"structure"`

	// The name of the environment with the deployment to cancel.
	//
	// EnvironmentName is a required field
	EnvironmentName *string `locationName:"environmentName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s CancelEnvironmentDeploymentInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CancelEnvironmentDeploymentInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *CancelEnvironmentDeploymentInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "CancelEnvironmentDeploymentInput"}
	if s.EnvironmentName == nil {
		invalidParams.Add(request.NewErrParamRequired("EnvironmentName"))
	}
	if s.EnvironmentName != nil && len(*s.EnvironmentName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("EnvironmentName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetEnvironmentName sets the EnvironmentName field's value.
func (s *CancelEnvironmentDeploymentInput) SetEnvironmentName(v string) *CancelEnvironmentDeploymentInput {
	s.EnvironmentName = &v
	return s
}

type CancelEnvironmentDeploymentOutput struct {
	_ struct{} `type:"structure"`

	// The environment summary data that's returned by AWS Proton.
	//
	// Environment is a required field
	Environment *Environment `locationName:"environment" type:"structure" required:"true"`
}

// String returns the string representation
func (s CancelEnvironmentDeploymentOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CancelEnvironmentDeploymentOutput) GoString() string {
	return s.String()
}

// SetEnvironment sets the Environment field's value.
func (s *CancelEnvironmentDeploymentOutput) SetEnvironment(v *Environment) *CancelEnvironmentDeploymentOutput {
	s.Environment = v
	return s
}

type CancelServiceInstanceDeploymentInput struct {
	_ struct{} `type:"structure"`

	// The name of the service instance with the deployment to cancel.
	//
	// ServiceInstanceName is a required field
	ServiceInstanceName *string `locationName:"serviceInstanceName" min:"1" type:"string" required:"true"`

	// The name of the service with the service instance deployment to cancel.
	//
	// ServiceName is a required field
	ServiceName *string `locationName:"serviceName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s CancelServiceInstanceDeploymentInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CancelServiceInstanceDeploymentInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *CancelServiceInstanceDeploymentInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "CancelServiceInstanceDeploymentInput"}
	if s.ServiceInstanceName == nil {
		invalidParams.Add(request.NewErrParamRequired("ServiceInstanceName"))
	}
	if s.ServiceInstanceName != nil && len(*s.ServiceInstanceName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ServiceInstanceName", 1))
	}
	if s.ServiceName == nil {
		invalidParams.Add(request.NewErrParamRequired("ServiceName"))
	}
	if s.ServiceName != nil && len(*s.ServiceName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ServiceName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetServiceInstanceName sets the ServiceInstanceName field's value.
func (s *CancelServiceInstanceDeploymentInput) SetServiceInstanceName(v string) *CancelServiceInstanceDeploymentInput {
	s.ServiceInstanceName = &v
	return s
}

// SetServiceName sets the ServiceName field's value.
func (s *CancelServiceInstanceDeploymentInput) SetServiceName(v string) *CancelServiceInstanceDeploymentInput {
	s.ServiceName = &v
	return s
}

type CancelServiceInstanceDeploymentOutput struct {
	_ struct{} `type:"structure"`

	// The service instance summary data that's returned by AWS Proton.
	//
	// ServiceInstance is a required field
	ServiceInstance *ServiceInstance `locationName:"serviceInstance" type:"structure" required:"true"`
}

// String returns the string representation
func (s CancelServiceInstanceDeploymentOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CancelServiceInstanceDeploymentOutput) GoString() string {
	return s.String()
}

// SetServiceInstance sets the ServiceInstance field's value.
func (s *CancelServiceInstanceDeploymentOutput) SetServiceInstance(v *ServiceInstance) *CancelServiceInstanceDeploymentOutput {
	s.ServiceInstance = v
	return s
}

type CancelServicePipelineDeploymentInput struct {
	_ struct{} `type:"structure"`

	// The name of the service with the service pipeline deployment to cancel.
	//
	// ServiceName is a required field
	ServiceName *string `locationName:"serviceName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s CancelServicePipelineDeploymentInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CancelServicePipelineDeploymentInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *CancelServicePipelineDeploymentInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "CancelServicePipelineDeploymentInput"}
	if s.ServiceName == nil {
		invalidParams.Add(request.NewErrParamRequired("ServiceName"))
	}
	if s.ServiceName != nil && len(*s.ServiceName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ServiceName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetServiceName sets the ServiceName field's value.
func (s *CancelServicePipelineDeploymentInput) SetServiceName(v string) *CancelServicePipelineDeploymentInput {
	s.ServiceName = &v
	return s
}

type CancelServicePipelineDeploymentOutput struct {
	_ struct{} `type:"structure"`

	// The service pipeline detail data that's returned by AWS Proton.
	//
	// Pipeline is a required field
	Pipeline *ServicePipeline `locationName:"pipeline" type:"structure" required:"true"`
}

// String returns the string representation
func (s CancelServicePipelineDeploymentOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CancelServicePipelineDeploymentOutput) GoString() string {
	return s.String()
}

// SetPipeline sets the Pipeline field's value.
func (s *CancelServicePipelineDeploymentOutput) SetPipeline(v *ServicePipeline) *CancelServicePipelineDeploymentOutput {
	s.Pipeline = v
	return s
}

// Compatible environment template data.
type CompatibleEnvironmentTemplate struct {
	_ struct{} `type:"structure"`

	// The major version of the compatible environment template.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// The compatible environment template name.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s CompatibleEnvironmentTemplate) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CompatibleEnvironmentTemplate) GoString() string {
	return s.String()
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *CompatibleEnvironmentTemplate) SetMajorVersion(v string) *CompatibleEnvironmentTemplate {
	s.MajorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *CompatibleEnvironmentTemplate) SetTemplateName(v string) *CompatibleEnvironmentTemplate {
	s.TemplateName = &v
	return s
}

// Compatible environment template data.
type CompatibleEnvironmentTemplateInput struct {
	_ struct{} `type:"structure"`

	// The major version of the compatible environment template.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// The compatible environment template name.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s CompatibleEnvironmentTemplateInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CompatibleEnvironmentTemplateInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *CompatibleEnvironmentTemplateInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "CompatibleEnvironmentTemplateInput"}
	if s.MajorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MajorVersion"))
	}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *CompatibleEnvironmentTemplateInput) SetMajorVersion(v string) *CompatibleEnvironmentTemplateInput {
	s.MajorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *CompatibleEnvironmentTemplateInput) SetTemplateName(v string) *CompatibleEnvironmentTemplateInput {
	s.TemplateName = &v
	return s
}

// The request couldn't be made due to a conflicting operation or resource.
type ConflictException struct {
	_            struct{}                  `type:"structure"`
	RespMetadata protocol.ResponseMetadata `json:"-" xml:"-"`

	Message_ *string `locationName:"message" type:"string" sensitive:"true"`
}

// String returns the string representation
func (s ConflictException) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ConflictException) GoString() string {
	return s.String()
}

func newErrorConflictException(v protocol.ResponseMetadata) error {
	return &ConflictException{
		RespMetadata: v,
	}
}

// Code returns the exception type name.
func (s *ConflictException) Code() string {
	return "ConflictException"
}

// Message returns the exception's message.
func (s *ConflictException) Message() string {
	if s.Message_ != nil {
		return *s.Message_
	}
	return ""
}

// OrigErr always returns nil, satisfies awserr.Error interface.
func (s *ConflictException) OrigErr() error {
	return nil
}

func (s *ConflictException) Error() string {
	return fmt.Sprintf("%s: %s", s.Code(), s.Message())
}

// Status code returns the HTTP status code for the request's response error.
func (s *ConflictException) StatusCode() int {
	return s.RespMetadata.StatusCode
}

// RequestID returns the service's response RequestID for request.
func (s *ConflictException) RequestID() string {
	return s.RespMetadata.RequestID
}

type CreateEnvironmentAccountConnectionInput struct {
	_ struct{} `type:"structure"`

	// When included, if two identicial requests are made with the same client token,
	// AWS Proton returns the environment account connection that the first request
	// created.
	ClientToken *string `locationName:"clientToken" type:"string" idempotencyToken:"true"`

	// The name of the AWS Proton environment that's created in the associated management
	// account.
	//
	// EnvironmentName is a required field
	EnvironmentName *string `locationName:"environmentName" min:"1" type:"string" required:"true"`

	// The ID of the management account that accepts or rejects the environment
	// account connection. You create an manage the AWS Proton environment in this
	// account. If the management account accepts the environment account connection,
	// AWS Proton can use the associated IAM role to provision environment infrastructure
	// resources in the associated environment account.
	//
	// ManagementAccountId is a required field
	ManagementAccountId *string `locationName:"managementAccountId" type:"string" required:"true"`

	// The Amazon Resource Name (ARN) of the IAM service role that's created in
	// the environment account. AWS Proton uses this role to provision infrastructure
	// resources in the associated environment account.
	//
	// RoleArn is a required field
	RoleArn *string `locationName:"roleArn" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s CreateEnvironmentAccountConnectionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateEnvironmentAccountConnectionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *CreateEnvironmentAccountConnectionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "CreateEnvironmentAccountConnectionInput"}
	if s.EnvironmentName == nil {
		invalidParams.Add(request.NewErrParamRequired("EnvironmentName"))
	}
	if s.EnvironmentName != nil && len(*s.EnvironmentName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("EnvironmentName", 1))
	}
	if s.ManagementAccountId == nil {
		invalidParams.Add(request.NewErrParamRequired("ManagementAccountId"))
	}
	if s.RoleArn == nil {
		invalidParams.Add(request.NewErrParamRequired("RoleArn"))
	}
	if s.RoleArn != nil && len(*s.RoleArn) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("RoleArn", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetClientToken sets the ClientToken field's value.
func (s *CreateEnvironmentAccountConnectionInput) SetClientToken(v string) *CreateEnvironmentAccountConnectionInput {
	s.ClientToken = &v
	return s
}

// SetEnvironmentName sets the EnvironmentName field's value.
func (s *CreateEnvironmentAccountConnectionInput) SetEnvironmentName(v string) *CreateEnvironmentAccountConnectionInput {
	s.EnvironmentName = &v
	return s
}

// SetManagementAccountId sets the ManagementAccountId field's value.
func (s *CreateEnvironmentAccountConnectionInput) SetManagementAccountId(v string) *CreateEnvironmentAccountConnectionInput {
	s.ManagementAccountId = &v
	return s
}

// SetRoleArn sets the RoleArn field's value.
func (s *CreateEnvironmentAccountConnectionInput) SetRoleArn(v string) *CreateEnvironmentAccountConnectionInput {
	s.RoleArn = &v
	return s
}

type CreateEnvironmentAccountConnectionOutput struct {
	_ struct{} `type:"structure"`

	// The environment account connection detail data that's returned by AWS Proton.
	//
	// EnvironmentAccountConnection is a required field
	EnvironmentAccountConnection *EnvironmentAccountConnection `locationName:"environmentAccountConnection" type:"structure" required:"true"`
}

// String returns the string representation
func (s CreateEnvironmentAccountConnectionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateEnvironmentAccountConnectionOutput) GoString() string {
	return s.String()
}

// SetEnvironmentAccountConnection sets the EnvironmentAccountConnection field's value.
func (s *CreateEnvironmentAccountConnectionOutput) SetEnvironmentAccountConnection(v *EnvironmentAccountConnection) *CreateEnvironmentAccountConnectionOutput {
	s.EnvironmentAccountConnection = v
	return s
}

type CreateEnvironmentInput struct {
	_ struct{} `type:"structure"`

	// A description of the environment that's being created and deployed.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The ID of the environment account connection that you provide if you're provisioning
	// your environment infrastructure resources to an environment account. You
	// must include either the environmentAccountConnectionId or protonServiceRoleArn
	// parameter and value. For more information, see Environment account connections
	// (https://docs.aws.amazon.com/proton/latest/adminguide/ag-env-account-connections.html)
	// in the AWS Proton Administrator guide.
	EnvironmentAccountConnectionId *string `locationName:"environmentAccountConnectionId" type:"string"`

	// The name of the environment.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// The Amazon Resource Name (ARN) of the AWS Proton service role that allows
	// AWS Proton to make calls to other services on your behalf. You must include
	// either the environmentAccountConnectionId or protonServiceRoleArn parameter
	// and value.
	ProtonServiceRoleArn *string `locationName:"protonServiceRoleArn" min:"1" type:"string"`

	// A link to a YAML formatted spec file that provides inputs as defined in the
	// environment template bundle schema file. For more information, see Environments
	// (https://docs.aws.amazon.com/proton/latest/adminguide/ag-environments.html)
	// in the AWS Proton Administrator Guide.
	//
	// Spec is a required field
	Spec *string `locationName:"spec" min:"1" type:"string" required:"true" sensitive:"true"`

	// Create tags for your environment. For more information, see AWS Proton resources
	// and tagging in the AWS Proton Administrator Guide (https://docs.aws.amazon.com/proton/latest/adminguide/resources.html)
	// or AWS Proton User Guide (https://docs.aws.amazon.com/proton/latest/userguide/resources.html).
	Tags []*Tag `locationName:"tags" type:"list"`

	// The ID of the major version of the environment template.
	//
	// TemplateMajorVersion is a required field
	TemplateMajorVersion *string `locationName:"templateMajorVersion" min:"1" type:"string" required:"true"`

	// The ID of the minor version of the environment template.
	TemplateMinorVersion *string `locationName:"templateMinorVersion" min:"1" type:"string"`

	// The name of the environment template. For more information, see Environment
	// Templates (https://docs.aws.amazon.com/proton/latest/adminguide/ag-templates.html)
	// in the AWS Proton Administrator Guide.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s CreateEnvironmentInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateEnvironmentInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *CreateEnvironmentInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "CreateEnvironmentInput"}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}
	if s.ProtonServiceRoleArn != nil && len(*s.ProtonServiceRoleArn) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ProtonServiceRoleArn", 1))
	}
	if s.Spec == nil {
		invalidParams.Add(request.NewErrParamRequired("Spec"))
	}
	if s.Spec != nil && len(*s.Spec) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Spec", 1))
	}
	if s.TemplateMajorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateMajorVersion"))
	}
	if s.TemplateMajorVersion != nil && len(*s.TemplateMajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateMajorVersion", 1))
	}
	if s.TemplateMinorVersion != nil && len(*s.TemplateMinorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateMinorVersion", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}
	if s.Tags != nil {
		for i, v := range s.Tags {
			if v == nil {
				continue
			}
			if err := v.Validate(); err != nil {
				invalidParams.AddNested(fmt.Sprintf("%s[%v]", "Tags", i), err.(request.ErrInvalidParams))
			}
		}
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetDescription sets the Description field's value.
func (s *CreateEnvironmentInput) SetDescription(v string) *CreateEnvironmentInput {
	s.Description = &v
	return s
}

// SetEnvironmentAccountConnectionId sets the EnvironmentAccountConnectionId field's value.
func (s *CreateEnvironmentInput) SetEnvironmentAccountConnectionId(v string) *CreateEnvironmentInput {
	s.EnvironmentAccountConnectionId = &v
	return s
}

// SetName sets the Name field's value.
func (s *CreateEnvironmentInput) SetName(v string) *CreateEnvironmentInput {
	s.Name = &v
	return s
}

// SetProtonServiceRoleArn sets the ProtonServiceRoleArn field's value.
func (s *CreateEnvironmentInput) SetProtonServiceRoleArn(v string) *CreateEnvironmentInput {
	s.ProtonServiceRoleArn = &v
	return s
}

// SetSpec sets the Spec field's value.
func (s *CreateEnvironmentInput) SetSpec(v string) *CreateEnvironmentInput {
	s.Spec = &v
	return s
}

// SetTags sets the Tags field's value.
func (s *CreateEnvironmentInput) SetTags(v []*Tag) *CreateEnvironmentInput {
	s.Tags = v
	return s
}

// SetTemplateMajorVersion sets the TemplateMajorVersion field's value.
func (s *CreateEnvironmentInput) SetTemplateMajorVersion(v string) *CreateEnvironmentInput {
	s.TemplateMajorVersion = &v
	return s
}

// SetTemplateMinorVersion sets the TemplateMinorVersion field's value.
func (s *CreateEnvironmentInput) SetTemplateMinorVersion(v string) *CreateEnvironmentInput {
	s.TemplateMinorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *CreateEnvironmentInput) SetTemplateName(v string) *CreateEnvironmentInput {
	s.TemplateName = &v
	return s
}

type CreateEnvironmentOutput struct {
	_ struct{} `type:"structure"`

	// The environment detail data that's returned by AWS Proton.
	//
	// Environment is a required field
	Environment *Environment `locationName:"environment" type:"structure" required:"true"`
}

// String returns the string representation
func (s CreateEnvironmentOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateEnvironmentOutput) GoString() string {
	return s.String()
}

// SetEnvironment sets the Environment field's value.
func (s *CreateEnvironmentOutput) SetEnvironment(v *Environment) *CreateEnvironmentOutput {
	s.Environment = v
	return s
}

type CreateEnvironmentTemplateInput struct {
	_ struct{} `type:"structure"`

	// A description of the environment template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The environment template name as displayed in the developer interface.
	DisplayName *string `locationName:"displayName" min:"1" type:"string" sensitive:"true"`

	// A customer provided encryption key that AWS Proton uses to encrypt data.
	EncryptionKey *string `locationName:"encryptionKey" min:"1" type:"string"`

	// The name of the environment template.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// When included, indicates that the environment template is for customer provisioned
	// and managed infrastructure.
	Provisioning *string `locationName:"provisioning" type:"string" enum:"Provisioning"`

	// Create tags for your environment template. For more information, see AWS
	// Proton resources and tagging in the AWS Proton Administrator Guide (https://docs.aws.amazon.com/proton/latest/adminguide/resources.html)
	// or AWS Proton User Guide (https://docs.aws.amazon.com/proton/latest/userguide/resources.html).
	Tags []*Tag `locationName:"tags" type:"list"`
}

// String returns the string representation
func (s CreateEnvironmentTemplateInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateEnvironmentTemplateInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *CreateEnvironmentTemplateInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "CreateEnvironmentTemplateInput"}
	if s.DisplayName != nil && len(*s.DisplayName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("DisplayName", 1))
	}
	if s.EncryptionKey != nil && len(*s.EncryptionKey) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("EncryptionKey", 1))
	}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}
	if s.Tags != nil {
		for i, v := range s.Tags {
			if v == nil {
				continue
			}
			if err := v.Validate(); err != nil {
				invalidParams.AddNested(fmt.Sprintf("%s[%v]", "Tags", i), err.(request.ErrInvalidParams))
			}
		}
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetDescription sets the Description field's value.
func (s *CreateEnvironmentTemplateInput) SetDescription(v string) *CreateEnvironmentTemplateInput {
	s.Description = &v
	return s
}

// SetDisplayName sets the DisplayName field's value.
func (s *CreateEnvironmentTemplateInput) SetDisplayName(v string) *CreateEnvironmentTemplateInput {
	s.DisplayName = &v
	return s
}

// SetEncryptionKey sets the EncryptionKey field's value.
func (s *CreateEnvironmentTemplateInput) SetEncryptionKey(v string) *CreateEnvironmentTemplateInput {
	s.EncryptionKey = &v
	return s
}

// SetName sets the Name field's value.
func (s *CreateEnvironmentTemplateInput) SetName(v string) *CreateEnvironmentTemplateInput {
	s.Name = &v
	return s
}

// SetProvisioning sets the Provisioning field's value.
func (s *CreateEnvironmentTemplateInput) SetProvisioning(v string) *CreateEnvironmentTemplateInput {
	s.Provisioning = &v
	return s
}

// SetTags sets the Tags field's value.
func (s *CreateEnvironmentTemplateInput) SetTags(v []*Tag) *CreateEnvironmentTemplateInput {
	s.Tags = v
	return s
}

type CreateEnvironmentTemplateOutput struct {
	_ struct{} `type:"structure"`

	// The environment template detail data that's returned by AWS Proton.
	//
	// EnvironmentTemplate is a required field
	EnvironmentTemplate *EnvironmentTemplate `locationName:"environmentTemplate" type:"structure" required:"true"`
}

// String returns the string representation
func (s CreateEnvironmentTemplateOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateEnvironmentTemplateOutput) GoString() string {
	return s.String()
}

// SetEnvironmentTemplate sets the EnvironmentTemplate field's value.
func (s *CreateEnvironmentTemplateOutput) SetEnvironmentTemplate(v *EnvironmentTemplate) *CreateEnvironmentTemplateOutput {
	s.EnvironmentTemplate = v
	return s
}

type CreateEnvironmentTemplateVersionInput struct {
	_ struct{} `type:"structure"`

	// When included, if two identicial requests are made with the same client token,
	// AWS Proton returns the environment template version that the first request
	// created.
	ClientToken *string `locationName:"clientToken" type:"string" idempotencyToken:"true"`

	// A description of the new version of an environment template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// To create a new minor version of the environment template, include a majorVersion.
	//
	// To create a new major and minor version of the environment template, exclude
	// majorVersion.
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string"`

	// An object that includes the template bundle S3 bucket path and name for the
	// new version of an template.
	//
	// Source is a required field
	Source *TemplateVersionSourceInput `locationName:"source" type:"structure" required:"true"`

	// Create tags for a new version of an environment template.
	Tags []*Tag `locationName:"tags" type:"list"`

	// The name of the environment template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s CreateEnvironmentTemplateVersionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateEnvironmentTemplateVersionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *CreateEnvironmentTemplateVersionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "CreateEnvironmentTemplateVersionInput"}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.Source == nil {
		invalidParams.Add(request.NewErrParamRequired("Source"))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}
	if s.Source != nil {
		if err := s.Source.Validate(); err != nil {
			invalidParams.AddNested("Source", err.(request.ErrInvalidParams))
		}
	}
	if s.Tags != nil {
		for i, v := range s.Tags {
			if v == nil {
				continue
			}
			if err := v.Validate(); err != nil {
				invalidParams.AddNested(fmt.Sprintf("%s[%v]", "Tags", i), err.(request.ErrInvalidParams))
			}
		}
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetClientToken sets the ClientToken field's value.
func (s *CreateEnvironmentTemplateVersionInput) SetClientToken(v string) *CreateEnvironmentTemplateVersionInput {
	s.ClientToken = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *CreateEnvironmentTemplateVersionInput) SetDescription(v string) *CreateEnvironmentTemplateVersionInput {
	s.Description = &v
	return s
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *CreateEnvironmentTemplateVersionInput) SetMajorVersion(v string) *CreateEnvironmentTemplateVersionInput {
	s.MajorVersion = &v
	return s
}

// SetSource sets the Source field's value.
func (s *CreateEnvironmentTemplateVersionInput) SetSource(v *TemplateVersionSourceInput) *CreateEnvironmentTemplateVersionInput {
	s.Source = v
	return s
}

// SetTags sets the Tags field's value.
func (s *CreateEnvironmentTemplateVersionInput) SetTags(v []*Tag) *CreateEnvironmentTemplateVersionInput {
	s.Tags = v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *CreateEnvironmentTemplateVersionInput) SetTemplateName(v string) *CreateEnvironmentTemplateVersionInput {
	s.TemplateName = &v
	return s
}

type CreateEnvironmentTemplateVersionOutput struct {
	_ struct{} `type:"structure"`

	// The environment template detail data that's returned by AWS Proton.
	//
	// EnvironmentTemplateVersion is a required field
	EnvironmentTemplateVersion *EnvironmentTemplateVersion `locationName:"environmentTemplateVersion" type:"structure" required:"true"`
}

// String returns the string representation
func (s CreateEnvironmentTemplateVersionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateEnvironmentTemplateVersionOutput) GoString() string {
	return s.String()
}

// SetEnvironmentTemplateVersion sets the EnvironmentTemplateVersion field's value.
func (s *CreateEnvironmentTemplateVersionOutput) SetEnvironmentTemplateVersion(v *EnvironmentTemplateVersion) *CreateEnvironmentTemplateVersionOutput {
	s.EnvironmentTemplateVersion = v
	return s
}

type CreateServiceInput struct {
	_ struct{} `type:"structure"`

	// The name of the code repository branch that holds the code that's deployed
	// in AWS Proton. Don't include this parameter if your service template doesn't
	// include a service pipeline.
	BranchName *string `locationName:"branchName" min:"1" type:"string"`

	// A description of the AWS Proton service.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The service name.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// The Amazon Resource Name (ARN) of the repository connection. For more information,
	// see Set up repository connection (https://docs.aws.amazon.com/proton/latest/adminguide/setting-up-for-service.html#setting-up-vcontrol)
	// in the AWS Proton Administrator Guide and Setting up with AWS Proton (https://docs.aws.amazon.com/proton/latest/userguide/proton-setup.html#setup-repo-connection)
	// in the AWS Proton User Guide. Don't include this parameter if your service
	// template doesn't include a service pipeline.
	RepositoryConnectionArn *string `locationName:"repositoryConnectionArn" min:"1" type:"string"`

	// The ID of the code repository. Don't include this parameter if your service
	// template doesn't include a service pipeline.
	RepositoryId *string `locationName:"repositoryId" min:"1" type:"string"`

	// A link to a spec file that provides inputs as defined in the service template
	// bundle schema file. The spec file is in YAML format. Don’t include pipeline
	// inputs in the spec if your service template doesn’t include a service pipeline.
	// For more information, see Create a service (https://docs.aws.amazon.com/proton/latest/adminguide/ag-create-svc.html.html)
	// in the AWS Proton Administrator Guide and Create a service (https://docs.aws.amazon.com/proton/latest/userguide/ug-svc-create.html)
	// in the AWS Proton User Guide.
	//
	// Spec is a required field
	Spec *string `locationName:"spec" min:"1" type:"string" required:"true" sensitive:"true"`

	// Create tags for your service. For more information, see AWS Proton resources
	// and tagging in the AWS Proton Administrator Guide (https://docs.aws.amazon.com/proton/latest/adminguide/resources.html)
	// or AWS Proton User Guide (https://docs.aws.amazon.com/proton/latest/userguide/resources.html).
	Tags []*Tag `locationName:"tags" type:"list"`

	// The ID of the major version of the service template that was used to create
	// the service.
	//
	// TemplateMajorVersion is a required field
	TemplateMajorVersion *string `locationName:"templateMajorVersion" min:"1" type:"string" required:"true"`

	// The ID of the minor version of the service template that was used to create
	// the service.
	TemplateMinorVersion *string `locationName:"templateMinorVersion" min:"1" type:"string"`

	// The name of the service template that's used to create the service.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s CreateServiceInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateServiceInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *CreateServiceInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "CreateServiceInput"}
	if s.BranchName != nil && len(*s.BranchName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("BranchName", 1))
	}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}
	if s.RepositoryConnectionArn != nil && len(*s.RepositoryConnectionArn) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("RepositoryConnectionArn", 1))
	}
	if s.RepositoryId != nil && len(*s.RepositoryId) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("RepositoryId", 1))
	}
	if s.Spec == nil {
		invalidParams.Add(request.NewErrParamRequired("Spec"))
	}
	if s.Spec != nil && len(*s.Spec) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Spec", 1))
	}
	if s.TemplateMajorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateMajorVersion"))
	}
	if s.TemplateMajorVersion != nil && len(*s.TemplateMajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateMajorVersion", 1))
	}
	if s.TemplateMinorVersion != nil && len(*s.TemplateMinorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateMinorVersion", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}
	if s.Tags != nil {
		for i, v := range s.Tags {
			if v == nil {
				continue
			}
			if err := v.Validate(); err != nil {
				invalidParams.AddNested(fmt.Sprintf("%s[%v]", "Tags", i), err.(request.ErrInvalidParams))
			}
		}
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetBranchName sets the BranchName field's value.
func (s *CreateServiceInput) SetBranchName(v string) *CreateServiceInput {
	s.BranchName = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *CreateServiceInput) SetDescription(v string) *CreateServiceInput {
	s.Description = &v
	return s
}

// SetName sets the Name field's value.
func (s *CreateServiceInput) SetName(v string) *CreateServiceInput {
	s.Name = &v
	return s
}

// SetRepositoryConnectionArn sets the RepositoryConnectionArn field's value.
func (s *CreateServiceInput) SetRepositoryConnectionArn(v string) *CreateServiceInput {
	s.RepositoryConnectionArn = &v
	return s
}

// SetRepositoryId sets the RepositoryId field's value.
func (s *CreateServiceInput) SetRepositoryId(v string) *CreateServiceInput {
	s.RepositoryId = &v
	return s
}

// SetSpec sets the Spec field's value.
func (s *CreateServiceInput) SetSpec(v string) *CreateServiceInput {
	s.Spec = &v
	return s
}

// SetTags sets the Tags field's value.
func (s *CreateServiceInput) SetTags(v []*Tag) *CreateServiceInput {
	s.Tags = v
	return s
}

// SetTemplateMajorVersion sets the TemplateMajorVersion field's value.
func (s *CreateServiceInput) SetTemplateMajorVersion(v string) *CreateServiceInput {
	s.TemplateMajorVersion = &v
	return s
}

// SetTemplateMinorVersion sets the TemplateMinorVersion field's value.
func (s *CreateServiceInput) SetTemplateMinorVersion(v string) *CreateServiceInput {
	s.TemplateMinorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *CreateServiceInput) SetTemplateName(v string) *CreateServiceInput {
	s.TemplateName = &v
	return s
}

type CreateServiceOutput struct {
	_ struct{} `type:"structure"`

	// The service detail data that's returned by AWS Proton.
	//
	// Service is a required field
	Service *Service `locationName:"service" type:"structure" required:"true"`
}

// String returns the string representation
func (s CreateServiceOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateServiceOutput) GoString() string {
	return s.String()
}

// SetService sets the Service field's value.
func (s *CreateServiceOutput) SetService(v *Service) *CreateServiceOutput {
	s.Service = v
	return s
}

type CreateServiceTemplateInput struct {
	_ struct{} `type:"structure"`

	// A description of the service template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The name of the service template as displayed in the developer interface.
	DisplayName *string `locationName:"displayName" min:"1" type:"string" sensitive:"true"`

	// A customer provided encryption key that's used to encrypt data.
	EncryptionKey *string `locationName:"encryptionKey" min:"1" type:"string"`

	// The name of the service template.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// AWS Proton includes a service pipeline for your service by default. When
	// included, this parameter indicates that an AWS Proton service pipeline won't
	// be included for your service. Once specified, this parameter can't be changed.
	// For more information, see Service template bundles (https://docs.aws.amazon.com/proton/latest/adminguide/ag-template-bundles.html)
	// in the AWS Proton Administrator Guide.
	PipelineProvisioning *string `locationName:"pipelineProvisioning" type:"string" enum:"Provisioning"`

	// Create tags for your service template. For more information, see AWS Proton
	// resources and tagging in the AWS Proton Administrator Guide (https://docs.aws.amazon.com/proton/latest/adminguide/resources.html)
	// or AWS Proton User Guide (https://docs.aws.amazon.com/proton/latest/userguide/resources.html).
	Tags []*Tag `locationName:"tags" type:"list"`
}

// String returns the string representation
func (s CreateServiceTemplateInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateServiceTemplateInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *CreateServiceTemplateInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "CreateServiceTemplateInput"}
	if s.DisplayName != nil && len(*s.DisplayName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("DisplayName", 1))
	}
	if s.EncryptionKey != nil && len(*s.EncryptionKey) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("EncryptionKey", 1))
	}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}
	if s.Tags != nil {
		for i, v := range s.Tags {
			if v == nil {
				continue
			}
			if err := v.Validate(); err != nil {
				invalidParams.AddNested(fmt.Sprintf("%s[%v]", "Tags", i), err.(request.ErrInvalidParams))
			}
		}
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetDescription sets the Description field's value.
func (s *CreateServiceTemplateInput) SetDescription(v string) *CreateServiceTemplateInput {
	s.Description = &v
	return s
}

// SetDisplayName sets the DisplayName field's value.
func (s *CreateServiceTemplateInput) SetDisplayName(v string) *CreateServiceTemplateInput {
	s.DisplayName = &v
	return s
}

// SetEncryptionKey sets the EncryptionKey field's value.
func (s *CreateServiceTemplateInput) SetEncryptionKey(v string) *CreateServiceTemplateInput {
	s.EncryptionKey = &v
	return s
}

// SetName sets the Name field's value.
func (s *CreateServiceTemplateInput) SetName(v string) *CreateServiceTemplateInput {
	s.Name = &v
	return s
}

// SetPipelineProvisioning sets the PipelineProvisioning field's value.
func (s *CreateServiceTemplateInput) SetPipelineProvisioning(v string) *CreateServiceTemplateInput {
	s.PipelineProvisioning = &v
	return s
}

// SetTags sets the Tags field's value.
func (s *CreateServiceTemplateInput) SetTags(v []*Tag) *CreateServiceTemplateInput {
	s.Tags = v
	return s
}

type CreateServiceTemplateOutput struct {
	_ struct{} `type:"structure"`

	// The service template detail data that's returned by AWS Proton.
	//
	// ServiceTemplate is a required field
	ServiceTemplate *ServiceTemplate `locationName:"serviceTemplate" type:"structure" required:"true"`
}

// String returns the string representation
func (s CreateServiceTemplateOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateServiceTemplateOutput) GoString() string {
	return s.String()
}

// SetServiceTemplate sets the ServiceTemplate field's value.
func (s *CreateServiceTemplateOutput) SetServiceTemplate(v *ServiceTemplate) *CreateServiceTemplateOutput {
	s.ServiceTemplate = v
	return s
}

type CreateServiceTemplateVersionInput struct {
	_ struct{} `type:"structure"`

	// When included, if two identicial requests are made with the same client token,
	// AWS Proton returns the service template version that the first request created.
	ClientToken *string `locationName:"clientToken" type:"string" idempotencyToken:"true"`

	// An array of compatible environment template objects for the new version of
	// a service template.
	//
	// CompatibleEnvironmentTemplates is a required field
	CompatibleEnvironmentTemplates []*CompatibleEnvironmentTemplateInput `locationName:"compatibleEnvironmentTemplates" min:"1" type:"list" required:"true"`

	// A description of the new version of a service template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// To create a new minor version of the service template, include a majorVersion.
	//
	// To create a new major and minor version of the service template, exclude
	// majorVersion.
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string"`

	// An object that includes the template bundle S3 bucket path and name for the
	// new version of a service template.
	//
	// Source is a required field
	Source *TemplateVersionSourceInput `locationName:"source" type:"structure" required:"true"`

	// Create tags for a new version of a service template.
	Tags []*Tag `locationName:"tags" type:"list"`

	// The name of the service template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s CreateServiceTemplateVersionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateServiceTemplateVersionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *CreateServiceTemplateVersionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "CreateServiceTemplateVersionInput"}
	if s.CompatibleEnvironmentTemplates == nil {
		invalidParams.Add(request.NewErrParamRequired("CompatibleEnvironmentTemplates"))
	}
	if s.CompatibleEnvironmentTemplates != nil && len(s.CompatibleEnvironmentTemplates) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("CompatibleEnvironmentTemplates", 1))
	}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.Source == nil {
		invalidParams.Add(request.NewErrParamRequired("Source"))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}
	if s.CompatibleEnvironmentTemplates != nil {
		for i, v := range s.CompatibleEnvironmentTemplates {
			if v == nil {
				continue
			}
			if err := v.Validate(); err != nil {
				invalidParams.AddNested(fmt.Sprintf("%s[%v]", "CompatibleEnvironmentTemplates", i), err.(request.ErrInvalidParams))
			}
		}
	}
	if s.Source != nil {
		if err := s.Source.Validate(); err != nil {
			invalidParams.AddNested("Source", err.(request.ErrInvalidParams))
		}
	}
	if s.Tags != nil {
		for i, v := range s.Tags {
			if v == nil {
				continue
			}
			if err := v.Validate(); err != nil {
				invalidParams.AddNested(fmt.Sprintf("%s[%v]", "Tags", i), err.(request.ErrInvalidParams))
			}
		}
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetClientToken sets the ClientToken field's value.
func (s *CreateServiceTemplateVersionInput) SetClientToken(v string) *CreateServiceTemplateVersionInput {
	s.ClientToken = &v
	return s
}

// SetCompatibleEnvironmentTemplates sets the CompatibleEnvironmentTemplates field's value.
func (s *CreateServiceTemplateVersionInput) SetCompatibleEnvironmentTemplates(v []*CompatibleEnvironmentTemplateInput) *CreateServiceTemplateVersionInput {
	s.CompatibleEnvironmentTemplates = v
	return s
}

// SetDescription sets the Description field's value.
func (s *CreateServiceTemplateVersionInput) SetDescription(v string) *CreateServiceTemplateVersionInput {
	s.Description = &v
	return s
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *CreateServiceTemplateVersionInput) SetMajorVersion(v string) *CreateServiceTemplateVersionInput {
	s.MajorVersion = &v
	return s
}

// SetSource sets the Source field's value.
func (s *CreateServiceTemplateVersionInput) SetSource(v *TemplateVersionSourceInput) *CreateServiceTemplateVersionInput {
	s.Source = v
	return s
}

// SetTags sets the Tags field's value.
func (s *CreateServiceTemplateVersionInput) SetTags(v []*Tag) *CreateServiceTemplateVersionInput {
	s.Tags = v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *CreateServiceTemplateVersionInput) SetTemplateName(v string) *CreateServiceTemplateVersionInput {
	s.TemplateName = &v
	return s
}

type CreateServiceTemplateVersionOutput struct {
	_ struct{} `type:"structure"`

	// The service template version summary of detail data that's returned by AWS
	// Proton.
	//
	// ServiceTemplateVersion is a required field
	ServiceTemplateVersion *ServiceTemplateVersion `locationName:"serviceTemplateVersion" type:"structure" required:"true"`
}

// String returns the string representation
func (s CreateServiceTemplateVersionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s CreateServiceTemplateVersionOutput) GoString() string {
	return s.String()
}

// SetServiceTemplateVersion sets the ServiceTemplateVersion field's value.
func (s *CreateServiceTemplateVersionOutput) SetServiceTemplateVersion(v *ServiceTemplateVersion) *CreateServiceTemplateVersionOutput {
	s.ServiceTemplateVersion = v
	return s
}

type DeleteEnvironmentAccountConnectionInput struct {
	_ struct{} `type:"structure"`

	// The ID of the environment account connection to delete.
	//
	// Id is a required field
	Id *string `locationName:"id" type:"string" required:"true"`
}

// String returns the string representation
func (s DeleteEnvironmentAccountConnectionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteEnvironmentAccountConnectionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *DeleteEnvironmentAccountConnectionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "DeleteEnvironmentAccountConnectionInput"}
	if s.Id == nil {
		invalidParams.Add(request.NewErrParamRequired("Id"))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetId sets the Id field's value.
func (s *DeleteEnvironmentAccountConnectionInput) SetId(v string) *DeleteEnvironmentAccountConnectionInput {
	s.Id = &v
	return s
}

type DeleteEnvironmentAccountConnectionOutput struct {
	_ struct{} `type:"structure"`

	// The environment account connection detail data that's returned by AWS Proton.
	EnvironmentAccountConnection *EnvironmentAccountConnection `locationName:"environmentAccountConnection" type:"structure"`
}

// String returns the string representation
func (s DeleteEnvironmentAccountConnectionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteEnvironmentAccountConnectionOutput) GoString() string {
	return s.String()
}

// SetEnvironmentAccountConnection sets the EnvironmentAccountConnection field's value.
func (s *DeleteEnvironmentAccountConnectionOutput) SetEnvironmentAccountConnection(v *EnvironmentAccountConnection) *DeleteEnvironmentAccountConnectionOutput {
	s.EnvironmentAccountConnection = v
	return s
}

type DeleteEnvironmentInput struct {
	_ struct{} `type:"structure"`

	// The name of the environment to delete.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s DeleteEnvironmentInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteEnvironmentInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *DeleteEnvironmentInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "DeleteEnvironmentInput"}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetName sets the Name field's value.
func (s *DeleteEnvironmentInput) SetName(v string) *DeleteEnvironmentInput {
	s.Name = &v
	return s
}

type DeleteEnvironmentOutput struct {
	_ struct{} `type:"structure"`

	// The environment detail data that's returned by AWS Proton.
	Environment *Environment `locationName:"environment" type:"structure"`
}

// String returns the string representation
func (s DeleteEnvironmentOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteEnvironmentOutput) GoString() string {
	return s.String()
}

// SetEnvironment sets the Environment field's value.
func (s *DeleteEnvironmentOutput) SetEnvironment(v *Environment) *DeleteEnvironmentOutput {
	s.Environment = v
	return s
}

type DeleteEnvironmentTemplateInput struct {
	_ struct{} `type:"structure"`

	// The name of the environment template to delete.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s DeleteEnvironmentTemplateInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteEnvironmentTemplateInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *DeleteEnvironmentTemplateInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "DeleteEnvironmentTemplateInput"}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetName sets the Name field's value.
func (s *DeleteEnvironmentTemplateInput) SetName(v string) *DeleteEnvironmentTemplateInput {
	s.Name = &v
	return s
}

type DeleteEnvironmentTemplateOutput struct {
	_ struct{} `type:"structure"`

	// The environment template detail data that's returned by AWS Proton.
	EnvironmentTemplate *EnvironmentTemplate `locationName:"environmentTemplate" type:"structure"`
}

// String returns the string representation
func (s DeleteEnvironmentTemplateOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteEnvironmentTemplateOutput) GoString() string {
	return s.String()
}

// SetEnvironmentTemplate sets the EnvironmentTemplate field's value.
func (s *DeleteEnvironmentTemplateOutput) SetEnvironmentTemplate(v *EnvironmentTemplate) *DeleteEnvironmentTemplateOutput {
	s.EnvironmentTemplate = v
	return s
}

type DeleteEnvironmentTemplateVersionInput struct {
	_ struct{} `type:"structure"`

	// The environment template major version to delete.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// The environment template minor version to delete.
	//
	// MinorVersion is a required field
	MinorVersion *string `locationName:"minorVersion" min:"1" type:"string" required:"true"`

	// The name of the environment template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s DeleteEnvironmentTemplateVersionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteEnvironmentTemplateVersionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *DeleteEnvironmentTemplateVersionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "DeleteEnvironmentTemplateVersionInput"}
	if s.MajorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MajorVersion"))
	}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.MinorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MinorVersion"))
	}
	if s.MinorVersion != nil && len(*s.MinorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MinorVersion", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *DeleteEnvironmentTemplateVersionInput) SetMajorVersion(v string) *DeleteEnvironmentTemplateVersionInput {
	s.MajorVersion = &v
	return s
}

// SetMinorVersion sets the MinorVersion field's value.
func (s *DeleteEnvironmentTemplateVersionInput) SetMinorVersion(v string) *DeleteEnvironmentTemplateVersionInput {
	s.MinorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *DeleteEnvironmentTemplateVersionInput) SetTemplateName(v string) *DeleteEnvironmentTemplateVersionInput {
	s.TemplateName = &v
	return s
}

type DeleteEnvironmentTemplateVersionOutput struct {
	_ struct{} `type:"structure"`

	// The environment template version detail data that's returned by AWS Proton.
	EnvironmentTemplateVersion *EnvironmentTemplateVersion `locationName:"environmentTemplateVersion" type:"structure"`
}

// String returns the string representation
func (s DeleteEnvironmentTemplateVersionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteEnvironmentTemplateVersionOutput) GoString() string {
	return s.String()
}

// SetEnvironmentTemplateVersion sets the EnvironmentTemplateVersion field's value.
func (s *DeleteEnvironmentTemplateVersionOutput) SetEnvironmentTemplateVersion(v *EnvironmentTemplateVersion) *DeleteEnvironmentTemplateVersionOutput {
	s.EnvironmentTemplateVersion = v
	return s
}

type DeleteServiceInput struct {
	_ struct{} `type:"structure"`

	// The name of the service to delete.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s DeleteServiceInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteServiceInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *DeleteServiceInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "DeleteServiceInput"}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetName sets the Name field's value.
func (s *DeleteServiceInput) SetName(v string) *DeleteServiceInput {
	s.Name = &v
	return s
}

type DeleteServiceOutput struct {
	_ struct{} `type:"structure"`

	// The service detail data that's returned by AWS Proton.
	Service *Service `locationName:"service" type:"structure"`
}

// String returns the string representation
func (s DeleteServiceOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteServiceOutput) GoString() string {
	return s.String()
}

// SetService sets the Service field's value.
func (s *DeleteServiceOutput) SetService(v *Service) *DeleteServiceOutput {
	s.Service = v
	return s
}

type DeleteServiceTemplateInput struct {
	_ struct{} `type:"structure"`

	// The name of the service template to delete.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s DeleteServiceTemplateInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteServiceTemplateInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *DeleteServiceTemplateInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "DeleteServiceTemplateInput"}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetName sets the Name field's value.
func (s *DeleteServiceTemplateInput) SetName(v string) *DeleteServiceTemplateInput {
	s.Name = &v
	return s
}

type DeleteServiceTemplateOutput struct {
	_ struct{} `type:"structure"`

	// The service template detail data that's returned by AWS Proton.
	ServiceTemplate *ServiceTemplate `locationName:"serviceTemplate" type:"structure"`
}

// String returns the string representation
func (s DeleteServiceTemplateOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteServiceTemplateOutput) GoString() string {
	return s.String()
}

// SetServiceTemplate sets the ServiceTemplate field's value.
func (s *DeleteServiceTemplateOutput) SetServiceTemplate(v *ServiceTemplate) *DeleteServiceTemplateOutput {
	s.ServiceTemplate = v
	return s
}

type DeleteServiceTemplateVersionInput struct {
	_ struct{} `type:"structure"`

	// The service template major version to delete.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// The service template minor version to delete.
	//
	// MinorVersion is a required field
	MinorVersion *string `locationName:"minorVersion" min:"1" type:"string" required:"true"`

	// The name of the service template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s DeleteServiceTemplateVersionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteServiceTemplateVersionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *DeleteServiceTemplateVersionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "DeleteServiceTemplateVersionInput"}
	if s.MajorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MajorVersion"))
	}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.MinorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MinorVersion"))
	}
	if s.MinorVersion != nil && len(*s.MinorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MinorVersion", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *DeleteServiceTemplateVersionInput) SetMajorVersion(v string) *DeleteServiceTemplateVersionInput {
	s.MajorVersion = &v
	return s
}

// SetMinorVersion sets the MinorVersion field's value.
func (s *DeleteServiceTemplateVersionInput) SetMinorVersion(v string) *DeleteServiceTemplateVersionInput {
	s.MinorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *DeleteServiceTemplateVersionInput) SetTemplateName(v string) *DeleteServiceTemplateVersionInput {
	s.TemplateName = &v
	return s
}

type DeleteServiceTemplateVersionOutput struct {
	_ struct{} `type:"structure"`

	// The service template version detail data that's returned by AWS Proton.
	ServiceTemplateVersion *ServiceTemplateVersion `locationName:"serviceTemplateVersion" type:"structure"`
}

// String returns the string representation
func (s DeleteServiceTemplateVersionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s DeleteServiceTemplateVersionOutput) GoString() string {
	return s.String()
}

// SetServiceTemplateVersion sets the ServiceTemplateVersion field's value.
func (s *DeleteServiceTemplateVersionOutput) SetServiceTemplateVersion(v *ServiceTemplateVersion) *DeleteServiceTemplateVersionOutput {
	s.ServiceTemplateVersion = v
	return s
}

// The environment detail data. An AWS Proton environment is a set resources
// shared across an AWS Proton service.
type Environment struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the environment.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the environment was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// The environment deployment status.
	//
	// DeploymentStatus is a required field
	DeploymentStatus *string `locationName:"deploymentStatus" type:"string" required:"true" enum:"DeploymentStatus"`

	// An environment deployment status message.
	DeploymentStatusMessage *string `locationName:"deploymentStatusMessage" type:"string" sensitive:"true"`

	// The description of the environment.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The ID of the environment account connection that's used to provision infrastructure
	// resources in an environment account.
	EnvironmentAccountConnectionId *string `locationName:"environmentAccountConnectionId" type:"string"`

	// The ID of the environment account that the environment infrastructure resources
	// are provisioned in.
	EnvironmentAccountId *string `locationName:"environmentAccountId" type:"string"`

	// The time when a deployment of the environment was last attempted.
	//
	// LastDeploymentAttemptedAt is a required field
	LastDeploymentAttemptedAt *time.Time `locationName:"lastDeploymentAttemptedAt" type:"timestamp" required:"true"`

	// The time when the environment was last deployed successfully.
	//
	// LastDeploymentSucceededAt is a required field
	LastDeploymentSucceededAt *time.Time `locationName:"lastDeploymentSucceededAt" type:"timestamp" required:"true"`

	// The name of the environment.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// The Amazon Resource Name (ARN) of the AWS Proton service role that allows
	// AWS Proton to make calls to other services on your behalf.
	ProtonServiceRoleArn *string `locationName:"protonServiceRoleArn" min:"1" type:"string"`

	// When included, indicates that the environment template is for customer provisioned
	// and managed infrastructure.
	Provisioning *string `locationName:"provisioning" type:"string" enum:"Provisioning"`

	// The environment spec.
	Spec *string `locationName:"spec" min:"1" type:"string" sensitive:"true"`

	// The ID of the major version of the environment template.
	//
	// TemplateMajorVersion is a required field
	TemplateMajorVersion *string `locationName:"templateMajorVersion" min:"1" type:"string" required:"true"`

	// The ID of the minor version of the environment template.
	//
	// TemplateMinorVersion is a required field
	TemplateMinorVersion *string `locationName:"templateMinorVersion" min:"1" type:"string" required:"true"`

	// The Amazon Resource Name (ARN) of the environment template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s Environment) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s Environment) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *Environment) SetArn(v string) *Environment {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *Environment) SetCreatedAt(v time.Time) *Environment {
	s.CreatedAt = &v
	return s
}

// SetDeploymentStatus sets the DeploymentStatus field's value.
func (s *Environment) SetDeploymentStatus(v string) *Environment {
	s.DeploymentStatus = &v
	return s
}

// SetDeploymentStatusMessage sets the DeploymentStatusMessage field's value.
func (s *Environment) SetDeploymentStatusMessage(v string) *Environment {
	s.DeploymentStatusMessage = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *Environment) SetDescription(v string) *Environment {
	s.Description = &v
	return s
}

// SetEnvironmentAccountConnectionId sets the EnvironmentAccountConnectionId field's value.
func (s *Environment) SetEnvironmentAccountConnectionId(v string) *Environment {
	s.EnvironmentAccountConnectionId = &v
	return s
}

// SetEnvironmentAccountId sets the EnvironmentAccountId field's value.
func (s *Environment) SetEnvironmentAccountId(v string) *Environment {
	s.EnvironmentAccountId = &v
	return s
}

// SetLastDeploymentAttemptedAt sets the LastDeploymentAttemptedAt field's value.
func (s *Environment) SetLastDeploymentAttemptedAt(v time.Time) *Environment {
	s.LastDeploymentAttemptedAt = &v
	return s
}

// SetLastDeploymentSucceededAt sets the LastDeploymentSucceededAt field's value.
func (s *Environment) SetLastDeploymentSucceededAt(v time.Time) *Environment {
	s.LastDeploymentSucceededAt = &v
	return s
}

// SetName sets the Name field's value.
func (s *Environment) SetName(v string) *Environment {
	s.Name = &v
	return s
}

// SetProtonServiceRoleArn sets the ProtonServiceRoleArn field's value.
func (s *Environment) SetProtonServiceRoleArn(v string) *Environment {
	s.ProtonServiceRoleArn = &v
	return s
}

// SetProvisioning sets the Provisioning field's value.
func (s *Environment) SetProvisioning(v string) *Environment {
	s.Provisioning = &v
	return s
}

// SetSpec sets the Spec field's value.
func (s *Environment) SetSpec(v string) *Environment {
	s.Spec = &v
	return s
}

// SetTemplateMajorVersion sets the TemplateMajorVersion field's value.
func (s *Environment) SetTemplateMajorVersion(v string) *Environment {
	s.TemplateMajorVersion = &v
	return s
}

// SetTemplateMinorVersion sets the TemplateMinorVersion field's value.
func (s *Environment) SetTemplateMinorVersion(v string) *Environment {
	s.TemplateMinorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *Environment) SetTemplateName(v string) *Environment {
	s.TemplateName = &v
	return s
}

// The environment account connection detail data.
type EnvironmentAccountConnection struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the environment account connection.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The environment account that's connected to the environment account connection.
	//
	// EnvironmentAccountId is a required field
	EnvironmentAccountId *string `locationName:"environmentAccountId" type:"string" required:"true"`

	// The name of the environment that's associated with the environment account
	// connection.
	//
	// EnvironmentName is a required field
	EnvironmentName *string `locationName:"environmentName" min:"1" type:"string" required:"true"`

	// The ID of the environment account connection.
	//
	// Id is a required field
	Id *string `locationName:"id" type:"string" required:"true"`

	// The time when the environment account connection was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The ID of the management account that's connected to the environment account
	// connection.
	//
	// ManagementAccountId is a required field
	ManagementAccountId *string `locationName:"managementAccountId" type:"string" required:"true"`

	// The time when the environment account connection request was made.
	//
	// RequestedAt is a required field
	RequestedAt *time.Time `locationName:"requestedAt" type:"timestamp" required:"true"`

	// The IAM service role that's associated with the environment account connection.
	//
	// RoleArn is a required field
	RoleArn *string `locationName:"roleArn" min:"1" type:"string" required:"true"`

	// The status of the environment account connection.
	//
	// Status is a required field
	Status *string `locationName:"status" type:"string" required:"true" enum:"EnvironmentAccountConnectionStatus"`
}

// String returns the string representation
func (s EnvironmentAccountConnection) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s EnvironmentAccountConnection) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *EnvironmentAccountConnection) SetArn(v string) *EnvironmentAccountConnection {
	s.Arn = &v
	return s
}

// SetEnvironmentAccountId sets the EnvironmentAccountId field's value.
func (s *EnvironmentAccountConnection) SetEnvironmentAccountId(v string) *EnvironmentAccountConnection {
	s.EnvironmentAccountId = &v
	return s
}

// SetEnvironmentName sets the EnvironmentName field's value.
func (s *EnvironmentAccountConnection) SetEnvironmentName(v string) *EnvironmentAccountConnection {
	s.EnvironmentName = &v
	return s
}

// SetId sets the Id field's value.
func (s *EnvironmentAccountConnection) SetId(v string) *EnvironmentAccountConnection {
	s.Id = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *EnvironmentAccountConnection) SetLastModifiedAt(v time.Time) *EnvironmentAccountConnection {
	s.LastModifiedAt = &v
	return s
}

// SetManagementAccountId sets the ManagementAccountId field's value.
func (s *EnvironmentAccountConnection) SetManagementAccountId(v string) *EnvironmentAccountConnection {
	s.ManagementAccountId = &v
	return s
}

// SetRequestedAt sets the RequestedAt field's value.
func (s *EnvironmentAccountConnection) SetRequestedAt(v time.Time) *EnvironmentAccountConnection {
	s.RequestedAt = &v
	return s
}

// SetRoleArn sets the RoleArn field's value.
func (s *EnvironmentAccountConnection) SetRoleArn(v string) *EnvironmentAccountConnection {
	s.RoleArn = &v
	return s
}

// SetStatus sets the Status field's value.
func (s *EnvironmentAccountConnection) SetStatus(v string) *EnvironmentAccountConnection {
	s.Status = &v
	return s
}

// A summary of the environment account connection detail data.
type EnvironmentAccountConnectionSummary struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the environment account connection.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The ID of the environment account that's connected to the environment account
	// connection.
	//
	// EnvironmentAccountId is a required field
	EnvironmentAccountId *string `locationName:"environmentAccountId" type:"string" required:"true"`

	// The name of the environment that's associated with the environment account
	// connection.
	//
	// EnvironmentName is a required field
	EnvironmentName *string `locationName:"environmentName" min:"1" type:"string" required:"true"`

	// The ID of the environment account connection.
	//
	// Id is a required field
	Id *string `locationName:"id" type:"string" required:"true"`

	// The time when the environment account connection was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The ID of the management account that's connected to the environment account
	// connection.
	//
	// ManagementAccountId is a required field
	ManagementAccountId *string `locationName:"managementAccountId" type:"string" required:"true"`

	// The time when the environment account connection request was made.
	//
	// RequestedAt is a required field
	RequestedAt *time.Time `locationName:"requestedAt" type:"timestamp" required:"true"`

	// The IAM service role that's associated with the environment account connection.
	//
	// RoleArn is a required field
	RoleArn *string `locationName:"roleArn" min:"1" type:"string" required:"true"`

	// The status of the environment account connection.
	//
	// Status is a required field
	Status *string `locationName:"status" type:"string" required:"true" enum:"EnvironmentAccountConnectionStatus"`
}

// String returns the string representation
func (s EnvironmentAccountConnectionSummary) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s EnvironmentAccountConnectionSummary) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *EnvironmentAccountConnectionSummary) SetArn(v string) *EnvironmentAccountConnectionSummary {
	s.Arn = &v
	return s
}

// SetEnvironmentAccountId sets the EnvironmentAccountId field's value.
func (s *EnvironmentAccountConnectionSummary) SetEnvironmentAccountId(v string) *EnvironmentAccountConnectionSummary {
	s.EnvironmentAccountId = &v
	return s
}

// SetEnvironmentName sets the EnvironmentName field's value.
func (s *EnvironmentAccountConnectionSummary) SetEnvironmentName(v string) *EnvironmentAccountConnectionSummary {
	s.EnvironmentName = &v
	return s
}

// SetId sets the Id field's value.
func (s *EnvironmentAccountConnectionSummary) SetId(v string) *EnvironmentAccountConnectionSummary {
	s.Id = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *EnvironmentAccountConnectionSummary) SetLastModifiedAt(v time.Time) *EnvironmentAccountConnectionSummary {
	s.LastModifiedAt = &v
	return s
}

// SetManagementAccountId sets the ManagementAccountId field's value.
func (s *EnvironmentAccountConnectionSummary) SetManagementAccountId(v string) *EnvironmentAccountConnectionSummary {
	s.ManagementAccountId = &v
	return s
}

// SetRequestedAt sets the RequestedAt field's value.
func (s *EnvironmentAccountConnectionSummary) SetRequestedAt(v time.Time) *EnvironmentAccountConnectionSummary {
	s.RequestedAt = &v
	return s
}

// SetRoleArn sets the RoleArn field's value.
func (s *EnvironmentAccountConnectionSummary) SetRoleArn(v string) *EnvironmentAccountConnectionSummary {
	s.RoleArn = &v
	return s
}

// SetStatus sets the Status field's value.
func (s *EnvironmentAccountConnectionSummary) SetStatus(v string) *EnvironmentAccountConnectionSummary {
	s.Status = &v
	return s
}

// A summary of the environment detail data.
type EnvironmentSummary struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the environment.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the environment was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// The environment deployment status.
	//
	// DeploymentStatus is a required field
	DeploymentStatus *string `locationName:"deploymentStatus" type:"string" required:"true" enum:"DeploymentStatus"`

	// An environment deployment status message.
	DeploymentStatusMessage *string `locationName:"deploymentStatusMessage" type:"string" sensitive:"true"`

	// The description of the environment.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The ID of the environment account connection that the environment is associated
	// with.
	EnvironmentAccountConnectionId *string `locationName:"environmentAccountConnectionId" type:"string"`

	// The ID of the environment account that the environment infrastructure resources
	// are provisioned in.
	EnvironmentAccountId *string `locationName:"environmentAccountId" type:"string"`

	// The time when a deployment of the environment was last attempted.
	//
	// LastDeploymentAttemptedAt is a required field
	LastDeploymentAttemptedAt *time.Time `locationName:"lastDeploymentAttemptedAt" type:"timestamp" required:"true"`

	// The time when the environment was last deployed successfully.
	//
	// LastDeploymentSucceededAt is a required field
	LastDeploymentSucceededAt *time.Time `locationName:"lastDeploymentSucceededAt" type:"timestamp" required:"true"`

	// The name of the environment.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// The Amazon Resource Name (ARN) of the AWS Proton service role that allows
	// AWS Proton to make calls to other services on your behalf.
	ProtonServiceRoleArn *string `locationName:"protonServiceRoleArn" min:"1" type:"string"`

	// When included, indicates that the environment template is for customer provisioned
	// and managed infrastructure.
	Provisioning *string `locationName:"provisioning" type:"string" enum:"Provisioning"`

	// The ID of the major version of the environment template.
	//
	// TemplateMajorVersion is a required field
	TemplateMajorVersion *string `locationName:"templateMajorVersion" min:"1" type:"string" required:"true"`

	// The ID of the minor version of the environment template.
	//
	// TemplateMinorVersion is a required field
	TemplateMinorVersion *string `locationName:"templateMinorVersion" min:"1" type:"string" required:"true"`

	// The name of the environment template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s EnvironmentSummary) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s EnvironmentSummary) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *EnvironmentSummary) SetArn(v string) *EnvironmentSummary {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *EnvironmentSummary) SetCreatedAt(v time.Time) *EnvironmentSummary {
	s.CreatedAt = &v
	return s
}

// SetDeploymentStatus sets the DeploymentStatus field's value.
func (s *EnvironmentSummary) SetDeploymentStatus(v string) *EnvironmentSummary {
	s.DeploymentStatus = &v
	return s
}

// SetDeploymentStatusMessage sets the DeploymentStatusMessage field's value.
func (s *EnvironmentSummary) SetDeploymentStatusMessage(v string) *EnvironmentSummary {
	s.DeploymentStatusMessage = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *EnvironmentSummary) SetDescription(v string) *EnvironmentSummary {
	s.Description = &v
	return s
}

// SetEnvironmentAccountConnectionId sets the EnvironmentAccountConnectionId field's value.
func (s *EnvironmentSummary) SetEnvironmentAccountConnectionId(v string) *EnvironmentSummary {
	s.EnvironmentAccountConnectionId = &v
	return s
}

// SetEnvironmentAccountId sets the EnvironmentAccountId field's value.
func (s *EnvironmentSummary) SetEnvironmentAccountId(v string) *EnvironmentSummary {
	s.EnvironmentAccountId = &v
	return s
}

// SetLastDeploymentAttemptedAt sets the LastDeploymentAttemptedAt field's value.
func (s *EnvironmentSummary) SetLastDeploymentAttemptedAt(v time.Time) *EnvironmentSummary {
	s.LastDeploymentAttemptedAt = &v
	return s
}

// SetLastDeploymentSucceededAt sets the LastDeploymentSucceededAt field's value.
func (s *EnvironmentSummary) SetLastDeploymentSucceededAt(v time.Time) *EnvironmentSummary {
	s.LastDeploymentSucceededAt = &v
	return s
}

// SetName sets the Name field's value.
func (s *EnvironmentSummary) SetName(v string) *EnvironmentSummary {
	s.Name = &v
	return s
}

// SetProtonServiceRoleArn sets the ProtonServiceRoleArn field's value.
func (s *EnvironmentSummary) SetProtonServiceRoleArn(v string) *EnvironmentSummary {
	s.ProtonServiceRoleArn = &v
	return s
}

// SetProvisioning sets the Provisioning field's value.
func (s *EnvironmentSummary) SetProvisioning(v string) *EnvironmentSummary {
	s.Provisioning = &v
	return s
}

// SetTemplateMajorVersion sets the TemplateMajorVersion field's value.
func (s *EnvironmentSummary) SetTemplateMajorVersion(v string) *EnvironmentSummary {
	s.TemplateMajorVersion = &v
	return s
}

// SetTemplateMinorVersion sets the TemplateMinorVersion field's value.
func (s *EnvironmentSummary) SetTemplateMinorVersion(v string) *EnvironmentSummary {
	s.TemplateMinorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *EnvironmentSummary) SetTemplateName(v string) *EnvironmentSummary {
	s.TemplateName = &v
	return s
}

// The environment template data.
type EnvironmentTemplate struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the environment template.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the environment template was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// A description of the environment template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The name of the environment template as displayed in the developer interface.
	DisplayName *string `locationName:"displayName" min:"1" type:"string" sensitive:"true"`

	// The customer provided encryption key for the environment template.
	EncryptionKey *string `locationName:"encryptionKey" min:"1" type:"string"`

	// The time when the environment template was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The name of the environment template.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// When included, indicates that the environment template is for customer provisioned
	// and managed infrastructure.
	Provisioning *string `locationName:"provisioning" type:"string" enum:"Provisioning"`

	// The ID of the recommended version of the environment template.
	RecommendedVersion *string `locationName:"recommendedVersion" min:"1" type:"string"`
}

// String returns the string representation
func (s EnvironmentTemplate) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s EnvironmentTemplate) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *EnvironmentTemplate) SetArn(v string) *EnvironmentTemplate {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *EnvironmentTemplate) SetCreatedAt(v time.Time) *EnvironmentTemplate {
	s.CreatedAt = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *EnvironmentTemplate) SetDescription(v string) *EnvironmentTemplate {
	s.Description = &v
	return s
}

// SetDisplayName sets the DisplayName field's value.
func (s *EnvironmentTemplate) SetDisplayName(v string) *EnvironmentTemplate {
	s.DisplayName = &v
	return s
}

// SetEncryptionKey sets the EncryptionKey field's value.
func (s *EnvironmentTemplate) SetEncryptionKey(v string) *EnvironmentTemplate {
	s.EncryptionKey = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *EnvironmentTemplate) SetLastModifiedAt(v time.Time) *EnvironmentTemplate {
	s.LastModifiedAt = &v
	return s
}

// SetName sets the Name field's value.
func (s *EnvironmentTemplate) SetName(v string) *EnvironmentTemplate {
	s.Name = &v
	return s
}

// SetProvisioning sets the Provisioning field's value.
func (s *EnvironmentTemplate) SetProvisioning(v string) *EnvironmentTemplate {
	s.Provisioning = &v
	return s
}

// SetRecommendedVersion sets the RecommendedVersion field's value.
func (s *EnvironmentTemplate) SetRecommendedVersion(v string) *EnvironmentTemplate {
	s.RecommendedVersion = &v
	return s
}

// A search filter for environment templates.
type EnvironmentTemplateFilter struct {
	_ struct{} `type:"structure"`

	// Include majorVersion to filter search for a major version.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// Include templateName to filter search for a template name.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s EnvironmentTemplateFilter) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s EnvironmentTemplateFilter) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *EnvironmentTemplateFilter) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "EnvironmentTemplateFilter"}
	if s.MajorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MajorVersion"))
	}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *EnvironmentTemplateFilter) SetMajorVersion(v string) *EnvironmentTemplateFilter {
	s.MajorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *EnvironmentTemplateFilter) SetTemplateName(v string) *EnvironmentTemplateFilter {
	s.TemplateName = &v
	return s
}

// The environment template data.
type EnvironmentTemplateSummary struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the environment template.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the environment template was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// A description of the environment template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The name of the environment template as displayed in the developer interface.
	DisplayName *string `locationName:"displayName" min:"1" type:"string" sensitive:"true"`

	// The time when the environment template was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The name of the environment template.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// When included, indicates that the environment template is for customer provisioned
	// and managed infrastructure.
	Provisioning *string `locationName:"provisioning" type:"string" enum:"Provisioning"`

	// The ID of the recommended version of the environment template.
	RecommendedVersion *string `locationName:"recommendedVersion" min:"1" type:"string"`
}

// String returns the string representation
func (s EnvironmentTemplateSummary) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s EnvironmentTemplateSummary) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *EnvironmentTemplateSummary) SetArn(v string) *EnvironmentTemplateSummary {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *EnvironmentTemplateSummary) SetCreatedAt(v time.Time) *EnvironmentTemplateSummary {
	s.CreatedAt = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *EnvironmentTemplateSummary) SetDescription(v string) *EnvironmentTemplateSummary {
	s.Description = &v
	return s
}

// SetDisplayName sets the DisplayName field's value.
func (s *EnvironmentTemplateSummary) SetDisplayName(v string) *EnvironmentTemplateSummary {
	s.DisplayName = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *EnvironmentTemplateSummary) SetLastModifiedAt(v time.Time) *EnvironmentTemplateSummary {
	s.LastModifiedAt = &v
	return s
}

// SetName sets the Name field's value.
func (s *EnvironmentTemplateSummary) SetName(v string) *EnvironmentTemplateSummary {
	s.Name = &v
	return s
}

// SetProvisioning sets the Provisioning field's value.
func (s *EnvironmentTemplateSummary) SetProvisioning(v string) *EnvironmentTemplateSummary {
	s.Provisioning = &v
	return s
}

// SetRecommendedVersion sets the RecommendedVersion field's value.
func (s *EnvironmentTemplateSummary) SetRecommendedVersion(v string) *EnvironmentTemplateSummary {
	s.RecommendedVersion = &v
	return s
}

// The environment template version data.
type EnvironmentTemplateVersion struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the version of an environment template.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the version of an environment template was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// A description of the minor version of an environment template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The time when the version of an environment template was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The ID of the latest major version that's associated with the version of
	// an environment template.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// The ID of the minor version of an environment template.
	//
	// MinorVersion is a required field
	MinorVersion *string `locationName:"minorVersion" min:"1" type:"string" required:"true"`

	// The ID of the recommended minor version of the environment template.
	RecommendedMinorVersion *string `locationName:"recommendedMinorVersion" min:"1" type:"string"`

	// The schema of the version of an environment template.
	Schema *string `locationName:"schema" min:"1" type:"string" sensitive:"true"`

	// The status of the version of an environment template.
	//
	// Status is a required field
	Status *string `locationName:"status" type:"string" required:"true" enum:"TemplateVersionStatus"`

	// The status message of the version of an environment template.
	StatusMessage *string `locationName:"statusMessage" type:"string" sensitive:"true"`

	// The name of the version of an environment template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s EnvironmentTemplateVersion) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s EnvironmentTemplateVersion) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *EnvironmentTemplateVersion) SetArn(v string) *EnvironmentTemplateVersion {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *EnvironmentTemplateVersion) SetCreatedAt(v time.Time) *EnvironmentTemplateVersion {
	s.CreatedAt = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *EnvironmentTemplateVersion) SetDescription(v string) *EnvironmentTemplateVersion {
	s.Description = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *EnvironmentTemplateVersion) SetLastModifiedAt(v time.Time) *EnvironmentTemplateVersion {
	s.LastModifiedAt = &v
	return s
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *EnvironmentTemplateVersion) SetMajorVersion(v string) *EnvironmentTemplateVersion {
	s.MajorVersion = &v
	return s
}

// SetMinorVersion sets the MinorVersion field's value.
func (s *EnvironmentTemplateVersion) SetMinorVersion(v string) *EnvironmentTemplateVersion {
	s.MinorVersion = &v
	return s
}

// SetRecommendedMinorVersion sets the RecommendedMinorVersion field's value.
func (s *EnvironmentTemplateVersion) SetRecommendedMinorVersion(v string) *EnvironmentTemplateVersion {
	s.RecommendedMinorVersion = &v
	return s
}

// SetSchema sets the Schema field's value.
func (s *EnvironmentTemplateVersion) SetSchema(v string) *EnvironmentTemplateVersion {
	s.Schema = &v
	return s
}

// SetStatus sets the Status field's value.
func (s *EnvironmentTemplateVersion) SetStatus(v string) *EnvironmentTemplateVersion {
	s.Status = &v
	return s
}

// SetStatusMessage sets the StatusMessage field's value.
func (s *EnvironmentTemplateVersion) SetStatusMessage(v string) *EnvironmentTemplateVersion {
	s.StatusMessage = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *EnvironmentTemplateVersion) SetTemplateName(v string) *EnvironmentTemplateVersion {
	s.TemplateName = &v
	return s
}

// A summary of the version of an environment template detail data.
type EnvironmentTemplateVersionSummary struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the version of an environment template.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the version of an environment template was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// A description of the version of an environment template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The time when the version of an environment template was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The ID of the latest major version that's associated with the version of
	// an environment template.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// The ID of the version of an environment template.
	//
	// MinorVersion is a required field
	MinorVersion *string `locationName:"minorVersion" min:"1" type:"string" required:"true"`

	// The ID of the recommended minor version of the environment template.
	RecommendedMinorVersion *string `locationName:"recommendedMinorVersion" min:"1" type:"string"`

	// The status of the version of an environment template.
	//
	// Status is a required field
	Status *string `locationName:"status" type:"string" required:"true" enum:"TemplateVersionStatus"`

	// The status message of the version of an environment template.
	StatusMessage *string `locationName:"statusMessage" type:"string" sensitive:"true"`

	// The name of the version of an environment template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s EnvironmentTemplateVersionSummary) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s EnvironmentTemplateVersionSummary) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *EnvironmentTemplateVersionSummary) SetArn(v string) *EnvironmentTemplateVersionSummary {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *EnvironmentTemplateVersionSummary) SetCreatedAt(v time.Time) *EnvironmentTemplateVersionSummary {
	s.CreatedAt = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *EnvironmentTemplateVersionSummary) SetDescription(v string) *EnvironmentTemplateVersionSummary {
	s.Description = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *EnvironmentTemplateVersionSummary) SetLastModifiedAt(v time.Time) *EnvironmentTemplateVersionSummary {
	s.LastModifiedAt = &v
	return s
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *EnvironmentTemplateVersionSummary) SetMajorVersion(v string) *EnvironmentTemplateVersionSummary {
	s.MajorVersion = &v
	return s
}

// SetMinorVersion sets the MinorVersion field's value.
func (s *EnvironmentTemplateVersionSummary) SetMinorVersion(v string) *EnvironmentTemplateVersionSummary {
	s.MinorVersion = &v
	return s
}

// SetRecommendedMinorVersion sets the RecommendedMinorVersion field's value.
func (s *EnvironmentTemplateVersionSummary) SetRecommendedMinorVersion(v string) *EnvironmentTemplateVersionSummary {
	s.RecommendedMinorVersion = &v
	return s
}

// SetStatus sets the Status field's value.
func (s *EnvironmentTemplateVersionSummary) SetStatus(v string) *EnvironmentTemplateVersionSummary {
	s.Status = &v
	return s
}

// SetStatusMessage sets the StatusMessage field's value.
func (s *EnvironmentTemplateVersionSummary) SetStatusMessage(v string) *EnvironmentTemplateVersionSummary {
	s.StatusMessage = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *EnvironmentTemplateVersionSummary) SetTemplateName(v string) *EnvironmentTemplateVersionSummary {
	s.TemplateName = &v
	return s
}

type GetAccountSettingsInput struct {
	_ struct{} `type:"structure"`
}

// String returns the string representation
func (s GetAccountSettingsInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetAccountSettingsInput) GoString() string {
	return s.String()
}

type GetAccountSettingsOutput struct {
	_ struct{} `type:"structure"`

	// The AWS Proton pipeline service role detail data that's returned by AWS Proton.
	AccountSettings *AccountSettings `locationName:"accountSettings" type:"structure"`
}

// String returns the string representation
func (s GetAccountSettingsOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetAccountSettingsOutput) GoString() string {
	return s.String()
}

// SetAccountSettings sets the AccountSettings field's value.
func (s *GetAccountSettingsOutput) SetAccountSettings(v *AccountSettings) *GetAccountSettingsOutput {
	s.AccountSettings = v
	return s
}

type GetEnvironmentAccountConnectionInput struct {
	_ struct{} `type:"structure"`

	// The ID of the environment account connection.
	//
	// Id is a required field
	Id *string `locationName:"id" type:"string" required:"true"`
}

// String returns the string representation
func (s GetEnvironmentAccountConnectionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetEnvironmentAccountConnectionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *GetEnvironmentAccountConnectionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "GetEnvironmentAccountConnectionInput"}
	if s.Id == nil {
		invalidParams.Add(request.NewErrParamRequired("Id"))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetId sets the Id field's value.
func (s *GetEnvironmentAccountConnectionInput) SetId(v string) *GetEnvironmentAccountConnectionInput {
	s.Id = &v
	return s
}

type GetEnvironmentAccountConnectionOutput struct {
	_ struct{} `type:"structure"`

	// The environment account connection detail data that's returned by AWS Proton.
	//
	// EnvironmentAccountConnection is a required field
	EnvironmentAccountConnection *EnvironmentAccountConnection `locationName:"environmentAccountConnection" type:"structure" required:"true"`
}

// String returns the string representation
func (s GetEnvironmentAccountConnectionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetEnvironmentAccountConnectionOutput) GoString() string {
	return s.String()
}

// SetEnvironmentAccountConnection sets the EnvironmentAccountConnection field's value.
func (s *GetEnvironmentAccountConnectionOutput) SetEnvironmentAccountConnection(v *EnvironmentAccountConnection) *GetEnvironmentAccountConnectionOutput {
	s.EnvironmentAccountConnection = v
	return s
}

type GetEnvironmentInput struct {
	_ struct{} `type:"structure"`

	// The name of the environment that you want to get the detail data for.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s GetEnvironmentInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetEnvironmentInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *GetEnvironmentInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "GetEnvironmentInput"}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetName sets the Name field's value.
func (s *GetEnvironmentInput) SetName(v string) *GetEnvironmentInput {
	s.Name = &v
	return s
}

type GetEnvironmentOutput struct {
	_ struct{} `type:"structure"`

	// The environment detail data that's returned by AWS Proton.
	//
	// Environment is a required field
	Environment *Environment `locationName:"environment" type:"structure" required:"true"`
}

// String returns the string representation
func (s GetEnvironmentOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetEnvironmentOutput) GoString() string {
	return s.String()
}

// SetEnvironment sets the Environment field's value.
func (s *GetEnvironmentOutput) SetEnvironment(v *Environment) *GetEnvironmentOutput {
	s.Environment = v
	return s
}

type GetEnvironmentTemplateInput struct {
	_ struct{} `type:"structure"`

	// The name of the environment template that you want to get the detail data
	// for.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s GetEnvironmentTemplateInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetEnvironmentTemplateInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *GetEnvironmentTemplateInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "GetEnvironmentTemplateInput"}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetName sets the Name field's value.
func (s *GetEnvironmentTemplateInput) SetName(v string) *GetEnvironmentTemplateInput {
	s.Name = &v
	return s
}

type GetEnvironmentTemplateOutput struct {
	_ struct{} `type:"structure"`

	// The environment template detail data that's returned by AWS Proton.
	//
	// EnvironmentTemplate is a required field
	EnvironmentTemplate *EnvironmentTemplate `locationName:"environmentTemplate" type:"structure" required:"true"`
}

// String returns the string representation
func (s GetEnvironmentTemplateOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetEnvironmentTemplateOutput) GoString() string {
	return s.String()
}

// SetEnvironmentTemplate sets the EnvironmentTemplate field's value.
func (s *GetEnvironmentTemplateOutput) SetEnvironmentTemplate(v *EnvironmentTemplate) *GetEnvironmentTemplateOutput {
	s.EnvironmentTemplate = v
	return s
}

type GetEnvironmentTemplateVersionInput struct {
	_ struct{} `type:"structure"`

	// To view environment template major version detail data, include majorVersion.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// To view environment template minor version detail data, include minorVersion.
	//
	// MinorVersion is a required field
	MinorVersion *string `locationName:"minorVersion" min:"1" type:"string" required:"true"`

	// The name of the environment template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s GetEnvironmentTemplateVersionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetEnvironmentTemplateVersionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *GetEnvironmentTemplateVersionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "GetEnvironmentTemplateVersionInput"}
	if s.MajorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MajorVersion"))
	}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.MinorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MinorVersion"))
	}
	if s.MinorVersion != nil && len(*s.MinorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MinorVersion", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *GetEnvironmentTemplateVersionInput) SetMajorVersion(v string) *GetEnvironmentTemplateVersionInput {
	s.MajorVersion = &v
	return s
}

// SetMinorVersion sets the MinorVersion field's value.
func (s *GetEnvironmentTemplateVersionInput) SetMinorVersion(v string) *GetEnvironmentTemplateVersionInput {
	s.MinorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *GetEnvironmentTemplateVersionInput) SetTemplateName(v string) *GetEnvironmentTemplateVersionInput {
	s.TemplateName = &v
	return s
}

type GetEnvironmentTemplateVersionOutput struct {
	_ struct{} `type:"structure"`

	// The environment template version detail data that's returned by AWS Proton.
	//
	// EnvironmentTemplateVersion is a required field
	EnvironmentTemplateVersion *EnvironmentTemplateVersion `locationName:"environmentTemplateVersion" type:"structure" required:"true"`
}

// String returns the string representation
func (s GetEnvironmentTemplateVersionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetEnvironmentTemplateVersionOutput) GoString() string {
	return s.String()
}

// SetEnvironmentTemplateVersion sets the EnvironmentTemplateVersion field's value.
func (s *GetEnvironmentTemplateVersionOutput) SetEnvironmentTemplateVersion(v *EnvironmentTemplateVersion) *GetEnvironmentTemplateVersionOutput {
	s.EnvironmentTemplateVersion = v
	return s
}

type GetServiceInput struct {
	_ struct{} `type:"structure"`

	// The name of the service that you want to get the detail data for.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s GetServiceInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetServiceInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *GetServiceInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "GetServiceInput"}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetName sets the Name field's value.
func (s *GetServiceInput) SetName(v string) *GetServiceInput {
	s.Name = &v
	return s
}

type GetServiceInstanceInput struct {
	_ struct{} `type:"structure"`

	// The name of a service instance that you want to get the detail data for.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// The name of the service that the service instance belongs to.
	//
	// ServiceName is a required field
	ServiceName *string `locationName:"serviceName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s GetServiceInstanceInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetServiceInstanceInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *GetServiceInstanceInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "GetServiceInstanceInput"}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}
	if s.ServiceName == nil {
		invalidParams.Add(request.NewErrParamRequired("ServiceName"))
	}
	if s.ServiceName != nil && len(*s.ServiceName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ServiceName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetName sets the Name field's value.
func (s *GetServiceInstanceInput) SetName(v string) *GetServiceInstanceInput {
	s.Name = &v
	return s
}

// SetServiceName sets the ServiceName field's value.
func (s *GetServiceInstanceInput) SetServiceName(v string) *GetServiceInstanceInput {
	s.ServiceName = &v
	return s
}

type GetServiceInstanceOutput struct {
	_ struct{} `type:"structure"`

	// The service instance detail data that's returned by AWS Proton.
	//
	// ServiceInstance is a required field
	ServiceInstance *ServiceInstance `locationName:"serviceInstance" type:"structure" required:"true"`
}

// String returns the string representation
func (s GetServiceInstanceOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetServiceInstanceOutput) GoString() string {
	return s.String()
}

// SetServiceInstance sets the ServiceInstance field's value.
func (s *GetServiceInstanceOutput) SetServiceInstance(v *ServiceInstance) *GetServiceInstanceOutput {
	s.ServiceInstance = v
	return s
}

type GetServiceOutput struct {
	_ struct{} `type:"structure"`

	// The service detail data that's returned by AWS Proton.
	Service *Service `locationName:"service" type:"structure"`
}

// String returns the string representation
func (s GetServiceOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetServiceOutput) GoString() string {
	return s.String()
}

// SetService sets the Service field's value.
func (s *GetServiceOutput) SetService(v *Service) *GetServiceOutput {
	s.Service = v
	return s
}

type GetServiceTemplateInput struct {
	_ struct{} `type:"structure"`

	// The name of the service template that you want to get detail data for.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s GetServiceTemplateInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetServiceTemplateInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *GetServiceTemplateInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "GetServiceTemplateInput"}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetName sets the Name field's value.
func (s *GetServiceTemplateInput) SetName(v string) *GetServiceTemplateInput {
	s.Name = &v
	return s
}

type GetServiceTemplateOutput struct {
	_ struct{} `type:"structure"`

	// The service template detail data that's returned by AWS Proton.
	//
	// ServiceTemplate is a required field
	ServiceTemplate *ServiceTemplate `locationName:"serviceTemplate" type:"structure" required:"true"`
}

// String returns the string representation
func (s GetServiceTemplateOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetServiceTemplateOutput) GoString() string {
	return s.String()
}

// SetServiceTemplate sets the ServiceTemplate field's value.
func (s *GetServiceTemplateOutput) SetServiceTemplate(v *ServiceTemplate) *GetServiceTemplateOutput {
	s.ServiceTemplate = v
	return s
}

type GetServiceTemplateVersionInput struct {
	_ struct{} `type:"structure"`

	// To view service template major version detail data, include majorVersion.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// To view service template minor version detail data, include minorVersion.
	//
	// MinorVersion is a required field
	MinorVersion *string `locationName:"minorVersion" min:"1" type:"string" required:"true"`

	// The name of the service template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s GetServiceTemplateVersionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetServiceTemplateVersionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *GetServiceTemplateVersionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "GetServiceTemplateVersionInput"}
	if s.MajorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MajorVersion"))
	}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.MinorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MinorVersion"))
	}
	if s.MinorVersion != nil && len(*s.MinorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MinorVersion", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *GetServiceTemplateVersionInput) SetMajorVersion(v string) *GetServiceTemplateVersionInput {
	s.MajorVersion = &v
	return s
}

// SetMinorVersion sets the MinorVersion field's value.
func (s *GetServiceTemplateVersionInput) SetMinorVersion(v string) *GetServiceTemplateVersionInput {
	s.MinorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *GetServiceTemplateVersionInput) SetTemplateName(v string) *GetServiceTemplateVersionInput {
	s.TemplateName = &v
	return s
}

type GetServiceTemplateVersionOutput struct {
	_ struct{} `type:"structure"`

	// The service template version detail data that's returned by AWS Proton.
	//
	// ServiceTemplateVersion is a required field
	ServiceTemplateVersion *ServiceTemplateVersion `locationName:"serviceTemplateVersion" type:"structure" required:"true"`
}

// String returns the string representation
func (s GetServiceTemplateVersionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s GetServiceTemplateVersionOutput) GoString() string {
	return s.String()
}

// SetServiceTemplateVersion sets the ServiceTemplateVersion field's value.
func (s *GetServiceTemplateVersionOutput) SetServiceTemplateVersion(v *ServiceTemplateVersion) *GetServiceTemplateVersionOutput {
	s.ServiceTemplateVersion = v
	return s
}

// The request failed to register with the service.
type InternalServerException struct {
	_            struct{}                  `type:"structure"`
	RespMetadata protocol.ResponseMetadata `json:"-" xml:"-"`

	Message_ *string `locationName:"message" type:"string" sensitive:"true"`
}

// String returns the string representation
func (s InternalServerException) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s InternalServerException) GoString() string {
	return s.String()
}

func newErrorInternalServerException(v protocol.ResponseMetadata) error {
	return &InternalServerException{
		RespMetadata: v,
	}
}

// Code returns the exception type name.
func (s *InternalServerException) Code() string {
	return "InternalServerException"
}

// Message returns the exception's message.
func (s *InternalServerException) Message() string {
	if s.Message_ != nil {
		return *s.Message_
	}
	return ""
}

// OrigErr always returns nil, satisfies awserr.Error interface.
func (s *InternalServerException) OrigErr() error {
	return nil
}

func (s *InternalServerException) Error() string {
	return fmt.Sprintf("%s: %s", s.Code(), s.Message())
}

// Status code returns the HTTP status code for the request's response error.
func (s *InternalServerException) StatusCode() int {
	return s.RespMetadata.StatusCode
}

// RequestID returns the service's response RequestID for request.
func (s *InternalServerException) RequestID() string {
	return s.RespMetadata.RequestID
}

type ListEnvironmentAccountConnectionsInput struct {
	_ struct{} `type:"structure"`

	// The environment name that's associated with each listed environment account
	// connection.
	EnvironmentName *string `locationName:"environmentName" min:"1" type:"string"`

	// The maximum number of environment account connections to list.
	MaxResults *int64 `locationName:"maxResults" min:"1" type:"integer"`

	// A token to indicate the location of the next environment account connection
	// in the array of environment account connections, after the list of environment
	// account connections that was previously requested.
	NextToken *string `locationName:"nextToken" type:"string"`

	// The type of account making the ListEnvironmentAccountConnections request.
	//
	// RequestedBy is a required field
	RequestedBy *string `locationName:"requestedBy" type:"string" required:"true" enum:"EnvironmentAccountConnectionRequesterAccountType"`

	// The status details for each listed environment account connection.
	Statuses []*string `locationName:"statuses" type:"list"`
}

// String returns the string representation
func (s ListEnvironmentAccountConnectionsInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListEnvironmentAccountConnectionsInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ListEnvironmentAccountConnectionsInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "ListEnvironmentAccountConnectionsInput"}
	if s.EnvironmentName != nil && len(*s.EnvironmentName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("EnvironmentName", 1))
	}
	if s.MaxResults != nil && *s.MaxResults < 1 {
		invalidParams.Add(request.NewErrParamMinValue("MaxResults", 1))
	}
	if s.RequestedBy == nil {
		invalidParams.Add(request.NewErrParamRequired("RequestedBy"))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetEnvironmentName sets the EnvironmentName field's value.
func (s *ListEnvironmentAccountConnectionsInput) SetEnvironmentName(v string) *ListEnvironmentAccountConnectionsInput {
	s.EnvironmentName = &v
	return s
}

// SetMaxResults sets the MaxResults field's value.
func (s *ListEnvironmentAccountConnectionsInput) SetMaxResults(v int64) *ListEnvironmentAccountConnectionsInput {
	s.MaxResults = &v
	return s
}

// SetNextToken sets the NextToken field's value.
func (s *ListEnvironmentAccountConnectionsInput) SetNextToken(v string) *ListEnvironmentAccountConnectionsInput {
	s.NextToken = &v
	return s
}

// SetRequestedBy sets the RequestedBy field's value.
func (s *ListEnvironmentAccountConnectionsInput) SetRequestedBy(v string) *ListEnvironmentAccountConnectionsInput {
	s.RequestedBy = &v
	return s
}

// SetStatuses sets the Statuses field's value.
func (s *ListEnvironmentAccountConnectionsInput) SetStatuses(v []*string) *ListEnvironmentAccountConnectionsInput {
	s.Statuses = v
	return s
}

type ListEnvironmentAccountConnectionsOutput struct {
	_ struct{} `type:"structure"`

	// An array of environment account connections with details that's returned
	// by AWS Proton.
	//
	// EnvironmentAccountConnections is a required field
	EnvironmentAccountConnections []*EnvironmentAccountConnectionSummary `locationName:"environmentAccountConnections" type:"list" required:"true"`

	// A token to indicate the location of the next environment account connection
	// in the array of environment account connections, after the current requested
	// list of environment account connections.
	NextToken *string `locationName:"nextToken" type:"string"`
}

// String returns the string representation
func (s ListEnvironmentAccountConnectionsOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListEnvironmentAccountConnectionsOutput) GoString() string {
	return s.String()
}

// SetEnvironmentAccountConnections sets the EnvironmentAccountConnections field's value.
func (s *ListEnvironmentAccountConnectionsOutput) SetEnvironmentAccountConnections(v []*EnvironmentAccountConnectionSummary) *ListEnvironmentAccountConnectionsOutput {
	s.EnvironmentAccountConnections = v
	return s
}

// SetNextToken sets the NextToken field's value.
func (s *ListEnvironmentAccountConnectionsOutput) SetNextToken(v string) *ListEnvironmentAccountConnectionsOutput {
	s.NextToken = &v
	return s
}

type ListEnvironmentTemplateVersionsInput struct {
	_ struct{} `type:"structure"`

	// To view a list of minor of versions under a major version of an environment
	// template, include majorVersion.
	//
	// To view a list of major versions of an environment template, exclude majorVersion.
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string"`

	// The maximum number of major or minor versions of an environment template
	// to list.
	MaxResults *int64 `locationName:"maxResults" min:"1" type:"integer"`

	// A token to indicate the location of the next major or minor version in the
	// array of major or minor versions of an environment template, after the list
	// of major or minor versions that was previously requested.
	NextToken *string `locationName:"nextToken" type:"string"`

	// The name of the environment template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s ListEnvironmentTemplateVersionsInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListEnvironmentTemplateVersionsInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ListEnvironmentTemplateVersionsInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "ListEnvironmentTemplateVersionsInput"}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.MaxResults != nil && *s.MaxResults < 1 {
		invalidParams.Add(request.NewErrParamMinValue("MaxResults", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *ListEnvironmentTemplateVersionsInput) SetMajorVersion(v string) *ListEnvironmentTemplateVersionsInput {
	s.MajorVersion = &v
	return s
}

// SetMaxResults sets the MaxResults field's value.
func (s *ListEnvironmentTemplateVersionsInput) SetMaxResults(v int64) *ListEnvironmentTemplateVersionsInput {
	s.MaxResults = &v
	return s
}

// SetNextToken sets the NextToken field's value.
func (s *ListEnvironmentTemplateVersionsInput) SetNextToken(v string) *ListEnvironmentTemplateVersionsInput {
	s.NextToken = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *ListEnvironmentTemplateVersionsInput) SetTemplateName(v string) *ListEnvironmentTemplateVersionsInput {
	s.TemplateName = &v
	return s
}

type ListEnvironmentTemplateVersionsOutput struct {
	_ struct{} `type:"structure"`

	// A token to indicate the location of the next major or minor version in the
	// array of major or minor versions of an environment template, after the list
	// of major or minor versions that was previously requested.
	NextToken *string `locationName:"nextToken" type:"string"`

	// An array of major or minor versions of an environment template detail data.
	//
	// TemplateVersions is a required field
	TemplateVersions []*EnvironmentTemplateVersionSummary `locationName:"templateVersions" type:"list" required:"true"`
}

// String returns the string representation
func (s ListEnvironmentTemplateVersionsOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListEnvironmentTemplateVersionsOutput) GoString() string {
	return s.String()
}

// SetNextToken sets the NextToken field's value.
func (s *ListEnvironmentTemplateVersionsOutput) SetNextToken(v string) *ListEnvironmentTemplateVersionsOutput {
	s.NextToken = &v
	return s
}

// SetTemplateVersions sets the TemplateVersions field's value.
func (s *ListEnvironmentTemplateVersionsOutput) SetTemplateVersions(v []*EnvironmentTemplateVersionSummary) *ListEnvironmentTemplateVersionsOutput {
	s.TemplateVersions = v
	return s
}

type ListEnvironmentTemplatesInput struct {
	_ struct{} `type:"structure"`

	// The maximum number of environment templates to list.
	MaxResults *int64 `locationName:"maxResults" min:"1" type:"integer"`

	// A token to indicate the location of the next environment template in the
	// array of environment templates, after the list of environment templates that
	// was previously requested.
	NextToken *string `locationName:"nextToken" type:"string"`
}

// String returns the string representation
func (s ListEnvironmentTemplatesInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListEnvironmentTemplatesInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ListEnvironmentTemplatesInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "ListEnvironmentTemplatesInput"}
	if s.MaxResults != nil && *s.MaxResults < 1 {
		invalidParams.Add(request.NewErrParamMinValue("MaxResults", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMaxResults sets the MaxResults field's value.
func (s *ListEnvironmentTemplatesInput) SetMaxResults(v int64) *ListEnvironmentTemplatesInput {
	s.MaxResults = &v
	return s
}

// SetNextToken sets the NextToken field's value.
func (s *ListEnvironmentTemplatesInput) SetNextToken(v string) *ListEnvironmentTemplatesInput {
	s.NextToken = &v
	return s
}

type ListEnvironmentTemplatesOutput struct {
	_ struct{} `type:"structure"`

	// A token to indicate the location of the next environment template in the
	// array of environment templates, after the current requested list of environment
	// templates.
	NextToken *string `locationName:"nextToken" type:"string"`

	// An array of environment templates with detail data.
	//
	// Templates is a required field
	Templates []*EnvironmentTemplateSummary `locationName:"templates" type:"list" required:"true"`
}

// String returns the string representation
func (s ListEnvironmentTemplatesOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListEnvironmentTemplatesOutput) GoString() string {
	return s.String()
}

// SetNextToken sets the NextToken field's value.
func (s *ListEnvironmentTemplatesOutput) SetNextToken(v string) *ListEnvironmentTemplatesOutput {
	s.NextToken = &v
	return s
}

// SetTemplates sets the Templates field's value.
func (s *ListEnvironmentTemplatesOutput) SetTemplates(v []*EnvironmentTemplateSummary) *ListEnvironmentTemplatesOutput {
	s.Templates = v
	return s
}

type ListEnvironmentsInput struct {
	_ struct{} `type:"structure"`

	// An array of the versions of the environment template.
	EnvironmentTemplates []*EnvironmentTemplateFilter `locationName:"environmentTemplates" type:"list"`

	// The maximum number of environments to list.
	MaxResults *int64 `locationName:"maxResults" min:"1" type:"integer"`

	// A token to indicate the location of the next environment in the array of
	// environments, after the list of environments that was previously requested.
	NextToken *string `locationName:"nextToken" type:"string"`
}

// String returns the string representation
func (s ListEnvironmentsInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListEnvironmentsInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ListEnvironmentsInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "ListEnvironmentsInput"}
	if s.MaxResults != nil && *s.MaxResults < 1 {
		invalidParams.Add(request.NewErrParamMinValue("MaxResults", 1))
	}
	if s.EnvironmentTemplates != nil {
		for i, v := range s.EnvironmentTemplates {
			if v == nil {
				continue
			}
			if err := v.Validate(); err != nil {
				invalidParams.AddNested(fmt.Sprintf("%s[%v]", "EnvironmentTemplates", i), err.(request.ErrInvalidParams))
			}
		}
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetEnvironmentTemplates sets the EnvironmentTemplates field's value.
func (s *ListEnvironmentsInput) SetEnvironmentTemplates(v []*EnvironmentTemplateFilter) *ListEnvironmentsInput {
	s.EnvironmentTemplates = v
	return s
}

// SetMaxResults sets the MaxResults field's value.
func (s *ListEnvironmentsInput) SetMaxResults(v int64) *ListEnvironmentsInput {
	s.MaxResults = &v
	return s
}

// SetNextToken sets the NextToken field's value.
func (s *ListEnvironmentsInput) SetNextToken(v string) *ListEnvironmentsInput {
	s.NextToken = &v
	return s
}

type ListEnvironmentsOutput struct {
	_ struct{} `type:"structure"`

	// An array of environment detail data summaries.
	//
	// Environments is a required field
	Environments []*EnvironmentSummary `locationName:"environments" type:"list" required:"true"`

	// A token to indicate the location of the next environment in the array of
	// environments, after the current requested list of environments.
	NextToken *string `locationName:"nextToken" type:"string"`
}

// String returns the string representation
func (s ListEnvironmentsOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListEnvironmentsOutput) GoString() string {
	return s.String()
}

// SetEnvironments sets the Environments field's value.
func (s *ListEnvironmentsOutput) SetEnvironments(v []*EnvironmentSummary) *ListEnvironmentsOutput {
	s.Environments = v
	return s
}

// SetNextToken sets the NextToken field's value.
func (s *ListEnvironmentsOutput) SetNextToken(v string) *ListEnvironmentsOutput {
	s.NextToken = &v
	return s
}

type ListServiceInstancesInput struct {
	_ struct{} `type:"structure"`

	// The maximum number of service instances to list.
	MaxResults *int64 `locationName:"maxResults" min:"1" type:"integer"`

	// A token to indicate the location of the next service in the array of service
	// instances, after the list of service instances that was previously requested.
	NextToken *string `locationName:"nextToken" type:"string"`

	// The name of the service that the service instance belongs to.
	ServiceName *string `locationName:"serviceName" min:"1" type:"string"`
}

// String returns the string representation
func (s ListServiceInstancesInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListServiceInstancesInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ListServiceInstancesInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "ListServiceInstancesInput"}
	if s.MaxResults != nil && *s.MaxResults < 1 {
		invalidParams.Add(request.NewErrParamMinValue("MaxResults", 1))
	}
	if s.ServiceName != nil && len(*s.ServiceName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ServiceName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMaxResults sets the MaxResults field's value.
func (s *ListServiceInstancesInput) SetMaxResults(v int64) *ListServiceInstancesInput {
	s.MaxResults = &v
	return s
}

// SetNextToken sets the NextToken field's value.
func (s *ListServiceInstancesInput) SetNextToken(v string) *ListServiceInstancesInput {
	s.NextToken = &v
	return s
}

// SetServiceName sets the ServiceName field's value.
func (s *ListServiceInstancesInput) SetServiceName(v string) *ListServiceInstancesInput {
	s.ServiceName = &v
	return s
}

type ListServiceInstancesOutput struct {
	_ struct{} `type:"structure"`

	// A token to indicate the location of the next service instance in the array
	// of service instances, after the current requested list of service instances.
	NextToken *string `locationName:"nextToken" type:"string"`

	// An array of service instances with summaries of detail data.
	//
	// ServiceInstances is a required field
	ServiceInstances []*ServiceInstanceSummary `locationName:"serviceInstances" type:"list" required:"true"`
}

// String returns the string representation
func (s ListServiceInstancesOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListServiceInstancesOutput) GoString() string {
	return s.String()
}

// SetNextToken sets the NextToken field's value.
func (s *ListServiceInstancesOutput) SetNextToken(v string) *ListServiceInstancesOutput {
	s.NextToken = &v
	return s
}

// SetServiceInstances sets the ServiceInstances field's value.
func (s *ListServiceInstancesOutput) SetServiceInstances(v []*ServiceInstanceSummary) *ListServiceInstancesOutput {
	s.ServiceInstances = v
	return s
}

type ListServiceTemplateVersionsInput struct {
	_ struct{} `type:"structure"`

	// To view a list of minor of versions under a major version of a service template,
	// include majorVersion.
	//
	// To view a list of major versions of a service template, exclude majorVersion.
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string"`

	// The maximum number of major or minor versions of a service template to list.
	MaxResults *int64 `locationName:"maxResults" min:"1" type:"integer"`

	// A token to indicate the location of the next major or minor version in the
	// array of major or minor versions of a service template, after the list of
	// major or minor versions that was previously requested.
	NextToken *string `locationName:"nextToken" type:"string"`

	// The name of the service template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s ListServiceTemplateVersionsInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListServiceTemplateVersionsInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ListServiceTemplateVersionsInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "ListServiceTemplateVersionsInput"}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.MaxResults != nil && *s.MaxResults < 1 {
		invalidParams.Add(request.NewErrParamMinValue("MaxResults", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *ListServiceTemplateVersionsInput) SetMajorVersion(v string) *ListServiceTemplateVersionsInput {
	s.MajorVersion = &v
	return s
}

// SetMaxResults sets the MaxResults field's value.
func (s *ListServiceTemplateVersionsInput) SetMaxResults(v int64) *ListServiceTemplateVersionsInput {
	s.MaxResults = &v
	return s
}

// SetNextToken sets the NextToken field's value.
func (s *ListServiceTemplateVersionsInput) SetNextToken(v string) *ListServiceTemplateVersionsInput {
	s.NextToken = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *ListServiceTemplateVersionsInput) SetTemplateName(v string) *ListServiceTemplateVersionsInput {
	s.TemplateName = &v
	return s
}

type ListServiceTemplateVersionsOutput struct {
	_ struct{} `type:"structure"`

	// A token to indicate the location of the next major or minor version in the
	// array of major or minor versions of a service template, after the list of
	// major or minor versions that was previously requested.
	NextToken *string `locationName:"nextToken" type:"string"`

	// An array of major or minor versions of a service template with detail data.
	//
	// TemplateVersions is a required field
	TemplateVersions []*ServiceTemplateVersionSummary `locationName:"templateVersions" type:"list" required:"true"`
}

// String returns the string representation
func (s ListServiceTemplateVersionsOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListServiceTemplateVersionsOutput) GoString() string {
	return s.String()
}

// SetNextToken sets the NextToken field's value.
func (s *ListServiceTemplateVersionsOutput) SetNextToken(v string) *ListServiceTemplateVersionsOutput {
	s.NextToken = &v
	return s
}

// SetTemplateVersions sets the TemplateVersions field's value.
func (s *ListServiceTemplateVersionsOutput) SetTemplateVersions(v []*ServiceTemplateVersionSummary) *ListServiceTemplateVersionsOutput {
	s.TemplateVersions = v
	return s
}

type ListServiceTemplatesInput struct {
	_ struct{} `type:"structure"`

	// The maximum number of service templates to list.
	MaxResults *int64 `locationName:"maxResults" min:"1" type:"integer"`

	// A token to indicate the location of the next service template in the array
	// of service templates, after the list of service templates previously requested.
	NextToken *string `locationName:"nextToken" type:"string"`
}

// String returns the string representation
func (s ListServiceTemplatesInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListServiceTemplatesInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ListServiceTemplatesInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "ListServiceTemplatesInput"}
	if s.MaxResults != nil && *s.MaxResults < 1 {
		invalidParams.Add(request.NewErrParamMinValue("MaxResults", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMaxResults sets the MaxResults field's value.
func (s *ListServiceTemplatesInput) SetMaxResults(v int64) *ListServiceTemplatesInput {
	s.MaxResults = &v
	return s
}

// SetNextToken sets the NextToken field's value.
func (s *ListServiceTemplatesInput) SetNextToken(v string) *ListServiceTemplatesInput {
	s.NextToken = &v
	return s
}

type ListServiceTemplatesOutput struct {
	_ struct{} `type:"structure"`

	// A token to indicate the location of the next service template in the array
	// of service templates, after the current requested list of service templates.
	NextToken *string `locationName:"nextToken" type:"string"`

	// An array of service templates with detail data.
	//
	// Templates is a required field
	Templates []*ServiceTemplateSummary `locationName:"templates" type:"list" required:"true"`
}

// String returns the string representation
func (s ListServiceTemplatesOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListServiceTemplatesOutput) GoString() string {
	return s.String()
}

// SetNextToken sets the NextToken field's value.
func (s *ListServiceTemplatesOutput) SetNextToken(v string) *ListServiceTemplatesOutput {
	s.NextToken = &v
	return s
}

// SetTemplates sets the Templates field's value.
func (s *ListServiceTemplatesOutput) SetTemplates(v []*ServiceTemplateSummary) *ListServiceTemplatesOutput {
	s.Templates = v
	return s
}

type ListServicesInput struct {
	_ struct{} `type:"structure"`

	// The maximum number of services to list.
	MaxResults *int64 `locationName:"maxResults" min:"1" type:"integer"`

	// A token to indicate the location of the next service in the array of services,
	// after the list of services that was previously requested.
	NextToken *string `locationName:"nextToken" type:"string"`
}

// String returns the string representation
func (s ListServicesInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListServicesInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ListServicesInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "ListServicesInput"}
	if s.MaxResults != nil && *s.MaxResults < 1 {
		invalidParams.Add(request.NewErrParamMinValue("MaxResults", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMaxResults sets the MaxResults field's value.
func (s *ListServicesInput) SetMaxResults(v int64) *ListServicesInput {
	s.MaxResults = &v
	return s
}

// SetNextToken sets the NextToken field's value.
func (s *ListServicesInput) SetNextToken(v string) *ListServicesInput {
	s.NextToken = &v
	return s
}

type ListServicesOutput struct {
	_ struct{} `type:"structure"`

	// A token to indicate the location of the next service in the array of services,
	// after the current requested list of services.
	NextToken *string `locationName:"nextToken" type:"string"`

	// An array of services with summaries of detail data.
	//
	// Services is a required field
	Services []*ServiceSummary `locationName:"services" type:"list" required:"true"`
}

// String returns the string representation
func (s ListServicesOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListServicesOutput) GoString() string {
	return s.String()
}

// SetNextToken sets the NextToken field's value.
func (s *ListServicesOutput) SetNextToken(v string) *ListServicesOutput {
	s.NextToken = &v
	return s
}

// SetServices sets the Services field's value.
func (s *ListServicesOutput) SetServices(v []*ServiceSummary) *ListServicesOutput {
	s.Services = v
	return s
}

type ListTagsForResourceInput struct {
	_ struct{} `type:"structure"`

	// The maximum number of tags to list.
	MaxResults *int64 `locationName:"maxResults" min:"1" type:"integer"`

	// A token to indicate the location of the next resource tag in the array of
	// resource tags, after the list of resource tags that was previously requested.
	NextToken *string `locationName:"nextToken" type:"string"`

	// The Amazon Resource Name (ARN) of the resource for the listed tags.
	//
	// ResourceArn is a required field
	ResourceArn *string `locationName:"resourceArn" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s ListTagsForResourceInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListTagsForResourceInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *ListTagsForResourceInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "ListTagsForResourceInput"}
	if s.MaxResults != nil && *s.MaxResults < 1 {
		invalidParams.Add(request.NewErrParamMinValue("MaxResults", 1))
	}
	if s.ResourceArn == nil {
		invalidParams.Add(request.NewErrParamRequired("ResourceArn"))
	}
	if s.ResourceArn != nil && len(*s.ResourceArn) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ResourceArn", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetMaxResults sets the MaxResults field's value.
func (s *ListTagsForResourceInput) SetMaxResults(v int64) *ListTagsForResourceInput {
	s.MaxResults = &v
	return s
}

// SetNextToken sets the NextToken field's value.
func (s *ListTagsForResourceInput) SetNextToken(v string) *ListTagsForResourceInput {
	s.NextToken = &v
	return s
}

// SetResourceArn sets the ResourceArn field's value.
func (s *ListTagsForResourceInput) SetResourceArn(v string) *ListTagsForResourceInput {
	s.ResourceArn = &v
	return s
}

type ListTagsForResourceOutput struct {
	_ struct{} `type:"structure"`

	// A token to indicate the location of the next resource tag in the array of
	// resource tags, after the current requested list of resource tags.
	NextToken *string `locationName:"nextToken" type:"string"`

	// An array of resource tags with detail data.
	//
	// Tags is a required field
	Tags []*Tag `locationName:"tags" type:"list" required:"true"`
}

// String returns the string representation
func (s ListTagsForResourceOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ListTagsForResourceOutput) GoString() string {
	return s.String()
}

// SetNextToken sets the NextToken field's value.
func (s *ListTagsForResourceOutput) SetNextToken(v string) *ListTagsForResourceOutput {
	s.NextToken = &v
	return s
}

// SetTags sets the Tags field's value.
func (s *ListTagsForResourceOutput) SetTags(v []*Tag) *ListTagsForResourceOutput {
	s.Tags = v
	return s
}

type RejectEnvironmentAccountConnectionInput struct {
	_ struct{} `type:"structure"`

	// The ID of the environment account connection to reject.
	//
	// Id is a required field
	Id *string `locationName:"id" type:"string" required:"true"`
}

// String returns the string representation
func (s RejectEnvironmentAccountConnectionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s RejectEnvironmentAccountConnectionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *RejectEnvironmentAccountConnectionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "RejectEnvironmentAccountConnectionInput"}
	if s.Id == nil {
		invalidParams.Add(request.NewErrParamRequired("Id"))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetId sets the Id field's value.
func (s *RejectEnvironmentAccountConnectionInput) SetId(v string) *RejectEnvironmentAccountConnectionInput {
	s.Id = &v
	return s
}

type RejectEnvironmentAccountConnectionOutput struct {
	_ struct{} `type:"structure"`

	// The environment connection account detail data that's returned by AWS Proton.
	//
	// EnvironmentAccountConnection is a required field
	EnvironmentAccountConnection *EnvironmentAccountConnection `locationName:"environmentAccountConnection" type:"structure" required:"true"`
}

// String returns the string representation
func (s RejectEnvironmentAccountConnectionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s RejectEnvironmentAccountConnectionOutput) GoString() string {
	return s.String()
}

// SetEnvironmentAccountConnection sets the EnvironmentAccountConnection field's value.
func (s *RejectEnvironmentAccountConnectionOutput) SetEnvironmentAccountConnection(v *EnvironmentAccountConnection) *RejectEnvironmentAccountConnectionOutput {
	s.EnvironmentAccountConnection = v
	return s
}

// The requested resource wasn't found.
type ResourceNotFoundException struct {
	_            struct{}                  `type:"structure"`
	RespMetadata protocol.ResponseMetadata `json:"-" xml:"-"`

	Message_ *string `locationName:"message" type:"string" sensitive:"true"`
}

// String returns the string representation
func (s ResourceNotFoundException) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ResourceNotFoundException) GoString() string {
	return s.String()
}

func newErrorResourceNotFoundException(v protocol.ResponseMetadata) error {
	return &ResourceNotFoundException{
		RespMetadata: v,
	}
}

// Code returns the exception type name.
func (s *ResourceNotFoundException) Code() string {
	return "ResourceNotFoundException"
}

// Message returns the exception's message.
func (s *ResourceNotFoundException) Message() string {
	if s.Message_ != nil {
		return *s.Message_
	}
	return ""
}

// OrigErr always returns nil, satisfies awserr.Error interface.
func (s *ResourceNotFoundException) OrigErr() error {
	return nil
}

func (s *ResourceNotFoundException) Error() string {
	return fmt.Sprintf("%s: %s", s.Code(), s.Message())
}

// Status code returns the HTTP status code for the request's response error.
func (s *ResourceNotFoundException) StatusCode() int {
	return s.RespMetadata.StatusCode
}

// RequestID returns the service's response RequestID for request.
func (s *ResourceNotFoundException) RequestID() string {
	return s.RespMetadata.RequestID
}

// Template bundle S3 bucket data.
type S3ObjectSource struct {
	_ struct{} `type:"structure"`

	// The name of the S3 bucket that contains a template bundle.
	//
	// Bucket is a required field
	Bucket *string `locationName:"bucket" min:"3" type:"string" required:"true"`

	// The path to the S3 bucket that contains a template bundle.
	//
	// Key is a required field
	Key *string `locationName:"key" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s S3ObjectSource) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s S3ObjectSource) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *S3ObjectSource) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "S3ObjectSource"}
	if s.Bucket == nil {
		invalidParams.Add(request.NewErrParamRequired("Bucket"))
	}
	if s.Bucket != nil && len(*s.Bucket) < 3 {
		invalidParams.Add(request.NewErrParamMinLen("Bucket", 3))
	}
	if s.Key == nil {
		invalidParams.Add(request.NewErrParamRequired("Key"))
	}
	if s.Key != nil && len(*s.Key) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Key", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetBucket sets the Bucket field's value.
func (s *S3ObjectSource) SetBucket(v string) *S3ObjectSource {
	s.Bucket = &v
	return s
}

// SetKey sets the Key field's value.
func (s *S3ObjectSource) SetKey(v string) *S3ObjectSource {
	s.Key = &v
	return s
}

// The service detail data.
type Service struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the service.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The name of the code repository branch that holds the code that's deployed
	// in AWS Proton.
	BranchName *string `locationName:"branchName" min:"1" type:"string"`

	// The time when the service was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// A description of a service.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The time when the service was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The name of the service.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// The service pipeline detail data.
	Pipeline *ServicePipeline `locationName:"pipeline" type:"structure"`

	// The Amazon Resource Name (ARN) of the repository connection. For more information,
	// see Set up a repository connection (https://docs.aws.amazon.com/proton/latest/adminguide/setting-up-for-service.html#setting-up-vcontrol)
	// in the AWS Proton Administrator Guide and Setting up with AWS Proton (https://docs.aws.amazon.com/proton/latest/userguide/proton-setup.html#setup-repo-connection)
	// in the AWS Proton User Guide.
	RepositoryConnectionArn *string `locationName:"repositoryConnectionArn" min:"1" type:"string"`

	// The ID of the code repository.
	RepositoryId *string `locationName:"repositoryId" min:"1" type:"string"`

	// The formatted specification that defines the service.
	//
	// Spec is a required field
	Spec *string `locationName:"spec" min:"1" type:"string" required:"true" sensitive:"true"`

	// The status of the service.
	//
	// Status is a required field
	Status *string `locationName:"status" type:"string" required:"true" enum:"ServiceStatus"`

	// A service status message.
	StatusMessage *string `locationName:"statusMessage" type:"string" sensitive:"true"`

	// The name of the service template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s Service) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s Service) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *Service) SetArn(v string) *Service {
	s.Arn = &v
	return s
}

// SetBranchName sets the BranchName field's value.
func (s *Service) SetBranchName(v string) *Service {
	s.BranchName = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *Service) SetCreatedAt(v time.Time) *Service {
	s.CreatedAt = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *Service) SetDescription(v string) *Service {
	s.Description = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *Service) SetLastModifiedAt(v time.Time) *Service {
	s.LastModifiedAt = &v
	return s
}

// SetName sets the Name field's value.
func (s *Service) SetName(v string) *Service {
	s.Name = &v
	return s
}

// SetPipeline sets the Pipeline field's value.
func (s *Service) SetPipeline(v *ServicePipeline) *Service {
	s.Pipeline = v
	return s
}

// SetRepositoryConnectionArn sets the RepositoryConnectionArn field's value.
func (s *Service) SetRepositoryConnectionArn(v string) *Service {
	s.RepositoryConnectionArn = &v
	return s
}

// SetRepositoryId sets the RepositoryId field's value.
func (s *Service) SetRepositoryId(v string) *Service {
	s.RepositoryId = &v
	return s
}

// SetSpec sets the Spec field's value.
func (s *Service) SetSpec(v string) *Service {
	s.Spec = &v
	return s
}

// SetStatus sets the Status field's value.
func (s *Service) SetStatus(v string) *Service {
	s.Status = &v
	return s
}

// SetStatusMessage sets the StatusMessage field's value.
func (s *Service) SetStatusMessage(v string) *Service {
	s.StatusMessage = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *Service) SetTemplateName(v string) *Service {
	s.TemplateName = &v
	return s
}

// The service instance detail data.
type ServiceInstance struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the service instance.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the service instance was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// The service instance deployment status.
	//
	// DeploymentStatus is a required field
	DeploymentStatus *string `locationName:"deploymentStatus" type:"string" required:"true" enum:"DeploymentStatus"`

	// A service instance deployment status message.
	DeploymentStatusMessage *string `locationName:"deploymentStatusMessage" type:"string" sensitive:"true"`

	// The name of the environment that the service instance was deployed into.
	//
	// EnvironmentName is a required field
	EnvironmentName *string `locationName:"environmentName" min:"1" type:"string" required:"true"`

	// The time when a deployment of the service instance was last attempted.
	//
	// LastDeploymentAttemptedAt is a required field
	LastDeploymentAttemptedAt *time.Time `locationName:"lastDeploymentAttemptedAt" type:"timestamp" required:"true"`

	// The time when the service instance was last deployed successfully.
	//
	// LastDeploymentSucceededAt is a required field
	LastDeploymentSucceededAt *time.Time `locationName:"lastDeploymentSucceededAt" type:"timestamp" required:"true"`

	// The name of the service instance.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// The name of the service that the service instance belongs to.
	//
	// ServiceName is a required field
	ServiceName *string `locationName:"serviceName" min:"1" type:"string" required:"true"`

	// The service spec that was used to create the service instance.
	Spec *string `locationName:"spec" min:"1" type:"string" sensitive:"true"`

	// The ID of the major version of the service template that was used to create
	// the service instance.
	//
	// TemplateMajorVersion is a required field
	TemplateMajorVersion *string `locationName:"templateMajorVersion" min:"1" type:"string" required:"true"`

	// The ID of the minor version of the service template that was used to create
	// the service instance.
	//
	// TemplateMinorVersion is a required field
	TemplateMinorVersion *string `locationName:"templateMinorVersion" min:"1" type:"string" required:"true"`

	// The name of the service template that was used to create the service instance.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s ServiceInstance) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ServiceInstance) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *ServiceInstance) SetArn(v string) *ServiceInstance {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *ServiceInstance) SetCreatedAt(v time.Time) *ServiceInstance {
	s.CreatedAt = &v
	return s
}

// SetDeploymentStatus sets the DeploymentStatus field's value.
func (s *ServiceInstance) SetDeploymentStatus(v string) *ServiceInstance {
	s.DeploymentStatus = &v
	return s
}

// SetDeploymentStatusMessage sets the DeploymentStatusMessage field's value.
func (s *ServiceInstance) SetDeploymentStatusMessage(v string) *ServiceInstance {
	s.DeploymentStatusMessage = &v
	return s
}

// SetEnvironmentName sets the EnvironmentName field's value.
func (s *ServiceInstance) SetEnvironmentName(v string) *ServiceInstance {
	s.EnvironmentName = &v
	return s
}

// SetLastDeploymentAttemptedAt sets the LastDeploymentAttemptedAt field's value.
func (s *ServiceInstance) SetLastDeploymentAttemptedAt(v time.Time) *ServiceInstance {
	s.LastDeploymentAttemptedAt = &v
	return s
}

// SetLastDeploymentSucceededAt sets the LastDeploymentSucceededAt field's value.
func (s *ServiceInstance) SetLastDeploymentSucceededAt(v time.Time) *ServiceInstance {
	s.LastDeploymentSucceededAt = &v
	return s
}

// SetName sets the Name field's value.
func (s *ServiceInstance) SetName(v string) *ServiceInstance {
	s.Name = &v
	return s
}

// SetServiceName sets the ServiceName field's value.
func (s *ServiceInstance) SetServiceName(v string) *ServiceInstance {
	s.ServiceName = &v
	return s
}

// SetSpec sets the Spec field's value.
func (s *ServiceInstance) SetSpec(v string) *ServiceInstance {
	s.Spec = &v
	return s
}

// SetTemplateMajorVersion sets the TemplateMajorVersion field's value.
func (s *ServiceInstance) SetTemplateMajorVersion(v string) *ServiceInstance {
	s.TemplateMajorVersion = &v
	return s
}

// SetTemplateMinorVersion sets the TemplateMinorVersion field's value.
func (s *ServiceInstance) SetTemplateMinorVersion(v string) *ServiceInstance {
	s.TemplateMinorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *ServiceInstance) SetTemplateName(v string) *ServiceInstance {
	s.TemplateName = &v
	return s
}

// A summary of the service instance detail data.
type ServiceInstanceSummary struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the service instance.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the service instance was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// The service instance deployment status.
	//
	// DeploymentStatus is a required field
	DeploymentStatus *string `locationName:"deploymentStatus" type:"string" required:"true" enum:"DeploymentStatus"`

	// A service instance deployment status message.
	DeploymentStatusMessage *string `locationName:"deploymentStatusMessage" type:"string" sensitive:"true"`

	// The name of the environment that the service instance was deployed into.
	//
	// EnvironmentName is a required field
	EnvironmentName *string `locationName:"environmentName" min:"1" type:"string" required:"true"`

	// The time when a deployment of the service was last attempted.
	//
	// LastDeploymentAttemptedAt is a required field
	LastDeploymentAttemptedAt *time.Time `locationName:"lastDeploymentAttemptedAt" type:"timestamp" required:"true"`

	// The time when the service was last deployed successfully.
	//
	// LastDeploymentSucceededAt is a required field
	LastDeploymentSucceededAt *time.Time `locationName:"lastDeploymentSucceededAt" type:"timestamp" required:"true"`

	// The name of the service instance.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// The name of the service that the service instance belongs to.
	//
	// ServiceName is a required field
	ServiceName *string `locationName:"serviceName" min:"1" type:"string" required:"true"`

	// The ID of the major version of a service template.
	//
	// TemplateMajorVersion is a required field
	TemplateMajorVersion *string `locationName:"templateMajorVersion" min:"1" type:"string" required:"true"`

	// The ID of the minor version of a service template.
	//
	// TemplateMinorVersion is a required field
	TemplateMinorVersion *string `locationName:"templateMinorVersion" min:"1" type:"string" required:"true"`

	// The name of the service template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s ServiceInstanceSummary) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ServiceInstanceSummary) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *ServiceInstanceSummary) SetArn(v string) *ServiceInstanceSummary {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *ServiceInstanceSummary) SetCreatedAt(v time.Time) *ServiceInstanceSummary {
	s.CreatedAt = &v
	return s
}

// SetDeploymentStatus sets the DeploymentStatus field's value.
func (s *ServiceInstanceSummary) SetDeploymentStatus(v string) *ServiceInstanceSummary {
	s.DeploymentStatus = &v
	return s
}

// SetDeploymentStatusMessage sets the DeploymentStatusMessage field's value.
func (s *ServiceInstanceSummary) SetDeploymentStatusMessage(v string) *ServiceInstanceSummary {
	s.DeploymentStatusMessage = &v
	return s
}

// SetEnvironmentName sets the EnvironmentName field's value.
func (s *ServiceInstanceSummary) SetEnvironmentName(v string) *ServiceInstanceSummary {
	s.EnvironmentName = &v
	return s
}

// SetLastDeploymentAttemptedAt sets the LastDeploymentAttemptedAt field's value.
func (s *ServiceInstanceSummary) SetLastDeploymentAttemptedAt(v time.Time) *ServiceInstanceSummary {
	s.LastDeploymentAttemptedAt = &v
	return s
}

// SetLastDeploymentSucceededAt sets the LastDeploymentSucceededAt field's value.
func (s *ServiceInstanceSummary) SetLastDeploymentSucceededAt(v time.Time) *ServiceInstanceSummary {
	s.LastDeploymentSucceededAt = &v
	return s
}

// SetName sets the Name field's value.
func (s *ServiceInstanceSummary) SetName(v string) *ServiceInstanceSummary {
	s.Name = &v
	return s
}

// SetServiceName sets the ServiceName field's value.
func (s *ServiceInstanceSummary) SetServiceName(v string) *ServiceInstanceSummary {
	s.ServiceName = &v
	return s
}

// SetTemplateMajorVersion sets the TemplateMajorVersion field's value.
func (s *ServiceInstanceSummary) SetTemplateMajorVersion(v string) *ServiceInstanceSummary {
	s.TemplateMajorVersion = &v
	return s
}

// SetTemplateMinorVersion sets the TemplateMinorVersion field's value.
func (s *ServiceInstanceSummary) SetTemplateMinorVersion(v string) *ServiceInstanceSummary {
	s.TemplateMinorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *ServiceInstanceSummary) SetTemplateName(v string) *ServiceInstanceSummary {
	s.TemplateName = &v
	return s
}

// The service pipeline detail data.
type ServicePipeline struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the service pipeline.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" min:"1" type:"string" required:"true"`

	// The time when the service pipeline was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// The deployment status of the service pipeline.
	//
	// DeploymentStatus is a required field
	DeploymentStatus *string `locationName:"deploymentStatus" type:"string" required:"true" enum:"DeploymentStatus"`

	// A service pipeline deployment status message.
	DeploymentStatusMessage *string `locationName:"deploymentStatusMessage" type:"string" sensitive:"true"`

	// The time when a deployment of the service pipeline was last attempted.
	//
	// LastDeploymentAttemptedAt is a required field
	LastDeploymentAttemptedAt *time.Time `locationName:"lastDeploymentAttemptedAt" type:"timestamp" required:"true"`

	// The time when the service pipeline was last deployed successfully.
	//
	// LastDeploymentSucceededAt is a required field
	LastDeploymentSucceededAt *time.Time `locationName:"lastDeploymentSucceededAt" type:"timestamp" required:"true"`

	// The service spec that was used to create the service pipeline.
	Spec *string `locationName:"spec" min:"1" type:"string" sensitive:"true"`

	// The ID of the major version of the service template that was used to create
	// the service pipeline.
	//
	// TemplateMajorVersion is a required field
	TemplateMajorVersion *string `locationName:"templateMajorVersion" min:"1" type:"string" required:"true"`

	// The ID of the minor version of the service template that was used to create
	// the service pipeline.
	//
	// TemplateMinorVersion is a required field
	TemplateMinorVersion *string `locationName:"templateMinorVersion" min:"1" type:"string" required:"true"`

	// The name of the service template that was used to create the service pipeline.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s ServicePipeline) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ServicePipeline) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *ServicePipeline) SetArn(v string) *ServicePipeline {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *ServicePipeline) SetCreatedAt(v time.Time) *ServicePipeline {
	s.CreatedAt = &v
	return s
}

// SetDeploymentStatus sets the DeploymentStatus field's value.
func (s *ServicePipeline) SetDeploymentStatus(v string) *ServicePipeline {
	s.DeploymentStatus = &v
	return s
}

// SetDeploymentStatusMessage sets the DeploymentStatusMessage field's value.
func (s *ServicePipeline) SetDeploymentStatusMessage(v string) *ServicePipeline {
	s.DeploymentStatusMessage = &v
	return s
}

// SetLastDeploymentAttemptedAt sets the LastDeploymentAttemptedAt field's value.
func (s *ServicePipeline) SetLastDeploymentAttemptedAt(v time.Time) *ServicePipeline {
	s.LastDeploymentAttemptedAt = &v
	return s
}

// SetLastDeploymentSucceededAt sets the LastDeploymentSucceededAt field's value.
func (s *ServicePipeline) SetLastDeploymentSucceededAt(v time.Time) *ServicePipeline {
	s.LastDeploymentSucceededAt = &v
	return s
}

// SetSpec sets the Spec field's value.
func (s *ServicePipeline) SetSpec(v string) *ServicePipeline {
	s.Spec = &v
	return s
}

// SetTemplateMajorVersion sets the TemplateMajorVersion field's value.
func (s *ServicePipeline) SetTemplateMajorVersion(v string) *ServicePipeline {
	s.TemplateMajorVersion = &v
	return s
}

// SetTemplateMinorVersion sets the TemplateMinorVersion field's value.
func (s *ServicePipeline) SetTemplateMinorVersion(v string) *ServicePipeline {
	s.TemplateMinorVersion = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *ServicePipeline) SetTemplateName(v string) *ServicePipeline {
	s.TemplateName = &v
	return s
}

// A quota was exceeded. For more information, see AWS Proton Quotas (https://docs.aws.amazon.com/proton/latest/adminguide/ag-limits.html)
// in the AWS Proton Administrator Guide.
type ServiceQuotaExceededException struct {
	_            struct{}                  `type:"structure"`
	RespMetadata protocol.ResponseMetadata `json:"-" xml:"-"`

	Message_ *string `locationName:"message" type:"string" sensitive:"true"`
}

// String returns the string representation
func (s ServiceQuotaExceededException) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ServiceQuotaExceededException) GoString() string {
	return s.String()
}

func newErrorServiceQuotaExceededException(v protocol.ResponseMetadata) error {
	return &ServiceQuotaExceededException{
		RespMetadata: v,
	}
}

// Code returns the exception type name.
func (s *ServiceQuotaExceededException) Code() string {
	return "ServiceQuotaExceededException"
}

// Message returns the exception's message.
func (s *ServiceQuotaExceededException) Message() string {
	if s.Message_ != nil {
		return *s.Message_
	}
	return ""
}

// OrigErr always returns nil, satisfies awserr.Error interface.
func (s *ServiceQuotaExceededException) OrigErr() error {
	return nil
}

func (s *ServiceQuotaExceededException) Error() string {
	return fmt.Sprintf("%s: %s", s.Code(), s.Message())
}

// Status code returns the HTTP status code for the request's response error.
func (s *ServiceQuotaExceededException) StatusCode() int {
	return s.RespMetadata.StatusCode
}

// RequestID returns the service's response RequestID for request.
func (s *ServiceQuotaExceededException) RequestID() string {
	return s.RespMetadata.RequestID
}

// A summary of the service detail data.
type ServiceSummary struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the service.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the service was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// A description of the service.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The time when the service was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The name of the service.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// The status of the service.
	//
	// Status is a required field
	Status *string `locationName:"status" type:"string" required:"true" enum:"ServiceStatus"`

	// A service status message.
	StatusMessage *string `locationName:"statusMessage" type:"string" sensitive:"true"`

	// The name of the service template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s ServiceSummary) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ServiceSummary) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *ServiceSummary) SetArn(v string) *ServiceSummary {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *ServiceSummary) SetCreatedAt(v time.Time) *ServiceSummary {
	s.CreatedAt = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *ServiceSummary) SetDescription(v string) *ServiceSummary {
	s.Description = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *ServiceSummary) SetLastModifiedAt(v time.Time) *ServiceSummary {
	s.LastModifiedAt = &v
	return s
}

// SetName sets the Name field's value.
func (s *ServiceSummary) SetName(v string) *ServiceSummary {
	s.Name = &v
	return s
}

// SetStatus sets the Status field's value.
func (s *ServiceSummary) SetStatus(v string) *ServiceSummary {
	s.Status = &v
	return s
}

// SetStatusMessage sets the StatusMessage field's value.
func (s *ServiceSummary) SetStatusMessage(v string) *ServiceSummary {
	s.StatusMessage = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *ServiceSummary) SetTemplateName(v string) *ServiceSummary {
	s.TemplateName = &v
	return s
}

// The service template detail data.
type ServiceTemplate struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the service template.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the service template was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// A description of the service template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The service template name as displayed in the developer interface.
	DisplayName *string `locationName:"displayName" min:"1" type:"string" sensitive:"true"`

	// The customer provided service template encryption key that's used to encrypt
	// data.
	EncryptionKey *string `locationName:"encryptionKey" min:"1" type:"string"`

	// The time when the service template was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The name of the service template.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// If pipelineProvisioning is true, a service pipeline is included in the service
	// template. Otherwise, a service pipeline isn't included in the service template.
	PipelineProvisioning *string `locationName:"pipelineProvisioning" type:"string" enum:"Provisioning"`

	// The ID of the recommended version of the service template.
	RecommendedVersion *string `locationName:"recommendedVersion" min:"1" type:"string"`
}

// String returns the string representation
func (s ServiceTemplate) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ServiceTemplate) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *ServiceTemplate) SetArn(v string) *ServiceTemplate {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *ServiceTemplate) SetCreatedAt(v time.Time) *ServiceTemplate {
	s.CreatedAt = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *ServiceTemplate) SetDescription(v string) *ServiceTemplate {
	s.Description = &v
	return s
}

// SetDisplayName sets the DisplayName field's value.
func (s *ServiceTemplate) SetDisplayName(v string) *ServiceTemplate {
	s.DisplayName = &v
	return s
}

// SetEncryptionKey sets the EncryptionKey field's value.
func (s *ServiceTemplate) SetEncryptionKey(v string) *ServiceTemplate {
	s.EncryptionKey = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *ServiceTemplate) SetLastModifiedAt(v time.Time) *ServiceTemplate {
	s.LastModifiedAt = &v
	return s
}

// SetName sets the Name field's value.
func (s *ServiceTemplate) SetName(v string) *ServiceTemplate {
	s.Name = &v
	return s
}

// SetPipelineProvisioning sets the PipelineProvisioning field's value.
func (s *ServiceTemplate) SetPipelineProvisioning(v string) *ServiceTemplate {
	s.PipelineProvisioning = &v
	return s
}

// SetRecommendedVersion sets the RecommendedVersion field's value.
func (s *ServiceTemplate) SetRecommendedVersion(v string) *ServiceTemplate {
	s.RecommendedVersion = &v
	return s
}

// The service template summary data.
type ServiceTemplateSummary struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the service template.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the service template was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// A description of the service template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The service template name as displayed in the developer interface.
	DisplayName *string `locationName:"displayName" min:"1" type:"string" sensitive:"true"`

	// The time when the service template was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The name of the service template.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// If pipelineProvisioning is true, a service pipeline is included in the service
	// template, otherwise a service pipeline isn't included in the service template.
	PipelineProvisioning *string `locationName:"pipelineProvisioning" type:"string" enum:"Provisioning"`

	// The ID of the recommended version of the service template.
	RecommendedVersion *string `locationName:"recommendedVersion" min:"1" type:"string"`
}

// String returns the string representation
func (s ServiceTemplateSummary) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ServiceTemplateSummary) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *ServiceTemplateSummary) SetArn(v string) *ServiceTemplateSummary {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *ServiceTemplateSummary) SetCreatedAt(v time.Time) *ServiceTemplateSummary {
	s.CreatedAt = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *ServiceTemplateSummary) SetDescription(v string) *ServiceTemplateSummary {
	s.Description = &v
	return s
}

// SetDisplayName sets the DisplayName field's value.
func (s *ServiceTemplateSummary) SetDisplayName(v string) *ServiceTemplateSummary {
	s.DisplayName = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *ServiceTemplateSummary) SetLastModifiedAt(v time.Time) *ServiceTemplateSummary {
	s.LastModifiedAt = &v
	return s
}

// SetName sets the Name field's value.
func (s *ServiceTemplateSummary) SetName(v string) *ServiceTemplateSummary {
	s.Name = &v
	return s
}

// SetPipelineProvisioning sets the PipelineProvisioning field's value.
func (s *ServiceTemplateSummary) SetPipelineProvisioning(v string) *ServiceTemplateSummary {
	s.PipelineProvisioning = &v
	return s
}

// SetRecommendedVersion sets the RecommendedVersion field's value.
func (s *ServiceTemplateSummary) SetRecommendedVersion(v string) *ServiceTemplateSummary {
	s.RecommendedVersion = &v
	return s
}

// The version of a service template detail data.
type ServiceTemplateVersion struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the version of a service template.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// An array of compatible environment template names for the major version of
	// a service template.
	//
	// CompatibleEnvironmentTemplates is a required field
	CompatibleEnvironmentTemplates []*CompatibleEnvironmentTemplate `locationName:"compatibleEnvironmentTemplates" type:"list" required:"true"`

	// The time when the version of a service template was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// A description of the version of a service template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The time when the version of a service template was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The ID of the latest major version that's associated with the version of
	// a service template.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// The ID of the minor version of a service template.
	//
	// MinorVersion is a required field
	MinorVersion *string `locationName:"minorVersion" min:"1" type:"string" required:"true"`

	// The ID of the recommended minor version of the service template.
	RecommendedMinorVersion *string `locationName:"recommendedMinorVersion" min:"1" type:"string"`

	// The schema of the version of a service template.
	Schema *string `locationName:"schema" min:"1" type:"string" sensitive:"true"`

	// The service template version status.
	//
	// Status is a required field
	Status *string `locationName:"status" type:"string" required:"true" enum:"TemplateVersionStatus"`

	// A service template version status message.
	StatusMessage *string `locationName:"statusMessage" type:"string" sensitive:"true"`

	// The name of the version of a service template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s ServiceTemplateVersion) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ServiceTemplateVersion) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *ServiceTemplateVersion) SetArn(v string) *ServiceTemplateVersion {
	s.Arn = &v
	return s
}

// SetCompatibleEnvironmentTemplates sets the CompatibleEnvironmentTemplates field's value.
func (s *ServiceTemplateVersion) SetCompatibleEnvironmentTemplates(v []*CompatibleEnvironmentTemplate) *ServiceTemplateVersion {
	s.CompatibleEnvironmentTemplates = v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *ServiceTemplateVersion) SetCreatedAt(v time.Time) *ServiceTemplateVersion {
	s.CreatedAt = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *ServiceTemplateVersion) SetDescription(v string) *ServiceTemplateVersion {
	s.Description = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *ServiceTemplateVersion) SetLastModifiedAt(v time.Time) *ServiceTemplateVersion {
	s.LastModifiedAt = &v
	return s
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *ServiceTemplateVersion) SetMajorVersion(v string) *ServiceTemplateVersion {
	s.MajorVersion = &v
	return s
}

// SetMinorVersion sets the MinorVersion field's value.
func (s *ServiceTemplateVersion) SetMinorVersion(v string) *ServiceTemplateVersion {
	s.MinorVersion = &v
	return s
}

// SetRecommendedMinorVersion sets the RecommendedMinorVersion field's value.
func (s *ServiceTemplateVersion) SetRecommendedMinorVersion(v string) *ServiceTemplateVersion {
	s.RecommendedMinorVersion = &v
	return s
}

// SetSchema sets the Schema field's value.
func (s *ServiceTemplateVersion) SetSchema(v string) *ServiceTemplateVersion {
	s.Schema = &v
	return s
}

// SetStatus sets the Status field's value.
func (s *ServiceTemplateVersion) SetStatus(v string) *ServiceTemplateVersion {
	s.Status = &v
	return s
}

// SetStatusMessage sets the StatusMessage field's value.
func (s *ServiceTemplateVersion) SetStatusMessage(v string) *ServiceTemplateVersion {
	s.StatusMessage = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *ServiceTemplateVersion) SetTemplateName(v string) *ServiceTemplateVersion {
	s.TemplateName = &v
	return s
}

// A summary of the service template version detail data.
type ServiceTemplateVersionSummary struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the version of a service template.
	//
	// Arn is a required field
	Arn *string `locationName:"arn" type:"string" required:"true"`

	// The time when the version of a service template was created.
	//
	// CreatedAt is a required field
	CreatedAt *time.Time `locationName:"createdAt" type:"timestamp" required:"true"`

	// A description of the version of a service template.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The time when the version of a service template was last modified.
	//
	// LastModifiedAt is a required field
	LastModifiedAt *time.Time `locationName:"lastModifiedAt" type:"timestamp" required:"true"`

	// The ID of the latest major version that's associated with the version of
	// a service template.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// The ID of the minor version of a service template.
	//
	// MinorVersion is a required field
	MinorVersion *string `locationName:"minorVersion" min:"1" type:"string" required:"true"`

	// The ID of the recommended minor version of the service template.
	RecommendedMinorVersion *string `locationName:"recommendedMinorVersion" min:"1" type:"string"`

	// The service template minor version status.
	//
	// Status is a required field
	Status *string `locationName:"status" type:"string" required:"true" enum:"TemplateVersionStatus"`

	// A service template minor version status message.
	StatusMessage *string `locationName:"statusMessage" type:"string" sensitive:"true"`

	// The name of the service template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s ServiceTemplateVersionSummary) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ServiceTemplateVersionSummary) GoString() string {
	return s.String()
}

// SetArn sets the Arn field's value.
func (s *ServiceTemplateVersionSummary) SetArn(v string) *ServiceTemplateVersionSummary {
	s.Arn = &v
	return s
}

// SetCreatedAt sets the CreatedAt field's value.
func (s *ServiceTemplateVersionSummary) SetCreatedAt(v time.Time) *ServiceTemplateVersionSummary {
	s.CreatedAt = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *ServiceTemplateVersionSummary) SetDescription(v string) *ServiceTemplateVersionSummary {
	s.Description = &v
	return s
}

// SetLastModifiedAt sets the LastModifiedAt field's value.
func (s *ServiceTemplateVersionSummary) SetLastModifiedAt(v time.Time) *ServiceTemplateVersionSummary {
	s.LastModifiedAt = &v
	return s
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *ServiceTemplateVersionSummary) SetMajorVersion(v string) *ServiceTemplateVersionSummary {
	s.MajorVersion = &v
	return s
}

// SetMinorVersion sets the MinorVersion field's value.
func (s *ServiceTemplateVersionSummary) SetMinorVersion(v string) *ServiceTemplateVersionSummary {
	s.MinorVersion = &v
	return s
}

// SetRecommendedMinorVersion sets the RecommendedMinorVersion field's value.
func (s *ServiceTemplateVersionSummary) SetRecommendedMinorVersion(v string) *ServiceTemplateVersionSummary {
	s.RecommendedMinorVersion = &v
	return s
}

// SetStatus sets the Status field's value.
func (s *ServiceTemplateVersionSummary) SetStatus(v string) *ServiceTemplateVersionSummary {
	s.Status = &v
	return s
}

// SetStatusMessage sets the StatusMessage field's value.
func (s *ServiceTemplateVersionSummary) SetStatusMessage(v string) *ServiceTemplateVersionSummary {
	s.StatusMessage = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *ServiceTemplateVersionSummary) SetTemplateName(v string) *ServiceTemplateVersionSummary {
	s.TemplateName = &v
	return s
}

// A description of a resource tag.
type Tag struct {
	_ struct{} `type:"structure"`

	// The key of the resource tag.
	//
	// Key is a required field
	Key *string `locationName:"key" min:"1" type:"string" required:"true"`

	// The value of the resource tag.
	//
	// Value is a required field
	Value *string `locationName:"value" type:"string" required:"true"`
}

// String returns the string representation
func (s Tag) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s Tag) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *Tag) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "Tag"}
	if s.Key == nil {
		invalidParams.Add(request.NewErrParamRequired("Key"))
	}
	if s.Key != nil && len(*s.Key) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Key", 1))
	}
	if s.Value == nil {
		invalidParams.Add(request.NewErrParamRequired("Value"))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetKey sets the Key field's value.
func (s *Tag) SetKey(v string) *Tag {
	s.Key = &v
	return s
}

// SetValue sets the Value field's value.
func (s *Tag) SetValue(v string) *Tag {
	s.Value = &v
	return s
}

type TagResourceInput struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the resource that the resource tag is applied
	// to.
	//
	// ResourceArn is a required field
	ResourceArn *string `locationName:"resourceArn" min:"1" type:"string" required:"true"`

	// An array of resource tags to apply to a resource.
	//
	// Tags is a required field
	Tags []*Tag `locationName:"tags" type:"list" required:"true"`
}

// String returns the string representation
func (s TagResourceInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s TagResourceInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *TagResourceInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "TagResourceInput"}
	if s.ResourceArn == nil {
		invalidParams.Add(request.NewErrParamRequired("ResourceArn"))
	}
	if s.ResourceArn != nil && len(*s.ResourceArn) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ResourceArn", 1))
	}
	if s.Tags == nil {
		invalidParams.Add(request.NewErrParamRequired("Tags"))
	}
	if s.Tags != nil {
		for i, v := range s.Tags {
			if v == nil {
				continue
			}
			if err := v.Validate(); err != nil {
				invalidParams.AddNested(fmt.Sprintf("%s[%v]", "Tags", i), err.(request.ErrInvalidParams))
			}
		}
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetResourceArn sets the ResourceArn field's value.
func (s *TagResourceInput) SetResourceArn(v string) *TagResourceInput {
	s.ResourceArn = &v
	return s
}

// SetTags sets the Tags field's value.
func (s *TagResourceInput) SetTags(v []*Tag) *TagResourceInput {
	s.Tags = v
	return s
}

type TagResourceOutput struct {
	_ struct{} `type:"structure"`
}

// String returns the string representation
func (s TagResourceOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s TagResourceOutput) GoString() string {
	return s.String()
}

// Template version source data.
type TemplateVersionSourceInput struct {
	_ struct{} `type:"structure"`

	// An S3 source object that includes the template bundle S3 path and name for
	// a template minor version.
	S3 *S3ObjectSource `locationName:"s3" type:"structure"`
}

// String returns the string representation
func (s TemplateVersionSourceInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s TemplateVersionSourceInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *TemplateVersionSourceInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "TemplateVersionSourceInput"}
	if s.S3 != nil {
		if err := s.S3.Validate(); err != nil {
			invalidParams.AddNested("S3", err.(request.ErrInvalidParams))
		}
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetS3 sets the S3 field's value.
func (s *TemplateVersionSourceInput) SetS3(v *S3ObjectSource) *TemplateVersionSourceInput {
	s.S3 = v
	return s
}

// The request was denied due to request throttling.
type ThrottlingException struct {
	_            struct{}                  `type:"structure"`
	RespMetadata protocol.ResponseMetadata `json:"-" xml:"-"`

	Message_ *string `locationName:"message" type:"string" sensitive:"true"`
}

// String returns the string representation
func (s ThrottlingException) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ThrottlingException) GoString() string {
	return s.String()
}

func newErrorThrottlingException(v protocol.ResponseMetadata) error {
	return &ThrottlingException{
		RespMetadata: v,
	}
}

// Code returns the exception type name.
func (s *ThrottlingException) Code() string {
	return "ThrottlingException"
}

// Message returns the exception's message.
func (s *ThrottlingException) Message() string {
	if s.Message_ != nil {
		return *s.Message_
	}
	return ""
}

// OrigErr always returns nil, satisfies awserr.Error interface.
func (s *ThrottlingException) OrigErr() error {
	return nil
}

func (s *ThrottlingException) Error() string {
	return fmt.Sprintf("%s: %s", s.Code(), s.Message())
}

// Status code returns the HTTP status code for the request's response error.
func (s *ThrottlingException) StatusCode() int {
	return s.RespMetadata.StatusCode
}

// RequestID returns the service's response RequestID for request.
func (s *ThrottlingException) RequestID() string {
	return s.RespMetadata.RequestID
}

type UntagResourceInput struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the resource that the tag is to be removed
	// from.
	//
	// ResourceArn is a required field
	ResourceArn *string `locationName:"resourceArn" min:"1" type:"string" required:"true"`

	// An array of tag keys indicating the resource tags to be removed from the
	// resource.
	//
	// TagKeys is a required field
	TagKeys []*string `locationName:"tagKeys" type:"list" required:"true"`
}

// String returns the string representation
func (s UntagResourceInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UntagResourceInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *UntagResourceInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "UntagResourceInput"}
	if s.ResourceArn == nil {
		invalidParams.Add(request.NewErrParamRequired("ResourceArn"))
	}
	if s.ResourceArn != nil && len(*s.ResourceArn) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ResourceArn", 1))
	}
	if s.TagKeys == nil {
		invalidParams.Add(request.NewErrParamRequired("TagKeys"))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetResourceArn sets the ResourceArn field's value.
func (s *UntagResourceInput) SetResourceArn(v string) *UntagResourceInput {
	s.ResourceArn = &v
	return s
}

// SetTagKeys sets the TagKeys field's value.
func (s *UntagResourceInput) SetTagKeys(v []*string) *UntagResourceInput {
	s.TagKeys = v
	return s
}

type UntagResourceOutput struct {
	_ struct{} `type:"structure"`
}

// String returns the string representation
func (s UntagResourceOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UntagResourceOutput) GoString() string {
	return s.String()
}

type UpdateAccountSettingsInput struct {
	_ struct{} `type:"structure"`

	// The Amazon Resource Name (ARN) of the AWS Proton pipeline service role.
	PipelineServiceRoleArn *string `locationName:"pipelineServiceRoleArn" min:"1" type:"string"`
}

// String returns the string representation
func (s UpdateAccountSettingsInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateAccountSettingsInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *UpdateAccountSettingsInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "UpdateAccountSettingsInput"}
	if s.PipelineServiceRoleArn != nil && len(*s.PipelineServiceRoleArn) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("PipelineServiceRoleArn", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetPipelineServiceRoleArn sets the PipelineServiceRoleArn field's value.
func (s *UpdateAccountSettingsInput) SetPipelineServiceRoleArn(v string) *UpdateAccountSettingsInput {
	s.PipelineServiceRoleArn = &v
	return s
}

type UpdateAccountSettingsOutput struct {
	_ struct{} `type:"structure"`

	// The AWS Proton pipeline service role detail data that's returned by AWS Proton.
	//
	// AccountSettings is a required field
	AccountSettings *AccountSettings `locationName:"accountSettings" type:"structure" required:"true"`
}

// String returns the string representation
func (s UpdateAccountSettingsOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateAccountSettingsOutput) GoString() string {
	return s.String()
}

// SetAccountSettings sets the AccountSettings field's value.
func (s *UpdateAccountSettingsOutput) SetAccountSettings(v *AccountSettings) *UpdateAccountSettingsOutput {
	s.AccountSettings = v
	return s
}

type UpdateEnvironmentAccountConnectionInput struct {
	_ struct{} `type:"structure"`

	// The ID of the environment account connection to update.
	//
	// Id is a required field
	Id *string `locationName:"id" type:"string" required:"true"`

	// The Amazon Resource Name (ARN) of the IAM service role that is associated
	// with the environment account connection to update.
	//
	// RoleArn is a required field
	RoleArn *string `locationName:"roleArn" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s UpdateEnvironmentAccountConnectionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateEnvironmentAccountConnectionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *UpdateEnvironmentAccountConnectionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "UpdateEnvironmentAccountConnectionInput"}
	if s.Id == nil {
		invalidParams.Add(request.NewErrParamRequired("Id"))
	}
	if s.RoleArn == nil {
		invalidParams.Add(request.NewErrParamRequired("RoleArn"))
	}
	if s.RoleArn != nil && len(*s.RoleArn) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("RoleArn", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetId sets the Id field's value.
func (s *UpdateEnvironmentAccountConnectionInput) SetId(v string) *UpdateEnvironmentAccountConnectionInput {
	s.Id = &v
	return s
}

// SetRoleArn sets the RoleArn field's value.
func (s *UpdateEnvironmentAccountConnectionInput) SetRoleArn(v string) *UpdateEnvironmentAccountConnectionInput {
	s.RoleArn = &v
	return s
}

type UpdateEnvironmentAccountConnectionOutput struct {
	_ struct{} `type:"structure"`

	// The environment account connection detail data that's returned by AWS Proton.
	//
	// EnvironmentAccountConnection is a required field
	EnvironmentAccountConnection *EnvironmentAccountConnection `locationName:"environmentAccountConnection" type:"structure" required:"true"`
}

// String returns the string representation
func (s UpdateEnvironmentAccountConnectionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateEnvironmentAccountConnectionOutput) GoString() string {
	return s.String()
}

// SetEnvironmentAccountConnection sets the EnvironmentAccountConnection field's value.
func (s *UpdateEnvironmentAccountConnectionOutput) SetEnvironmentAccountConnection(v *EnvironmentAccountConnection) *UpdateEnvironmentAccountConnectionOutput {
	s.EnvironmentAccountConnection = v
	return s
}

type UpdateEnvironmentInput struct {
	_ struct{} `type:"structure"`

	// There are four modes for updating an environment as described in the following.
	// The deploymentType field defines the mode.
	//
	// NONE
	//
	// In this mode, a deployment doesn't occur. Only the requested metadata parameters
	// are updated.
	//
	// CURRENT_VERSION
	//
	// In this mode, the environment is deployed and updated with the new spec that
	// you provide. Only requested parameters are updated. Don’t include minor
	// or major version parameters when you use this deployment-type.
	//
	// MINOR_VERSION
	//
	// In this mode, the environment is deployed and updated with the published,
	// recommended (latest) minor version of the current major version in use, by
	// default. You can also specify a different minor version of the current major
	// version in use.
	//
	// MAJOR_VERSION
	//
	// In this mode, the environment is deployed and updated with the published,
	// recommended (latest) major and minor version of the current template, by
	// default. You can also specify a different major version that is higher than
	// the major version in use and a minor version (optional).
	//
	// DeploymentType is a required field
	DeploymentType *string `locationName:"deploymentType" type:"string" required:"true" enum:"DeploymentUpdateType"`

	// A description of the environment update.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The ID of the environment account connection.
	//
	// You can only update to a new environment account connection if it was created
	// in the same environment account that the current environment account connection
	// was created in and is associated with the current environment.
	EnvironmentAccountConnectionId *string `locationName:"environmentAccountConnectionId" type:"string"`

	// The name of the environment to update.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// The Amazon Resource Name (ARN) of the AWS Proton service role that allows
	// AWS Proton to make API calls to other services your behalf.
	ProtonServiceRoleArn *string `locationName:"protonServiceRoleArn" min:"1" type:"string"`

	// The formatted specification that defines the update.
	Spec *string `locationName:"spec" min:"1" type:"string" sensitive:"true"`

	// The ID of the major version of the environment to update.
	TemplateMajorVersion *string `locationName:"templateMajorVersion" min:"1" type:"string"`

	// The ID of the minor version of the environment to update.
	TemplateMinorVersion *string `locationName:"templateMinorVersion" min:"1" type:"string"`
}

// String returns the string representation
func (s UpdateEnvironmentInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateEnvironmentInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *UpdateEnvironmentInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "UpdateEnvironmentInput"}
	if s.DeploymentType == nil {
		invalidParams.Add(request.NewErrParamRequired("DeploymentType"))
	}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}
	if s.ProtonServiceRoleArn != nil && len(*s.ProtonServiceRoleArn) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ProtonServiceRoleArn", 1))
	}
	if s.Spec != nil && len(*s.Spec) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Spec", 1))
	}
	if s.TemplateMajorVersion != nil && len(*s.TemplateMajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateMajorVersion", 1))
	}
	if s.TemplateMinorVersion != nil && len(*s.TemplateMinorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateMinorVersion", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetDeploymentType sets the DeploymentType field's value.
func (s *UpdateEnvironmentInput) SetDeploymentType(v string) *UpdateEnvironmentInput {
	s.DeploymentType = &v
	return s
}

// SetDescription sets the Description field's value.
func (s *UpdateEnvironmentInput) SetDescription(v string) *UpdateEnvironmentInput {
	s.Description = &v
	return s
}

// SetEnvironmentAccountConnectionId sets the EnvironmentAccountConnectionId field's value.
func (s *UpdateEnvironmentInput) SetEnvironmentAccountConnectionId(v string) *UpdateEnvironmentInput {
	s.EnvironmentAccountConnectionId = &v
	return s
}

// SetName sets the Name field's value.
func (s *UpdateEnvironmentInput) SetName(v string) *UpdateEnvironmentInput {
	s.Name = &v
	return s
}

// SetProtonServiceRoleArn sets the ProtonServiceRoleArn field's value.
func (s *UpdateEnvironmentInput) SetProtonServiceRoleArn(v string) *UpdateEnvironmentInput {
	s.ProtonServiceRoleArn = &v
	return s
}

// SetSpec sets the Spec field's value.
func (s *UpdateEnvironmentInput) SetSpec(v string) *UpdateEnvironmentInput {
	s.Spec = &v
	return s
}

// SetTemplateMajorVersion sets the TemplateMajorVersion field's value.
func (s *UpdateEnvironmentInput) SetTemplateMajorVersion(v string) *UpdateEnvironmentInput {
	s.TemplateMajorVersion = &v
	return s
}

// SetTemplateMinorVersion sets the TemplateMinorVersion field's value.
func (s *UpdateEnvironmentInput) SetTemplateMinorVersion(v string) *UpdateEnvironmentInput {
	s.TemplateMinorVersion = &v
	return s
}

type UpdateEnvironmentOutput struct {
	_ struct{} `type:"structure"`

	// The environment detail data that's returned by AWS Proton.
	//
	// Environment is a required field
	Environment *Environment `locationName:"environment" type:"structure" required:"true"`
}

// String returns the string representation
func (s UpdateEnvironmentOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateEnvironmentOutput) GoString() string {
	return s.String()
}

// SetEnvironment sets the Environment field's value.
func (s *UpdateEnvironmentOutput) SetEnvironment(v *Environment) *UpdateEnvironmentOutput {
	s.Environment = v
	return s
}

type UpdateEnvironmentTemplateInput struct {
	_ struct{} `type:"structure"`

	// A description of the environment template update.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The name of the environment template to update as displayed in the developer
	// interface.
	DisplayName *string `locationName:"displayName" min:"1" type:"string" sensitive:"true"`

	// The name of the environment template to update.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s UpdateEnvironmentTemplateInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateEnvironmentTemplateInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *UpdateEnvironmentTemplateInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "UpdateEnvironmentTemplateInput"}
	if s.DisplayName != nil && len(*s.DisplayName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("DisplayName", 1))
	}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetDescription sets the Description field's value.
func (s *UpdateEnvironmentTemplateInput) SetDescription(v string) *UpdateEnvironmentTemplateInput {
	s.Description = &v
	return s
}

// SetDisplayName sets the DisplayName field's value.
func (s *UpdateEnvironmentTemplateInput) SetDisplayName(v string) *UpdateEnvironmentTemplateInput {
	s.DisplayName = &v
	return s
}

// SetName sets the Name field's value.
func (s *UpdateEnvironmentTemplateInput) SetName(v string) *UpdateEnvironmentTemplateInput {
	s.Name = &v
	return s
}

type UpdateEnvironmentTemplateOutput struct {
	_ struct{} `type:"structure"`

	// The environment template detail data that's returned by AWS Proton.
	//
	// EnvironmentTemplate is a required field
	EnvironmentTemplate *EnvironmentTemplate `locationName:"environmentTemplate" type:"structure" required:"true"`
}

// String returns the string representation
func (s UpdateEnvironmentTemplateOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateEnvironmentTemplateOutput) GoString() string {
	return s.String()
}

// SetEnvironmentTemplate sets the EnvironmentTemplate field's value.
func (s *UpdateEnvironmentTemplateOutput) SetEnvironmentTemplate(v *EnvironmentTemplate) *UpdateEnvironmentTemplateOutput {
	s.EnvironmentTemplate = v
	return s
}

type UpdateEnvironmentTemplateVersionInput struct {
	_ struct{} `type:"structure"`

	// A description of environment template version to update.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// To update a major version of an environment template, include majorVersion.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// To update a minor version of an environment template, include minorVersion.
	//
	// MinorVersion is a required field
	MinorVersion *string `locationName:"minorVersion" min:"1" type:"string" required:"true"`

	// The status of the environment template minor version to update.
	Status *string `locationName:"status" type:"string" enum:"TemplateVersionStatus"`

	// The name of the environment template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s UpdateEnvironmentTemplateVersionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateEnvironmentTemplateVersionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *UpdateEnvironmentTemplateVersionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "UpdateEnvironmentTemplateVersionInput"}
	if s.MajorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MajorVersion"))
	}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.MinorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MinorVersion"))
	}
	if s.MinorVersion != nil && len(*s.MinorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MinorVersion", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetDescription sets the Description field's value.
func (s *UpdateEnvironmentTemplateVersionInput) SetDescription(v string) *UpdateEnvironmentTemplateVersionInput {
	s.Description = &v
	return s
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *UpdateEnvironmentTemplateVersionInput) SetMajorVersion(v string) *UpdateEnvironmentTemplateVersionInput {
	s.MajorVersion = &v
	return s
}

// SetMinorVersion sets the MinorVersion field's value.
func (s *UpdateEnvironmentTemplateVersionInput) SetMinorVersion(v string) *UpdateEnvironmentTemplateVersionInput {
	s.MinorVersion = &v
	return s
}

// SetStatus sets the Status field's value.
func (s *UpdateEnvironmentTemplateVersionInput) SetStatus(v string) *UpdateEnvironmentTemplateVersionInput {
	s.Status = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *UpdateEnvironmentTemplateVersionInput) SetTemplateName(v string) *UpdateEnvironmentTemplateVersionInput {
	s.TemplateName = &v
	return s
}

type UpdateEnvironmentTemplateVersionOutput struct {
	_ struct{} `type:"structure"`

	// The environment template version detail data that's returned by AWS Proton.
	//
	// EnvironmentTemplateVersion is a required field
	EnvironmentTemplateVersion *EnvironmentTemplateVersion `locationName:"environmentTemplateVersion" type:"structure" required:"true"`
}

// String returns the string representation
func (s UpdateEnvironmentTemplateVersionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateEnvironmentTemplateVersionOutput) GoString() string {
	return s.String()
}

// SetEnvironmentTemplateVersion sets the EnvironmentTemplateVersion field's value.
func (s *UpdateEnvironmentTemplateVersionOutput) SetEnvironmentTemplateVersion(v *EnvironmentTemplateVersion) *UpdateEnvironmentTemplateVersionOutput {
	s.EnvironmentTemplateVersion = v
	return s
}

type UpdateServiceInput struct {
	_ struct{} `type:"structure"`

	// The edited service description.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The name of the service to edit.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// Lists the service instances to add and the existing service instances to
	// remain. Omit the existing service instances to delete from the list. Don't
	// include edits to the existing service instances or pipeline. For more information,
	// see Edit a service in the AWS Proton Administrator Guide (https://docs.aws.amazon.com/proton/latest/adminguide/ag-svc-update.html)
	// or the AWS Proton User Guide (https://docs.aws.amazon.com/proton/latest/userguide/ug-svc-update.html).
	Spec *string `locationName:"spec" min:"1" type:"string" sensitive:"true"`
}

// String returns the string representation
func (s UpdateServiceInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateServiceInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *UpdateServiceInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "UpdateServiceInput"}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}
	if s.Spec != nil && len(*s.Spec) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Spec", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetDescription sets the Description field's value.
func (s *UpdateServiceInput) SetDescription(v string) *UpdateServiceInput {
	s.Description = &v
	return s
}

// SetName sets the Name field's value.
func (s *UpdateServiceInput) SetName(v string) *UpdateServiceInput {
	s.Name = &v
	return s
}

// SetSpec sets the Spec field's value.
func (s *UpdateServiceInput) SetSpec(v string) *UpdateServiceInput {
	s.Spec = &v
	return s
}

type UpdateServiceInstanceInput struct {
	_ struct{} `type:"structure"`

	// The deployment type.
	//
	// There are four modes for updating a service instance as described in the
	// following. The deploymentType field defines the mode.
	//
	// NONE
	//
	// In this mode, a deployment doesn't occur. Only the requested metadata parameters
	// are updated.
	//
	// CURRENT_VERSION
	//
	// In this mode, the service instance is deployed and updated with the new spec
	// that you provide. Only requested parameters are updated. Don’t include
	// minor or major version parameters when you use this deployment-type.
	//
	// MINOR_VERSION
	//
	// In this mode, the service instance is deployed and updated with the published,
	// recommended (latest) minor version of the current major version in use, by
	// default. You can also specify a different minor version of the current major
	// version in use.
	//
	// MAJOR_VERSION
	//
	// In this mode, the service instance is deployed and updated with the published,
	// recommended (latest) major and minor version of the current template, by
	// default. You can also specify a different major version that is higher than
	// the major version in use and a minor version (optional).
	//
	// DeploymentType is a required field
	DeploymentType *string `locationName:"deploymentType" type:"string" required:"true" enum:"DeploymentUpdateType"`

	// The name of the service instance to update.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`

	// The name of the service that the service instance belongs to.
	//
	// ServiceName is a required field
	ServiceName *string `locationName:"serviceName" min:"1" type:"string" required:"true"`

	// The formatted specification that defines the service instance update.
	Spec *string `locationName:"spec" min:"1" type:"string" sensitive:"true"`

	// The major version of the service template to update.
	TemplateMajorVersion *string `locationName:"templateMajorVersion" min:"1" type:"string"`

	// The minor version of the service template to update.
	TemplateMinorVersion *string `locationName:"templateMinorVersion" min:"1" type:"string"`
}

// String returns the string representation
func (s UpdateServiceInstanceInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateServiceInstanceInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *UpdateServiceInstanceInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "UpdateServiceInstanceInput"}
	if s.DeploymentType == nil {
		invalidParams.Add(request.NewErrParamRequired("DeploymentType"))
	}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}
	if s.ServiceName == nil {
		invalidParams.Add(request.NewErrParamRequired("ServiceName"))
	}
	if s.ServiceName != nil && len(*s.ServiceName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ServiceName", 1))
	}
	if s.Spec != nil && len(*s.Spec) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Spec", 1))
	}
	if s.TemplateMajorVersion != nil && len(*s.TemplateMajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateMajorVersion", 1))
	}
	if s.TemplateMinorVersion != nil && len(*s.TemplateMinorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateMinorVersion", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetDeploymentType sets the DeploymentType field's value.
func (s *UpdateServiceInstanceInput) SetDeploymentType(v string) *UpdateServiceInstanceInput {
	s.DeploymentType = &v
	return s
}

// SetName sets the Name field's value.
func (s *UpdateServiceInstanceInput) SetName(v string) *UpdateServiceInstanceInput {
	s.Name = &v
	return s
}

// SetServiceName sets the ServiceName field's value.
func (s *UpdateServiceInstanceInput) SetServiceName(v string) *UpdateServiceInstanceInput {
	s.ServiceName = &v
	return s
}

// SetSpec sets the Spec field's value.
func (s *UpdateServiceInstanceInput) SetSpec(v string) *UpdateServiceInstanceInput {
	s.Spec = &v
	return s
}

// SetTemplateMajorVersion sets the TemplateMajorVersion field's value.
func (s *UpdateServiceInstanceInput) SetTemplateMajorVersion(v string) *UpdateServiceInstanceInput {
	s.TemplateMajorVersion = &v
	return s
}

// SetTemplateMinorVersion sets the TemplateMinorVersion field's value.
func (s *UpdateServiceInstanceInput) SetTemplateMinorVersion(v string) *UpdateServiceInstanceInput {
	s.TemplateMinorVersion = &v
	return s
}

type UpdateServiceInstanceOutput struct {
	_ struct{} `type:"structure"`

	// The service instance summary data returned by AWS Proton.
	//
	// ServiceInstance is a required field
	ServiceInstance *ServiceInstance `locationName:"serviceInstance" type:"structure" required:"true"`
}

// String returns the string representation
func (s UpdateServiceInstanceOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateServiceInstanceOutput) GoString() string {
	return s.String()
}

// SetServiceInstance sets the ServiceInstance field's value.
func (s *UpdateServiceInstanceOutput) SetServiceInstance(v *ServiceInstance) *UpdateServiceInstanceOutput {
	s.ServiceInstance = v
	return s
}

type UpdateServiceOutput struct {
	_ struct{} `type:"structure"`

	// The service detail data that's returned by AWS Proton.
	//
	// Service is a required field
	Service *Service `locationName:"service" type:"structure" required:"true"`
}

// String returns the string representation
func (s UpdateServiceOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateServiceOutput) GoString() string {
	return s.String()
}

// SetService sets the Service field's value.
func (s *UpdateServiceOutput) SetService(v *Service) *UpdateServiceOutput {
	s.Service = v
	return s
}

type UpdateServicePipelineInput struct {
	_ struct{} `type:"structure"`

	// The deployment type.
	//
	// There are four modes for updating a service pipeline as described in the
	// following. The deploymentType field defines the mode.
	//
	// NONE
	//
	// In this mode, a deployment doesn't occur. Only the requested metadata parameters
	// are updated.
	//
	// CURRENT_VERSION
	//
	// In this mode, the service pipeline is deployed and updated with the new spec
	// that you provide. Only requested parameters are updated. Don’t include
	// minor or major version parameters when you use this deployment-type.
	//
	// MINOR_VERSION
	//
	// In this mode, the service pipeline is deployed and updated with the published,
	// recommended (latest) minor version of the current major version in use, by
	// default. You can also specify a different minor version of the current major
	// version in use.
	//
	// MAJOR_VERSION
	//
	// In this mode, the service pipeline is deployed and updated with the published,
	// recommended (latest) major and minor version of the current template, by
	// default. You can also specify a different major version that is higher than
	// the major version in use and a minor version (optional).
	//
	// DeploymentType is a required field
	DeploymentType *string `locationName:"deploymentType" type:"string" required:"true" enum:"DeploymentUpdateType"`

	// The name of the service to that the pipeline is associated with.
	//
	// ServiceName is a required field
	ServiceName *string `locationName:"serviceName" min:"1" type:"string" required:"true"`

	// The spec for the service pipeline to update.
	//
	// Spec is a required field
	Spec *string `locationName:"spec" min:"1" type:"string" required:"true" sensitive:"true"`

	// The major version of the service template that was used to create the service
	// that the pipeline is associated with.
	TemplateMajorVersion *string `locationName:"templateMajorVersion" min:"1" type:"string"`

	// The minor version of the service template that was used to create the service
	// that the pipeline is associated with.
	TemplateMinorVersion *string `locationName:"templateMinorVersion" min:"1" type:"string"`
}

// String returns the string representation
func (s UpdateServicePipelineInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateServicePipelineInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *UpdateServicePipelineInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "UpdateServicePipelineInput"}
	if s.DeploymentType == nil {
		invalidParams.Add(request.NewErrParamRequired("DeploymentType"))
	}
	if s.ServiceName == nil {
		invalidParams.Add(request.NewErrParamRequired("ServiceName"))
	}
	if s.ServiceName != nil && len(*s.ServiceName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("ServiceName", 1))
	}
	if s.Spec == nil {
		invalidParams.Add(request.NewErrParamRequired("Spec"))
	}
	if s.Spec != nil && len(*s.Spec) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Spec", 1))
	}
	if s.TemplateMajorVersion != nil && len(*s.TemplateMajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateMajorVersion", 1))
	}
	if s.TemplateMinorVersion != nil && len(*s.TemplateMinorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateMinorVersion", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetDeploymentType sets the DeploymentType field's value.
func (s *UpdateServicePipelineInput) SetDeploymentType(v string) *UpdateServicePipelineInput {
	s.DeploymentType = &v
	return s
}

// SetServiceName sets the ServiceName field's value.
func (s *UpdateServicePipelineInput) SetServiceName(v string) *UpdateServicePipelineInput {
	s.ServiceName = &v
	return s
}

// SetSpec sets the Spec field's value.
func (s *UpdateServicePipelineInput) SetSpec(v string) *UpdateServicePipelineInput {
	s.Spec = &v
	return s
}

// SetTemplateMajorVersion sets the TemplateMajorVersion field's value.
func (s *UpdateServicePipelineInput) SetTemplateMajorVersion(v string) *UpdateServicePipelineInput {
	s.TemplateMajorVersion = &v
	return s
}

// SetTemplateMinorVersion sets the TemplateMinorVersion field's value.
func (s *UpdateServicePipelineInput) SetTemplateMinorVersion(v string) *UpdateServicePipelineInput {
	s.TemplateMinorVersion = &v
	return s
}

type UpdateServicePipelineOutput struct {
	_ struct{} `type:"structure"`

	// The pipeline details returned by AWS Proton.
	//
	// Pipeline is a required field
	Pipeline *ServicePipeline `locationName:"pipeline" type:"structure" required:"true"`
}

// String returns the string representation
func (s UpdateServicePipelineOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateServicePipelineOutput) GoString() string {
	return s.String()
}

// SetPipeline sets the Pipeline field's value.
func (s *UpdateServicePipelineOutput) SetPipeline(v *ServicePipeline) *UpdateServicePipelineOutput {
	s.Pipeline = v
	return s
}

type UpdateServiceTemplateInput struct {
	_ struct{} `type:"structure"`

	// A description of the service template update.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// The name of the service template to update as displayed in the developer
	// interface.
	DisplayName *string `locationName:"displayName" min:"1" type:"string" sensitive:"true"`

	// The name of the service template to update.
	//
	// Name is a required field
	Name *string `locationName:"name" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s UpdateServiceTemplateInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateServiceTemplateInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *UpdateServiceTemplateInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "UpdateServiceTemplateInput"}
	if s.DisplayName != nil && len(*s.DisplayName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("DisplayName", 1))
	}
	if s.Name == nil {
		invalidParams.Add(request.NewErrParamRequired("Name"))
	}
	if s.Name != nil && len(*s.Name) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("Name", 1))
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetDescription sets the Description field's value.
func (s *UpdateServiceTemplateInput) SetDescription(v string) *UpdateServiceTemplateInput {
	s.Description = &v
	return s
}

// SetDisplayName sets the DisplayName field's value.
func (s *UpdateServiceTemplateInput) SetDisplayName(v string) *UpdateServiceTemplateInput {
	s.DisplayName = &v
	return s
}

// SetName sets the Name field's value.
func (s *UpdateServiceTemplateInput) SetName(v string) *UpdateServiceTemplateInput {
	s.Name = &v
	return s
}

type UpdateServiceTemplateOutput struct {
	_ struct{} `type:"structure"`

	// The service template detail data that's returned by AWS Proton.
	//
	// ServiceTemplate is a required field
	ServiceTemplate *ServiceTemplate `locationName:"serviceTemplate" type:"structure" required:"true"`
}

// String returns the string representation
func (s UpdateServiceTemplateOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateServiceTemplateOutput) GoString() string {
	return s.String()
}

// SetServiceTemplate sets the ServiceTemplate field's value.
func (s *UpdateServiceTemplateOutput) SetServiceTemplate(v *ServiceTemplate) *UpdateServiceTemplateOutput {
	s.ServiceTemplate = v
	return s
}

type UpdateServiceTemplateVersionInput struct {
	_ struct{} `type:"structure"`

	// An array of compatible environment names for a service template major or
	// minor version to update.
	CompatibleEnvironmentTemplates []*CompatibleEnvironmentTemplateInput `locationName:"compatibleEnvironmentTemplates" min:"1" type:"list"`

	// A description of a service template version to update.
	Description *string `locationName:"description" type:"string" sensitive:"true"`

	// To update a major version of a service template, include majorVersion.
	//
	// MajorVersion is a required field
	MajorVersion *string `locationName:"majorVersion" min:"1" type:"string" required:"true"`

	// To update a minor version of a service template, include minorVersion.
	//
	// MinorVersion is a required field
	MinorVersion *string `locationName:"minorVersion" min:"1" type:"string" required:"true"`

	// The status of the service template minor version to update.
	Status *string `locationName:"status" type:"string" enum:"TemplateVersionStatus"`

	// The name of the service template.
	//
	// TemplateName is a required field
	TemplateName *string `locationName:"templateName" min:"1" type:"string" required:"true"`
}

// String returns the string representation
func (s UpdateServiceTemplateVersionInput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateServiceTemplateVersionInput) GoString() string {
	return s.String()
}

// Validate inspects the fields of the type to determine if they are valid.
func (s *UpdateServiceTemplateVersionInput) Validate() error {
	invalidParams := request.ErrInvalidParams{Context: "UpdateServiceTemplateVersionInput"}
	if s.CompatibleEnvironmentTemplates != nil && len(s.CompatibleEnvironmentTemplates) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("CompatibleEnvironmentTemplates", 1))
	}
	if s.MajorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MajorVersion"))
	}
	if s.MajorVersion != nil && len(*s.MajorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MajorVersion", 1))
	}
	if s.MinorVersion == nil {
		invalidParams.Add(request.NewErrParamRequired("MinorVersion"))
	}
	if s.MinorVersion != nil && len(*s.MinorVersion) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("MinorVersion", 1))
	}
	if s.TemplateName == nil {
		invalidParams.Add(request.NewErrParamRequired("TemplateName"))
	}
	if s.TemplateName != nil && len(*s.TemplateName) < 1 {
		invalidParams.Add(request.NewErrParamMinLen("TemplateName", 1))
	}
	if s.CompatibleEnvironmentTemplates != nil {
		for i, v := range s.CompatibleEnvironmentTemplates {
			if v == nil {
				continue
			}
			if err := v.Validate(); err != nil {
				invalidParams.AddNested(fmt.Sprintf("%s[%v]", "CompatibleEnvironmentTemplates", i), err.(request.ErrInvalidParams))
			}
		}
	}

	if invalidParams.Len() > 0 {
		return invalidParams
	}
	return nil
}

// SetCompatibleEnvironmentTemplates sets the CompatibleEnvironmentTemplates field's value.
func (s *UpdateServiceTemplateVersionInput) SetCompatibleEnvironmentTemplates(v []*CompatibleEnvironmentTemplateInput) *UpdateServiceTemplateVersionInput {
	s.CompatibleEnvironmentTemplates = v
	return s
}

// SetDescription sets the Description field's value.
func (s *UpdateServiceTemplateVersionInput) SetDescription(v string) *UpdateServiceTemplateVersionInput {
	s.Description = &v
	return s
}

// SetMajorVersion sets the MajorVersion field's value.
func (s *UpdateServiceTemplateVersionInput) SetMajorVersion(v string) *UpdateServiceTemplateVersionInput {
	s.MajorVersion = &v
	return s
}

// SetMinorVersion sets the MinorVersion field's value.
func (s *UpdateServiceTemplateVersionInput) SetMinorVersion(v string) *UpdateServiceTemplateVersionInput {
	s.MinorVersion = &v
	return s
}

// SetStatus sets the Status field's value.
func (s *UpdateServiceTemplateVersionInput) SetStatus(v string) *UpdateServiceTemplateVersionInput {
	s.Status = &v
	return s
}

// SetTemplateName sets the TemplateName field's value.
func (s *UpdateServiceTemplateVersionInput) SetTemplateName(v string) *UpdateServiceTemplateVersionInput {
	s.TemplateName = &v
	return s
}

type UpdateServiceTemplateVersionOutput struct {
	_ struct{} `type:"structure"`

	// The service template version detail data that's returned by AWS Proton.
	//
	// ServiceTemplateVersion is a required field
	ServiceTemplateVersion *ServiceTemplateVersion `locationName:"serviceTemplateVersion" type:"structure" required:"true"`
}

// String returns the string representation
func (s UpdateServiceTemplateVersionOutput) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s UpdateServiceTemplateVersionOutput) GoString() string {
	return s.String()
}

// SetServiceTemplateVersion sets the ServiceTemplateVersion field's value.
func (s *UpdateServiceTemplateVersionOutput) SetServiceTemplateVersion(v *ServiceTemplateVersion) *UpdateServiceTemplateVersionOutput {
	s.ServiceTemplateVersion = v
	return s
}

// The input is invalid or an out-of-range value was supplied for the input
// parameter.
type ValidationException struct {
	_            struct{}                  `type:"structure"`
	RespMetadata protocol.ResponseMetadata `json:"-" xml:"-"`

	Message_ *string `locationName:"message" type:"string" sensitive:"true"`
}

// String returns the string representation
func (s ValidationException) String() string {
	return awsutil.Prettify(s)
}

// GoString returns the string representation
func (s ValidationException) GoString() string {
	return s.String()
}

func newErrorValidationException(v protocol.ResponseMetadata) error {
	return &ValidationException{
		RespMetadata: v,
	}
}

// Code returns the exception type name.
func (s *ValidationException) Code() string {
	return "ValidationException"
}

// Message returns the exception's message.
func (s *ValidationException) Message() string {
	if s.Message_ != nil {
		return *s.Message_
	}
	return ""
}

// OrigErr always returns nil, satisfies awserr.Error interface.
func (s *ValidationException) OrigErr() error {
	return nil
}

func (s *ValidationException) Error() string {
	return fmt.Sprintf("%s: %s", s.Code(), s.Message())
}

// Status code returns the HTTP status code for the request's response error.
func (s *ValidationException) StatusCode() int {
	return s.RespMetadata.StatusCode
}

// RequestID returns the service's response RequestID for request.
func (s *ValidationException) RequestID() string {
	return s.RespMetadata.RequestID
}

const (
	// DeploymentStatusInProgress is a DeploymentStatus enum value
	DeploymentStatusInProgress = "IN_PROGRESS"

	// DeploymentStatusFailed is a DeploymentStatus enum value
	DeploymentStatusFailed = "FAILED"

	// DeploymentStatusSucceeded is a DeploymentStatus enum value
	DeploymentStatusSucceeded = "SUCCEEDED"

	// DeploymentStatusDeleteInProgress is a DeploymentStatus enum value
	DeploymentStatusDeleteInProgress = "DELETE_IN_PROGRESS"

	// DeploymentStatusDeleteFailed is a DeploymentStatus enum value
	DeploymentStatusDeleteFailed = "DELETE_FAILED"

	// DeploymentStatusDeleteComplete is a DeploymentStatus enum value
	DeploymentStatusDeleteComplete = "DELETE_COMPLETE"

	// DeploymentStatusCancelling is a DeploymentStatus enum value
	DeploymentStatusCancelling = "CANCELLING"

	// DeploymentStatusCancelled is a DeploymentStatus enum value
	DeploymentStatusCancelled = "CANCELLED"
)

// DeploymentStatus_Values returns all elements of the DeploymentStatus enum
func DeploymentStatus_Values() []string {
	return []string{
		DeploymentStatusInProgress,
		DeploymentStatusFailed,
		DeploymentStatusSucceeded,
		DeploymentStatusDeleteInProgress,
		DeploymentStatusDeleteFailed,
		DeploymentStatusDeleteComplete,
		DeploymentStatusCancelling,
		DeploymentStatusCancelled,
	}
}

const (
	// DeploymentUpdateTypeNone is a DeploymentUpdateType enum value
	DeploymentUpdateTypeNone = "NONE"

	// DeploymentUpdateTypeCurrentVersion is a DeploymentUpdateType enum value
	DeploymentUpdateTypeCurrentVersion = "CURRENT_VERSION"

	// DeploymentUpdateTypeMinorVersion is a DeploymentUpdateType enum value
	DeploymentUpdateTypeMinorVersion = "MINOR_VERSION"

	// DeploymentUpdateTypeMajorVersion is a DeploymentUpdateType enum value
	DeploymentUpdateTypeMajorVersion = "MAJOR_VERSION"
)

// DeploymentUpdateType_Values returns all elements of the DeploymentUpdateType enum
func DeploymentUpdateType_Values() []string {
	return []string{
		DeploymentUpdateTypeNone,
		DeploymentUpdateTypeCurrentVersion,
		DeploymentUpdateTypeMinorVersion,
		DeploymentUpdateTypeMajorVersion,
	}
}

const (
	// EnvironmentAccountConnectionRequesterAccountTypeManagementAccount is a EnvironmentAccountConnectionRequesterAccountType enum value
	EnvironmentAccountConnectionRequesterAccountTypeManagementAccount = "MANAGEMENT_ACCOUNT"

	// EnvironmentAccountConnectionRequesterAccountTypeEnvironmentAccount is a EnvironmentAccountConnectionRequesterAccountType enum value
	EnvironmentAccountConnectionRequesterAccountTypeEnvironmentAccount = "ENVIRONMENT_ACCOUNT"
)

// EnvironmentAccountConnectionRequesterAccountType_Values returns all elements of the EnvironmentAccountConnectionRequesterAccountType enum
func EnvironmentAccountConnectionRequesterAccountType_Values() []string {
	return []string{
		EnvironmentAccountConnectionRequesterAccountTypeManagementAccount,
		EnvironmentAccountConnectionRequesterAccountTypeEnvironmentAccount,
	}
}

const (
	// EnvironmentAccountConnectionStatusPending is a EnvironmentAccountConnectionStatus enum value
	EnvironmentAccountConnectionStatusPending = "PENDING"

	// EnvironmentAccountConnectionStatusConnected is a EnvironmentAccountConnectionStatus enum value
	EnvironmentAccountConnectionStatusConnected = "CONNECTED"

	// EnvironmentAccountConnectionStatusRejected is a EnvironmentAccountConnectionStatus enum value
	EnvironmentAccountConnectionStatusRejected = "REJECTED"
)

// EnvironmentAccountConnectionStatus_Values returns all elements of the EnvironmentAccountConnectionStatus enum
func EnvironmentAccountConnectionStatus_Values() []string {
	return []string{
		EnvironmentAccountConnectionStatusPending,
		EnvironmentAccountConnectionStatusConnected,
		EnvironmentAccountConnectionStatusRejected,
	}
}

const (
	// ProvisioningCustomerManaged is a Provisioning enum value
	ProvisioningCustomerManaged = "CUSTOMER_MANAGED"
)

// Provisioning_Values returns all elements of the Provisioning enum
func Provisioning_Values() []string {
	return []string{
		ProvisioningCustomerManaged,
	}
}

const (
	// ServiceStatusCreateInProgress is a ServiceStatus enum value
	ServiceStatusCreateInProgress = "CREATE_IN_PROGRESS"

	// ServiceStatusCreateFailedCleanupInProgress is a ServiceStatus enum value
	ServiceStatusCreateFailedCleanupInProgress = "CREATE_FAILED_CLEANUP_IN_PROGRESS"

	// ServiceStatusCreateFailedCleanupComplete is a ServiceStatus enum value
	ServiceStatusCreateFailedCleanupComplete = "CREATE_FAILED_CLEANUP_COMPLETE"

	// ServiceStatusCreateFailedCleanupFailed is a ServiceStatus enum value
	ServiceStatusCreateFailedCleanupFailed = "CREATE_FAILED_CLEANUP_FAILED"

	// ServiceStatusCreateFailed is a ServiceStatus enum value
	ServiceStatusCreateFailed = "CREATE_FAILED"

	// ServiceStatusActive is a ServiceStatus enum value
	ServiceStatusActive = "ACTIVE"

	// ServiceStatusDeleteInProgress is a ServiceStatus enum value
	ServiceStatusDeleteInProgress = "DELETE_IN_PROGRESS"

	// ServiceStatusDeleteFailed is a ServiceStatus enum value
	ServiceStatusDeleteFailed = "DELETE_FAILED"

	// ServiceStatusUpdateInProgress is a ServiceStatus enum value
	ServiceStatusUpdateInProgress = "UPDATE_IN_PROGRESS"

	// ServiceStatusUpdateFailedCleanupInProgress is a ServiceStatus enum value
	ServiceStatusUpdateFailedCleanupInProgress = "UPDATE_FAILED_CLEANUP_IN_PROGRESS"

	// ServiceStatusUpdateFailedCleanupComplete is a ServiceStatus enum value
	ServiceStatusUpdateFailedCleanupComplete = "UPDATE_FAILED_CLEANUP_COMPLETE"

	// ServiceStatusUpdateFailedCleanupFailed is a ServiceStatus enum value
	ServiceStatusUpdateFailedCleanupFailed = "UPDATE_FAILED_CLEANUP_FAILED"

	// ServiceStatusUpdateFailed is a ServiceStatus enum value
	ServiceStatusUpdateFailed = "UPDATE_FAILED"

	// ServiceStatusUpdateCompleteCleanupFailed is a ServiceStatus enum value
	ServiceStatusUpdateCompleteCleanupFailed = "UPDATE_COMPLETE_CLEANUP_FAILED"
)

// ServiceStatus_Values returns all elements of the ServiceStatus enum
func ServiceStatus_Values() []string {
	return []string{
		ServiceStatusCreateInProgress,
		ServiceStatusCreateFailedCleanupInProgress,
		ServiceStatusCreateFailedCleanupComplete,
		ServiceStatusCreateFailedCleanupFailed,
		ServiceStatusCreateFailed,
		ServiceStatusActive,
		ServiceStatusDeleteInProgress,
		ServiceStatusDeleteFailed,
		ServiceStatusUpdateInProgress,
		ServiceStatusUpdateFailedCleanupInProgress,
		ServiceStatusUpdateFailedCleanupComplete,
		ServiceStatusUpdateFailedCleanupFailed,
		ServiceStatusUpdateFailed,
		ServiceStatusUpdateCompleteCleanupFailed,
	}
}

const (
	// TemplateVersionStatusRegistrationInProgress is a TemplateVersionStatus enum value
	TemplateVersionStatusRegistrationInProgress = "REGISTRATION_IN_PROGRESS"

	// TemplateVersionStatusRegistrationFailed is a TemplateVersionStatus enum value
	TemplateVersionStatusRegistrationFailed = "REGISTRATION_FAILED"

	// TemplateVersionStatusDraft is a TemplateVersionStatus enum value
	TemplateVersionStatusDraft = "DRAFT"

	// TemplateVersionStatusPublished is a TemplateVersionStatus enum value
	TemplateVersionStatusPublished = "PUBLISHED"
)

// TemplateVersionStatus_Values returns all elements of the TemplateVersionStatus enum
func TemplateVersionStatus_Values() []string {
	return []string{
		TemplateVersionStatusRegistrationInProgress,
		TemplateVersionStatusRegistrationFailed,
		TemplateVersionStatusDraft,
		TemplateVersionStatusPublished,
	}
}
